#include "stdafx.h"
#include "PEDAsm.h"


OPBYTE_INFO* PEDisAsm::G_CODE_TBLS[CTBL_MAX_SIZE] =
{
	G_1BCODE_TBL, G_2BCODE_TBL, G_3B_38_TBL, G_3B_3A_TBL, G_3DNOW_TBL
};

OPBYTE_INFO PEDisAsm::G_1BCODE_TBL[CTBL_LEN_1BCODE] =
{
	/*0x0000*/ MAKE_OPWORD(OC_INFO, 0x0000),	// ADD
	/*0x0001*/ MAKE_OPWORD(OC_INFO, 0x0001),	// ADD
	/*0x0002*/ MAKE_OPWORD(OC_INFO, 0x0002),	// ADD
	/*0x0003*/ MAKE_OPWORD(OC_INFO, 0x0003),	// ADD
	/*0x0004*/ MAKE_OPWORD(OC_INFO, 0x0004),	// ADD
	/*0x0005*/ MAKE_OPWORD(OC_INFO, 0x0005),	// ADD
	/*0x0006*/ MAKE_OPWORD(OC_INFO, 0x0006),	// PUSH
	/*0x0007*/ MAKE_OPWORD(OC_INFO, 0x0007),	// POP
	/*0x0008*/ MAKE_OPWORD(OC_INFO, 0x0008),	// OR
	/*0x0009*/ MAKE_OPWORD(OC_INFO, 0x0009),	// OR
	/*0x000A*/ MAKE_OPWORD(OC_INFO, 0x000A),	// OR
	/*0x000B*/ MAKE_OPWORD(OC_INFO, 0x000B),	// OR
	/*0x000C*/ MAKE_OPWORD(OC_INFO, 0x000C),	// OR
	/*0x000D*/ MAKE_OPWORD(OC_INFO, 0x000D),	// OR
	/*0x000E*/ MAKE_OPWORD(OC_INFO, 0x000E),	// PUSH
	/*0x000F*/ MAKE_OPWORD(OC_EXT , 0x0001),	// 2-Byte Escape
	/*0x0010*/ MAKE_OPWORD(OC_INFO, 0x000F),	// ADC
	/*0x0011*/ MAKE_OPWORD(OC_INFO, 0x0010),	// ADC
	/*0x0012*/ MAKE_OPWORD(OC_INFO, 0x0011),	// ADC
	/*0x0013*/ MAKE_OPWORD(OC_INFO, 0x0012),	// ADC
	/*0x0014*/ MAKE_OPWORD(OC_INFO, 0x0013),	// ADC
	/*0x0015*/ MAKE_OPWORD(OC_INFO, 0x0014),	// ADC
	/*0x0016*/ MAKE_OPWORD(OC_INFO, 0x0015),	// PUSH
	/*0x0017*/ MAKE_OPWORD(OC_INFO, 0x0016),	// POP
	/*0x0018*/ MAKE_OPWORD(OC_INFO, 0x0017),	// SBB
	/*0x0019*/ MAKE_OPWORD(OC_INFO, 0x0018),	// SBB
	/*0x001A*/ MAKE_OPWORD(OC_INFO, 0x0019),	// SBB
	/*0x001B*/ MAKE_OPWORD(OC_INFO, 0x001A),	// SBB
	/*0x001C*/ MAKE_OPWORD(OC_INFO, 0x001B),	// SBB
	/*0x001D*/ MAKE_OPWORD(OC_INFO, 0x001C),	// SBB
	/*0x001E*/ MAKE_OPWORD(OC_INFO, 0x001D),	// PUSH
	/*0x001F*/ MAKE_OPWORD(OC_INFO, 0x001E),	// POP
	/*0x0020*/ MAKE_OPWORD(OC_INFO, 0x001F),	// AND
	/*0x0021*/ MAKE_OPWORD(OC_INFO, 0x0020),	// AND
	/*0x0022*/ MAKE_OPWORD(OC_INFO, 0x0021),	// AND
	/*0x0023*/ MAKE_OPWORD(OC_INFO, 0x0022),	// AND
	/*0x0024*/ MAKE_OPWORD(OC_INFO, 0x0023),	// AND
	/*0x0025*/ MAKE_OPWORD(OC_INFO, 0x0024),	// AND
	/*0x0026*/ MAKE_OPWORD(OC_PREFIX, 0x0006),	// SEG_ES
	/*0x0027*/ MAKE_OPWORD(OC_INFO, 0x0025),	// DAA
	/*0x0028*/ MAKE_OPWORD(OC_INFO, 0x0026),	// SUB
	/*0x0029*/ MAKE_OPWORD(OC_INFO, 0x0027),	// SUB
	/*0x002A*/ MAKE_OPWORD(OC_INFO, 0x0028),	// SUB
	/*0x002B*/ MAKE_OPWORD(OC_INFO, 0x0029),	// SUB
	/*0x002C*/ MAKE_OPWORD(OC_INFO, 0x002A),	// SUB
	/*0x002D*/ MAKE_OPWORD(OC_INFO, 0x002B),	// SUB
	/*0x002E*/ MAKE_OPWORD(OC_PREFIX, 0x0003),	// SEG_CS
	/*0x002F*/ MAKE_OPWORD(OC_INFO, 0x002C),	// DAS
	/*0x0030*/ MAKE_OPWORD(OC_INFO, 0x002D),	// XOR
	/*0x0031*/ MAKE_OPWORD(OC_INFO, 0x002E),	// XOR
	/*0x0032*/ MAKE_OPWORD(OC_INFO, 0x002F),	// XOR
	/*0x0033*/ MAKE_OPWORD(OC_INFO, 0x0030),	// XOR
	/*0x0034*/ MAKE_OPWORD(OC_INFO, 0x0031),	// XOR
	/*0x0035*/ MAKE_OPWORD(OC_INFO, 0x0032),	// XOR
	/*0x0036*/ MAKE_OPWORD(OC_PREFIX, 0x0004),	// SEG_SS
	/*0x0037*/ MAKE_OPWORD(OC_INFO, 0x0033),	// AAA
	/*0x0038*/ MAKE_OPWORD(OC_INFO, 0x0034),	// CMP
	/*0x0039*/ MAKE_OPWORD(OC_INFO, 0x0035),	// CMP
	/*0x003A*/ MAKE_OPWORD(OC_INFO, 0x0036),	// CMP
	/*0x003B*/ MAKE_OPWORD(OC_INFO, 0x0037),	// CMP
	/*0x003C*/ MAKE_OPWORD(OC_INFO, 0x0038),	// CMP
	/*0x003D*/ MAKE_OPWORD(OC_INFO, 0x0039),	// CMP
	/*0x003E*/ MAKE_OPWORD(OC_PREFIX, 0x0005),	// SEG_DS
	/*0x003F*/ MAKE_OPWORD(OC_INFO, 0x003A),	// AAS
	/*0x0040*/ MAKE_OPWORD(OC_INFO, 0x003B),	// INC
	/*0x0041*/ MAKE_OPWORD(OC_INFO, 0x003C),	// INC
	/*0x0042*/ MAKE_OPWORD(OC_INFO, 0x003D),	// INC
	/*0x0043*/ MAKE_OPWORD(OC_INFO, 0x003E),	// INC
	/*0x0044*/ MAKE_OPWORD(OC_INFO, 0x003F),	// INC
	/*0x0045*/ MAKE_OPWORD(OC_INFO, 0x0040),	// INC
	/*0x0046*/ MAKE_OPWORD(OC_INFO, 0x0041),	// INC
	/*0x0047*/ MAKE_OPWORD(OC_INFO, 0x0042),	// INC
	/*0x0048*/ MAKE_OPWORD(OC_INFO, 0x0043),	// DEC
	/*0x0049*/ MAKE_OPWORD(OC_INFO, 0x0044),	// DEC
	/*0x004A*/ MAKE_OPWORD(OC_INFO, 0x0045),	// DEC
	/*0x004B*/ MAKE_OPWORD(OC_INFO, 0x0046),	// DEC
	/*0x004C*/ MAKE_OPWORD(OC_INFO, 0x0047),	// DEC
	/*0x004D*/ MAKE_OPWORD(OC_INFO, 0x0048),	// DEC
	/*0x004E*/ MAKE_OPWORD(OC_INFO, 0x0049),	// DEC
	/*0x004F*/ MAKE_OPWORD(OC_INFO, 0x004A),	// DEC
	/*0x0050*/ MAKE_OPWORD(OC_INFO, 0x004B),	// PUSH
	/*0x0051*/ MAKE_OPWORD(OC_INFO, 0x004C),	// PUSH
	/*0x0052*/ MAKE_OPWORD(OC_INFO, 0x004D),	// PUSH
	/*0x0053*/ MAKE_OPWORD(OC_INFO, 0x004E),	// PUSH
	/*0x0054*/ MAKE_OPWORD(OC_INFO, 0x004F),	// PUSH
	/*0x0055*/ MAKE_OPWORD(OC_INFO, 0x0050),	// PUSH
	/*0x0056*/ MAKE_OPWORD(OC_INFO, 0x0051),	// PUSH
	/*0x0057*/ MAKE_OPWORD(OC_INFO, 0x0052),	// PUSH
	/*0x0058*/ MAKE_OPWORD(OC_INFO, 0x0053),	// POP
	/*0x0059*/ MAKE_OPWORD(OC_INFO, 0x0054),	// POP
	/*0x005A*/ MAKE_OPWORD(OC_INFO, 0x0055),	// POP
	/*0x005B*/ MAKE_OPWORD(OC_INFO, 0x0056),	// POP
	/*0x005C*/ MAKE_OPWORD(OC_INFO, 0x0057),	// POP
	/*0x005D*/ MAKE_OPWORD(OC_INFO, 0x0058),	// POP
	/*0x005E*/ MAKE_OPWORD(OC_INFO, 0x0059),	// POP
	/*0x005F*/ MAKE_OPWORD(OC_INFO, 0x005A),	// POP
	/*0x0060*/ MAKE_OPWORD(OC_INFO, 0x005B),	// PUSHA
	/*0x0061*/ MAKE_OPWORD(OC_INFO, 0x005C),	// POPA
	/*0x0062*/ MAKE_OPWORD(OC_INFO, 0x005D),	// BOUND
	/*0x0063*/ MAKE_OPWORD(OC_INFO, 0x005E),	// ARPL
	/*0x0064*/ MAKE_OPWORD(OC_PREFIX, 0x0007),	// SEG_FS
	/*0x0065*/ MAKE_OPWORD(OC_PREFIX, 0x0008),	// SEG_GS
	/*0x0066*/ MAKE_OPWORD(OC_PREFIX, 0x0009),	// OP_SIZE
	/*0x0067*/ MAKE_OPWORD(OC_PREFIX, 0x000A),	// AD_SIZE
	/*0x0068*/ MAKE_OPWORD(OC_INFO, 0x005F),	// PUSH
	/*0x0069*/ MAKE_OPWORD(OC_INFOEX, 0x0000),	// IMUL
	/*0x006A*/ MAKE_OPWORD(OC_INFO, 0x0060),	// PUSH
	/*0x006B*/ MAKE_OPWORD(OC_INFOEX, 0x0001),	// IMUL
	/*0x006C*/ MAKE_OPWORD(OC_INFO, 0x0061),	// INS
	/*0x006D*/ MAKE_OPWORD(OC_INFO, 0x0062),	// INS
	/*0x006E*/ MAKE_OPWORD(OC_INFO, 0x0063),	// OUTS
	/*0x006F*/ MAKE_OPWORD(OC_INFO, 0x0064),	// OUTS
	/*0x0070*/ MAKE_OPWORD(OC_INFO, 0x0065),	// JO
	/*0x0071*/ MAKE_OPWORD(OC_INFO, 0x0066),	// JNO
	/*0x0072*/ MAKE_OPWORD(OC_INFO, 0x0067),	// JB
	/*0x0073*/ MAKE_OPWORD(OC_INFO, 0x0068),	// JNB
	/*0x0074*/ MAKE_OPWORD(OC_INFO, 0x0069),	// JZ
	/*0x0075*/ MAKE_OPWORD(OC_INFO, 0x006A),	// JNZ
	/*0x0076*/ MAKE_OPWORD(OC_INFO, 0x006B),	// JBE
	/*0x0077*/ MAKE_OPWORD(OC_INFO, 0x006C),	// JNBE
	/*0x0078*/ MAKE_OPWORD(OC_INFO, 0x006D),	// JS
	/*0x0079*/ MAKE_OPWORD(OC_INFO, 0x006E),	// JNS
	/*0x007A*/ MAKE_OPWORD(OC_INFO, 0x006F),	// JP
	/*0x007B*/ MAKE_OPWORD(OC_INFO, 0x0070),	// JNP
	/*0x007C*/ MAKE_OPWORD(OC_INFO, 0x0071),	// JL
	/*0x007D*/ MAKE_OPWORD(OC_INFO, 0x0072),	// JNL
	/*0x007E*/ MAKE_OPWORD(OC_INFO, 0x0073),	// JLE
	/*0x007F*/ MAKE_OPWORD(OC_INFO, 0x0074),	// JNLE
	/*0x0080*/ MAKE_OPWORD(OC_GROUP, 0x0100),	// Group1
	/*0x0081*/ MAKE_OPWORD(OC_GROUP, 0x0108),	// Group1
	/*0x0082*/ MAKE_OPWORD(OC_GROUP, 0x0110),	// Group1
	/*0x0083*/ MAKE_OPWORD(OC_GROUP, 0x0118),	// Group1
	/*0x0084*/ MAKE_OPWORD(OC_INFO, 0x0075),	// TEST
	/*0x0085*/ MAKE_OPWORD(OC_INFO, 0x0076),	// TEST
	/*0x0086*/ MAKE_OPWORD(OC_INFO, 0x0077),	// XCHG
	/*0x0087*/ MAKE_OPWORD(OC_INFO, 0x0078),	// XCHG
	/*0x0088*/ MAKE_OPWORD(OC_INFO, 0x0079),	// MOV
	/*0x0089*/ MAKE_OPWORD(OC_INFO, 0x007A),	// MOV
	/*0x008A*/ MAKE_OPWORD(OC_INFO, 0x007B),	// MOV
	/*0x008B*/ MAKE_OPWORD(OC_INFO, 0x007C),	// MOV
	/*0x008C*/ MAKE_OPWORD(OC_INFO, 0x007D),	// MOV
	/*0x008D*/ MAKE_OPWORD(OC_INFO, 0x007E),	// LEA
	/*0x008E*/ MAKE_OPWORD(OC_INFO, 0x007F),	// MOV
	/*0x008F*/ MAKE_OPWORD(OC_GROUP, 0x0120),	// Group1A
	/*0x0090*/ MAKE_OPWORD(OC_INFO, 0x0080),	// XCHG
	/*0x0091*/ MAKE_OPWORD(OC_INFO, 0x0081),	// XCHG
	/*0x0092*/ MAKE_OPWORD(OC_INFO, 0x0082),	// XCHG
	/*0x0093*/ MAKE_OPWORD(OC_INFO, 0x0083),	// XCHG
	/*0x0094*/ MAKE_OPWORD(OC_INFO, 0x0084),	// XCHG
	/*0x0095*/ MAKE_OPWORD(OC_INFO, 0x0085),	// XCHG
	/*0x0096*/ MAKE_OPWORD(OC_INFO, 0x0086),	// XCHG
	/*0x0097*/ MAKE_OPWORD(OC_INFO, 0x0087),	// XCHG
	/*0x0098*/ MAKE_OPWORD(OC_INFOEX, 0x0002),	// CBW
	/*0x0099*/ MAKE_OPWORD(OC_INFOEX, 0x0003),	// CWD
	/*0x009A*/ MAKE_OPWORD(OC_INFO, 0x0088),	// CALL_FAR
	/*0x009B*/ MAKE_OPWORD(OC_INFO, 0x04DB),	// WAIT
	/*0x009C*/ MAKE_OPWORD(OC_INFO, 0x0089),	// PUSHF
	/*0x009D*/ MAKE_OPWORD(OC_INFO, 0x008A),	// POPF
	/*0x009E*/ MAKE_OPWORD(OC_INFO, 0x008B),	// SAHF
	/*0x009F*/ MAKE_OPWORD(OC_INFO, 0x008C),	// LAHF
	/*0x00A0*/ MAKE_OPWORD(OC_INFO, 0x008D),	// MOV
	/*0x00A1*/ MAKE_OPWORD(OC_INFO, 0x008E),	// MOV
	/*0x00A2*/ MAKE_OPWORD(OC_INFO, 0x008F),	// MOV
	/*0x00A3*/ MAKE_OPWORD(OC_INFO, 0x0090),	// MOV
	/*0x00A4*/ MAKE_OPWORD(OC_INFO, 0x0091),	// MOVS
	/*0x00A5*/ MAKE_OPWORD(OC_INFO, 0x0092),	// MOVS
	/*0x00A6*/ MAKE_OPWORD(OC_INFO, 0x0093),	// CMPS
	/*0x00A7*/ MAKE_OPWORD(OC_INFO, 0x0094),	// CMPS
	/*0x00A8*/ MAKE_OPWORD(OC_INFO, 0x0095),	// TEST
	/*0x00A9*/ MAKE_OPWORD(OC_INFO, 0x0096),	// TEST
	/*0x00AA*/ MAKE_OPWORD(OC_INFO, 0x0097),	// STOS
	/*0x00AB*/ MAKE_OPWORD(OC_INFO, 0x0098),	// STOS
	/*0x00AC*/ MAKE_OPWORD(OC_INFO, 0x0099),	// LODS
	/*0x00AD*/ MAKE_OPWORD(OC_INFO, 0x009A),	// LODS
	/*0x00AE*/ MAKE_OPWORD(OC_INFO, 0x009B),	// SCAS
	/*0x00AF*/ MAKE_OPWORD(OC_INFO, 0x009C),	// SCAS
	/*0x00B0*/ MAKE_OPWORD(OC_INFO, 0x009D),	// MOV
	/*0x00B1*/ MAKE_OPWORD(OC_INFO, 0x009E),	// MOV
	/*0x00B2*/ MAKE_OPWORD(OC_INFO, 0x009F),	// MOV
	/*0x00B3*/ MAKE_OPWORD(OC_INFO, 0x00A0),	// MOV
	/*0x00B4*/ MAKE_OPWORD(OC_INFO, 0x00A1),	// MOV
	/*0x00B5*/ MAKE_OPWORD(OC_INFO, 0x00A2),	// MOV
	/*0x00B6*/ MAKE_OPWORD(OC_INFO, 0x00A3),	// MOV
	/*0x00B7*/ MAKE_OPWORD(OC_INFO, 0x00A4),	// MOV
	/*0x00B8*/ MAKE_OPWORD(OC_INFO, 0x00A5),	// MOV
	/*0x00B9*/ MAKE_OPWORD(OC_INFO, 0x00A6),	// MOV
	/*0x00BA*/ MAKE_OPWORD(OC_INFO, 0x00A7),	// MOV
	/*0x00BB*/ MAKE_OPWORD(OC_INFO, 0x00A8),	// MOV
	/*0x00BC*/ MAKE_OPWORD(OC_INFO, 0x00A9),	// MOV
	/*0x00BD*/ MAKE_OPWORD(OC_INFO, 0x00AA),	// MOV
	/*0x00BE*/ MAKE_OPWORD(OC_INFO, 0x00AB),	// MOV
	/*0x00BF*/ MAKE_OPWORD(OC_INFO, 0x00AC),	// MOV
	/*0x00C0*/ MAKE_OPWORD(OC_GROUP, 0x0128),	// Group2
	/*0x00C1*/ MAKE_OPWORD(OC_GROUP, 0x0130),	// Group2
	/*0x00C2*/ MAKE_OPWORD(OC_INFO, 0x00AD),	// RET
	/*0x00C3*/ MAKE_OPWORD(OC_INFO, 0x00AE),	// RET
	/*0x00C4*/ MAKE_OPWORD(OC_INFO, 0x00AF),	// LES
	/*0x00C5*/ MAKE_OPWORD(OC_INFO, 0x00B0),	// LDS
	/*0x00C6*/ MAKE_OPWORD(OC_GROUP, 0x0138),	// Group11
	/*0x00C7*/ MAKE_OPWORD(OC_GROUP, 0x0140),	// Group11
	/*0x00C8*/ MAKE_OPWORD(OC_INFO, 0x00B1),	// ENTER
	/*0x00C9*/ MAKE_OPWORD(OC_INFO, 0x00B2),	// LEAVE
	/*0x00CA*/ MAKE_OPWORD(OC_INFO, 0x00B3),	// RETF
	/*0x00CB*/ MAKE_OPWORD(OC_INFO, 0x00B4),	// RETF
	/*0x00CC*/ MAKE_OPWORD(OC_INFO, 0x00B5),	// INT_3
	/*0x00CD*/ MAKE_OPWORD(OC_INFO, 0x00B6),	// INT
	/*0x00CE*/ MAKE_OPWORD(OC_INFO, 0x00B7),	// INTO
	/*0x00CF*/ MAKE_OPWORD(OC_INFO, 0x00B8),	// IRET
	/*0x00D0*/ MAKE_OPWORD(OC_GROUP, 0x0148),	// Group2
	/*0x00D1*/ MAKE_OPWORD(OC_GROUP, 0x0150),	// Group2
	/*0x00D2*/ MAKE_OPWORD(OC_GROUP, 0x0158),	// Group2
	/*0x00D3*/ MAKE_OPWORD(OC_GROUP, 0x0160),	// Group2
	/*0x00D4*/ MAKE_OPWORD(OC_INFO, 0x00B9),	// AAM
	/*0x00D5*/ MAKE_OPWORD(OC_INFO, 0x00BA),	// AAD
	/*0x00D6*/ MAKE_OPWORD(OC_INFO, 0x00BB),	// SALC
	/*0x00D7*/ MAKE_OPWORD(OC_INFO, 0x00BC),	// XLAT
	/*0x00D8*/ MAKE_OPWORD(OC_FULL, 0x0168),	// FPU_Table
	/*0x00D9*/ MAKE_OPWORD(OC_FULL, 0x01B0),	// FPU_Table
	/*0x00DA*/ MAKE_OPWORD(OC_FULL, 0x0208),	// FPU_Table
	/*0x00DB*/ MAKE_OPWORD(OC_FULL, 0x0250),	// FPU_Table
	/*0x00DC*/ MAKE_OPWORD(OC_FULL, 0x02A8),	// FPU_Table
	/*0x00DD*/ MAKE_OPWORD(OC_FULL, 0x02F0),	// FPU_Table
	/*0x00DE*/ MAKE_OPWORD(OC_FULL, 0x0348),	// FPU_Table
	/*0x00DF*/ MAKE_OPWORD(OC_FULL, 0x0390),	// FPU_Table
	/*0x00E0*/ MAKE_OPWORD(OC_INFO, 0x00BD),	// LOOPNZ
	/*0x00E1*/ MAKE_OPWORD(OC_INFO, 0x00BE),	// LOOPZ
	/*0x00E2*/ MAKE_OPWORD(OC_INFO, 0x00BF),	// LOOP
	/*0x00E3*/ MAKE_OPWORD(OC_INFOEX, 0x0004),	// JCXZ
	/*0x00E4*/ MAKE_OPWORD(OC_INFO, 0x00C0),	// IN
	/*0x00E5*/ MAKE_OPWORD(OC_INFO, 0x00C1),	// IN
	/*0x00E6*/ MAKE_OPWORD(OC_INFO, 0x00C2),	// OUT
	/*0x00E7*/ MAKE_OPWORD(OC_INFO, 0x00C3),	// OUT
	/*0x00E8*/ MAKE_OPWORD(OC_INFO, 0x00C4),	// CALL
	/*0x00E9*/ MAKE_OPWORD(OC_INFO, 0x00C5),	// JMP
	/*0x00EA*/ MAKE_OPWORD(OC_INFO, 0x00C6),	// JMP_FAR
	/*0x00EB*/ MAKE_OPWORD(OC_INFO, 0x00C7),	// JMP
	/*0x00EC*/ MAKE_OPWORD(OC_INFO, 0x00C8),	// IN
	/*0x00ED*/ MAKE_OPWORD(OC_INFO, 0x00C9),	// IN
	/*0x00EE*/ MAKE_OPWORD(OC_INFO, 0x00CA),	// OUT
	/*0x00EF*/ MAKE_OPWORD(OC_INFO, 0x00CB),	// OUT
	/*0x00F0*/ MAKE_OPWORD(OC_PREFIX, 0x0000),	// LOCK
	/*0x00F1*/ MAKE_OPWORD(OC_INFO, 0x00CC),	// INT1
	/*0x00F2*/ MAKE_OPWORD(OC_PREFIX, 0x0001),	// REPNZ
	/*0x00F3*/ MAKE_OPWORD(OC_PREFIX, 0x0002),	// REP
	/*0x00F4*/ MAKE_OPWORD(OC_INFO, 0x00CD),	// HLT
	/*0x00F5*/ MAKE_OPWORD(OC_INFO, 0x00CE),	// CMC
	/*0x00F6*/ MAKE_OPWORD(OC_GROUP, 0x03E0),	// Group3
	/*0x00F7*/ MAKE_OPWORD(OC_GROUP, 0x03E8),	// Group3
	/*0x00F8*/ MAKE_OPWORD(OC_INFO, 0x00CF),	// CLC
	/*0x00F9*/ MAKE_OPWORD(OC_INFO, 0x00D0),	// STC
	/*0x00FA*/ MAKE_OPWORD(OC_INFO, 0x00D1),	// CLI
	/*0x00FB*/ MAKE_OPWORD(OC_INFO, 0x00D2),	// STI
	/*0x00FC*/ MAKE_OPWORD(OC_INFO, 0x00D3),	// CLD
	/*0x00FD*/ MAKE_OPWORD(OC_INFO, 0x00D4),	// STD
	/*0x00FE*/ MAKE_OPWORD(OC_GROUP, 0x03F0),	// Group4
	/*0x00FF*/ MAKE_OPWORD(OC_GROUP, 0x03F8),	// Group4
	/*0x0100*/ MAKE_OPWORD(OC_INFO, 0x013A),	// ADD
	/*0x0101*/ MAKE_OPWORD(OC_INFO, 0x013B),	// OR
	/*0x0102*/ MAKE_OPWORD(OC_INFO, 0x013C),	// ADC
	/*0x0103*/ MAKE_OPWORD(OC_INFO, 0x013D),	// SBB
	/*0x0104*/ MAKE_OPWORD(OC_INFO, 0x013E),	// AND
	/*0x0105*/ MAKE_OPWORD(OC_INFO, 0x013F),	// SUB
	/*0x0106*/ MAKE_OPWORD(OC_INFO, 0x0140),	// XOR
	/*0x0107*/ MAKE_OPWORD(OC_INFO, 0x0141),	// CMP
	/*0x0108*/ MAKE_OPWORD(OC_INFO, 0x0142),	// ADD
	/*0x0109*/ MAKE_OPWORD(OC_INFO, 0x0143),	// OR
	/*0x010A*/ MAKE_OPWORD(OC_INFO, 0x0144),	// ADC
	/*0x010B*/ MAKE_OPWORD(OC_INFO, 0x0145),	// SBB
	/*0x010C*/ MAKE_OPWORD(OC_INFO, 0x0146),	// AND
	/*0x010D*/ MAKE_OPWORD(OC_INFO, 0x0147),	// SUB
	/*0x010E*/ MAKE_OPWORD(OC_INFO, 0x0148),	// XOR
	/*0x010F*/ MAKE_OPWORD(OC_INFO, 0x0149),	// CMP
	/*0x0110*/ MAKE_OPWORD(OC_INFO, 0x014A),	// ADD
	/*0x0111*/ MAKE_OPWORD(OC_INFO, 0x014B),	// OR
	/*0x0112*/ MAKE_OPWORD(OC_INFO, 0x014C),	// ADC
	/*0x0113*/ MAKE_OPWORD(OC_INFO, 0x014D),	// SBB
	/*0x0114*/ MAKE_OPWORD(OC_INFO, 0x014E),	// AND
	/*0x0115*/ MAKE_OPWORD(OC_INFO, 0x014F),	// SUB
	/*0x0116*/ MAKE_OPWORD(OC_INFO, 0x0150),	// XOR
	/*0x0117*/ MAKE_OPWORD(OC_INFO, 0x0151),	// CMP
	/*0x0118*/ MAKE_OPWORD(OC_INFO, 0x0152),	// ADD
	/*0x0119*/ MAKE_OPWORD(OC_INFO, 0x0153),	// OR
	/*0x011A*/ MAKE_OPWORD(OC_INFO, 0x0154),	// ADC
	/*0x011B*/ MAKE_OPWORD(OC_INFO, 0x0155),	// SBB
	/*0x011C*/ MAKE_OPWORD(OC_INFO, 0x0156),	// AND
	/*0x011D*/ MAKE_OPWORD(OC_INFO, 0x0157),	// SUB
	/*0x011E*/ MAKE_OPWORD(OC_INFO, 0x0158),	// XOR
	/*0x011F*/ MAKE_OPWORD(OC_INFO, 0x0159),	// CMP
	/*0x0120*/ MAKE_OPWORD(OC_INFO, 0x015A),	// POP
	/*0x0121*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0122*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0123*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0124*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0125*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0126*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0127*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0128*/ MAKE_OPWORD(OC_INFO, 0x015B),	// ROL
	/*0x0129*/ MAKE_OPWORD(OC_INFO, 0x015C),	// ROR
	/*0x012A*/ MAKE_OPWORD(OC_INFO, 0x015D),	// RCL
	/*0x012B*/ MAKE_OPWORD(OC_INFO, 0x015E),	// RCR
	/*0x012C*/ MAKE_OPWORD(OC_INFO, 0x015F),	// SHL
	/*0x012D*/ MAKE_OPWORD(OC_INFO, 0x0160),	// SHR
	/*0x012E*/ MAKE_OPWORD(OC_INFO, 0x0161),	// SAL
	/*0x012F*/ MAKE_OPWORD(OC_INFO, 0x0162),	// SAR
	/*0x0130*/ MAKE_OPWORD(OC_INFO, 0x0163),	// ROL
	/*0x0131*/ MAKE_OPWORD(OC_INFO, 0x0164),	// ROR
	/*0x0132*/ MAKE_OPWORD(OC_INFO, 0x0165),	// RCL
	/*0x0133*/ MAKE_OPWORD(OC_INFO, 0x0166),	// RCR
	/*0x0134*/ MAKE_OPWORD(OC_INFO, 0x0167),	// SHL
	/*0x0135*/ MAKE_OPWORD(OC_INFO, 0x0168),	// SHR
	/*0x0136*/ MAKE_OPWORD(OC_INFO, 0x0169),	// SAL
	/*0x0137*/ MAKE_OPWORD(OC_INFO, 0x016A),	// SAR
	/*0x0138*/ MAKE_OPWORD(OC_INFO, 0x016B),	// MOV
	/*0x0139*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0140*/ MAKE_OPWORD(OC_INFO, 0x016C),	// MOV
	/*0x0141*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0142*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0143*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0144*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0145*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0146*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0147*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0148*/ MAKE_OPWORD(OC_INFO, 0x016D),	// ROL
	/*0x0149*/ MAKE_OPWORD(OC_INFO, 0x016E),	// ROR
	/*0x014A*/ MAKE_OPWORD(OC_INFO, 0x016F),	// RCL
	/*0x014B*/ MAKE_OPWORD(OC_INFO, 0x0170),	// RCR
	/*0x014C*/ MAKE_OPWORD(OC_INFO, 0x0171),	// SHL
	/*0x014D*/ MAKE_OPWORD(OC_INFO, 0x0172),	// SHR
	/*0x014E*/ MAKE_OPWORD(OC_INFO, 0x0173),	// SAL
	/*0x014F*/ MAKE_OPWORD(OC_INFO, 0x0174),	// SAR
	/*0x0150*/ MAKE_OPWORD(OC_INFO, 0x0175),	// ROL
	/*0x0151*/ MAKE_OPWORD(OC_INFO, 0x0176),	// ROR
	/*0x0152*/ MAKE_OPWORD(OC_INFO, 0x0177),	// RCL
	/*0x0153*/ MAKE_OPWORD(OC_INFO, 0x0178),	// RCR
	/*0x0154*/ MAKE_OPWORD(OC_INFO, 0x0179),	// SHL
	/*0x0155*/ MAKE_OPWORD(OC_INFO, 0x017A),	// SHR
	/*0x0156*/ MAKE_OPWORD(OC_INFO, 0x017B),	// SAL
	/*0x0157*/ MAKE_OPWORD(OC_INFO, 0x017C),	// SAR
	/*0x0158*/ MAKE_OPWORD(OC_INFO, 0x017D),	// ROL
	/*0x0159*/ MAKE_OPWORD(OC_INFO, 0x017E),	// ROR
	/*0x015A*/ MAKE_OPWORD(OC_INFO, 0x017F),	// RCL
	/*0x015B*/ MAKE_OPWORD(OC_INFO, 0x0180),	// RCR
	/*0x015C*/ MAKE_OPWORD(OC_INFO, 0x0181),	// SHL
	/*0x015D*/ MAKE_OPWORD(OC_INFO, 0x0182),	// SHR
	/*0x015E*/ MAKE_OPWORD(OC_INFO, 0x0183),	// SAL
	/*0x015F*/ MAKE_OPWORD(OC_INFO, 0x0184),	// SAR
	/*0x0160*/ MAKE_OPWORD(OC_INFO, 0x0185),	// ROL
	/*0x0161*/ MAKE_OPWORD(OC_INFO, 0x0186),	// ROR
	/*0x0162*/ MAKE_OPWORD(OC_INFO, 0x0187),	// RCL
	/*0x0163*/ MAKE_OPWORD(OC_INFO, 0x0188),	// RCR
	/*0x0164*/ MAKE_OPWORD(OC_INFO, 0x0189),	// SHL
	/*0x0165*/ MAKE_OPWORD(OC_INFO, 0x018A),	// SHR
	/*0x0166*/ MAKE_OPWORD(OC_INFO, 0x018B),	// SAL
	/*0x0167*/ MAKE_OPWORD(OC_INFO, 0x018C),	// SAR
	/*0x0168*/ MAKE_OPWORD(OC_INFO, 0x018D),	// FADD
	/*0x0169*/ MAKE_OPWORD(OC_INFO, 0x018E),	// FMUL
	/*0x016A*/ MAKE_OPWORD(OC_INFO, 0x018F),	// FCOM
	/*0x016B*/ MAKE_OPWORD(OC_INFO, 0x0190),	// FCOMP
	/*0x016C*/ MAKE_OPWORD(OC_INFO, 0x0191),	// FSUB
	/*0x016D*/ MAKE_OPWORD(OC_INFO, 0x0192),	// FSUBR
	/*0x016E*/ MAKE_OPWORD(OC_INFO, 0x0193),	// FDIV
	/*0x016F*/ MAKE_OPWORD(OC_INFO, 0x0194),	// FDIVR
	/*0x0170*/ MAKE_OPWORD(OC_INFO, 0x0195),	// FADD
	/*0x0171*/ MAKE_OPWORD(OC_INFO, 0x0196),	// FADD
	/*0x0172*/ MAKE_OPWORD(OC_INFO, 0x0197),	// FADD
	/*0x0173*/ MAKE_OPWORD(OC_INFO, 0x0198),	// FADD
	/*0x0174*/ MAKE_OPWORD(OC_INFO, 0x0199),	// FADD
	/*0x0175*/ MAKE_OPWORD(OC_INFO, 0x019A),	// FADD
	/*0x0176*/ MAKE_OPWORD(OC_INFO, 0x019B),	// FADD
	/*0x0177*/ MAKE_OPWORD(OC_INFO, 0x019C),	// FADD
	/*0x0178*/ MAKE_OPWORD(OC_INFO, 0x019D),	// FMUL
	/*0x0179*/ MAKE_OPWORD(OC_INFO, 0x019E),	// FMUL
	/*0x017A*/ MAKE_OPWORD(OC_INFO, 0x019F),	// FMUL
	/*0x017B*/ MAKE_OPWORD(OC_INFO, 0x01A0),	// FMUL
	/*0x017C*/ MAKE_OPWORD(OC_INFO, 0x01A1),	// FMUL
	/*0x017D*/ MAKE_OPWORD(OC_INFO, 0x01A2),	// FMUL
	/*0x017E*/ MAKE_OPWORD(OC_INFO, 0x01A3),	// FMUL
	/*0x017F*/ MAKE_OPWORD(OC_INFO, 0x01A4),	// FMUL
	/*0x0180*/ MAKE_OPWORD(OC_INFO, 0x01A5),	// FCOM
	/*0x0181*/ MAKE_OPWORD(OC_INFO, 0x01A6),	// FCOM
	/*0x0182*/ MAKE_OPWORD(OC_INFO, 0x01A7),	// FCOM
	/*0x0183*/ MAKE_OPWORD(OC_INFO, 0x01A8),	// FCOM
	/*0x0184*/ MAKE_OPWORD(OC_INFO, 0x01A9),	// FCOM
	/*0x0185*/ MAKE_OPWORD(OC_INFO, 0x01AA),	// FCOM
	/*0x0186*/ MAKE_OPWORD(OC_INFO, 0x01AB),	// FCOM
	/*0x0187*/ MAKE_OPWORD(OC_INFO, 0x01AC),	// FCOM
	/*0x0188*/ MAKE_OPWORD(OC_INFO, 0x01AD),	// FCOMP
	/*0x0189*/ MAKE_OPWORD(OC_INFO, 0x01AE),	// FCOMP
	/*0x018A*/ MAKE_OPWORD(OC_INFO, 0x01AF),	// FCOMP
	/*0x018B*/ MAKE_OPWORD(OC_INFO, 0x01B0),	// FCOMP
	/*0x018C*/ MAKE_OPWORD(OC_INFO, 0x01B1),	// FCOMP
	/*0x018D*/ MAKE_OPWORD(OC_INFO, 0x01B2),	// FCOMP
	/*0x018E*/ MAKE_OPWORD(OC_INFO, 0x01B3),	// FCOMP
	/*0x018F*/ MAKE_OPWORD(OC_INFO, 0x01B4),	// FCOMP
	/*0x0190*/ MAKE_OPWORD(OC_INFO, 0x01B5),	// FSUB
	/*0x0191*/ MAKE_OPWORD(OC_INFO, 0x01B6),	// FSUB
	/*0x0192*/ MAKE_OPWORD(OC_INFO, 0x01B7),	// FSUB
	/*0x0193*/ MAKE_OPWORD(OC_INFO, 0x01B8),	// FSUB
	/*0x0194*/ MAKE_OPWORD(OC_INFO, 0x01B9),	// FSUB
	/*0x0195*/ MAKE_OPWORD(OC_INFO, 0x01BA),	// FSUB
	/*0x0196*/ MAKE_OPWORD(OC_INFO, 0x01BB),	// FSUB
	/*0x0197*/ MAKE_OPWORD(OC_INFO, 0x01BC),	// FSUB
	/*0x0198*/ MAKE_OPWORD(OC_INFO, 0x01BD),	// FSUBR
	/*0x0199*/ MAKE_OPWORD(OC_INFO, 0x01BE),	// FSUBR
	/*0x019A*/ MAKE_OPWORD(OC_INFO, 0x01BF),	// FSUBR
	/*0x019B*/ MAKE_OPWORD(OC_INFO, 0x01C0),	// FSUBR
	/*0x019C*/ MAKE_OPWORD(OC_INFO, 0x01C1),	// FSUBR
	/*0x019D*/ MAKE_OPWORD(OC_INFO, 0x01C2),	// FSUBR
	/*0x019E*/ MAKE_OPWORD(OC_INFO, 0x01C3),	// FSUBR
	/*0x019F*/ MAKE_OPWORD(OC_INFO, 0x01C4),	// FSUBR
	/*0x01A0*/ MAKE_OPWORD(OC_INFO, 0x01C5),	// FDIV
	/*0x01A1*/ MAKE_OPWORD(OC_INFO, 0x01C6),	// FDIV
	/*0x01A2*/ MAKE_OPWORD(OC_INFO, 0x01C7),	// FDIV
	/*0x01A3*/ MAKE_OPWORD(OC_INFO, 0x01C8),	// FDIV
	/*0x01A4*/ MAKE_OPWORD(OC_INFO, 0x01C9),	// FDIV
	/*0x01A5*/ MAKE_OPWORD(OC_INFO, 0x01CA),	// FDIV
	/*0x01A6*/ MAKE_OPWORD(OC_INFO, 0x01CB),	// FDIV
	/*0x01A7*/ MAKE_OPWORD(OC_INFO, 0x01CC),	// FDIV
	/*0x01A8*/ MAKE_OPWORD(OC_INFO, 0x01CD),	// FDIVR
	/*0x01A9*/ MAKE_OPWORD(OC_INFO, 0x01CE),	// FDIVR
	/*0x01AA*/ MAKE_OPWORD(OC_INFO, 0x01CF),	// FDIVR
	/*0x01AB*/ MAKE_OPWORD(OC_INFO, 0x01D0),	// FDIVR
	/*0x01AC*/ MAKE_OPWORD(OC_INFO, 0x01D1),	// FDIVR
	/*0x01AD*/ MAKE_OPWORD(OC_INFO, 0x01D2),	// FDIVR
	/*0x01AE*/ MAKE_OPWORD(OC_INFO, 0x01D3),	// FDIVR
	/*0x01AF*/ MAKE_OPWORD(OC_INFO, 0x01D4),	// FDIVR
	/*0x01B0*/ MAKE_OPWORD(OC_INFO, 0x01D5),	// FLD
	/*0x01B1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B2*/ MAKE_OPWORD(OC_INFO, 0x01D6),	// FST
	/*0x01B3*/ MAKE_OPWORD(OC_INFO, 0x01D7),	// FSTP
	/*0x01B4*/ MAKE_OPWORD(OC_INFO, 0x01D8),	// FLDENV
	/*0x01B5*/ MAKE_OPWORD(OC_INFO, 0x01D9),	// FLDCW
	/*0x01B6*/ MAKE_OPWORD(OC_WITHPF, 0x01F8),	// 
	/*0x01B7*/ MAKE_OPWORD(OC_WITHPF, 0x0200),	// 
	/*0x01B8*/ MAKE_OPWORD(OC_INFO, 0x01DA),	// FLD
	/*0x01B9*/ MAKE_OPWORD(OC_INFO, 0x01DB),	// FLD
	/*0x01BA*/ MAKE_OPWORD(OC_INFO, 0x01DC),	// FLD
	/*0x01BB*/ MAKE_OPWORD(OC_INFO, 0x01DD),	// FLD
	/*0x01BC*/ MAKE_OPWORD(OC_INFO, 0x01DE),	// FLD
	/*0x01BD*/ MAKE_OPWORD(OC_INFO, 0x01DF),	// FLD
	/*0x01BE*/ MAKE_OPWORD(OC_INFO, 0x01E0),	// FLD
	/*0x01BF*/ MAKE_OPWORD(OC_INFO, 0x01E1),	// FLD
	/*0x01C0*/ MAKE_OPWORD(OC_INFO, 0x01E2),	// FXCH
	/*0x01C1*/ MAKE_OPWORD(OC_INFO, 0x01E3),	// FXCH
	/*0x01C2*/ MAKE_OPWORD(OC_INFO, 0x01E4),	// FXCH
	/*0x01C3*/ MAKE_OPWORD(OC_INFO, 0x01E5),	// FXCH
	/*0x01C4*/ MAKE_OPWORD(OC_INFO, 0x01E6),	// FXCH
	/*0x01C5*/ MAKE_OPWORD(OC_INFO, 0x01E7),	// FXCH
	/*0x01C6*/ MAKE_OPWORD(OC_INFO, 0x01E8),	// FXCH
	/*0x01C7*/ MAKE_OPWORD(OC_INFO, 0x01E9),	// FXCH
	/*0x01C8*/ MAKE_OPWORD(OC_INFO, 0x01EA),	// FNOP
	/*0x01C9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D8*/ MAKE_OPWORD(OC_INFO, 0x01EB),	// FCHS
	/*0x01D9*/ MAKE_OPWORD(OC_INFO, 0x01EC),	// FABS
	/*0x01DA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01DB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01DC*/ MAKE_OPWORD(OC_INFO, 0x01ED),	// FTST
	/*0x01DD*/ MAKE_OPWORD(OC_INFO, 0x01EE),	// FXAM
	/*0x01DE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01DF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E0*/ MAKE_OPWORD(OC_INFO, 0x01EF),	// FLD1
	/*0x01E1*/ MAKE_OPWORD(OC_INFO, 0x01F0),	// FLDL2T
	/*0x01E2*/ MAKE_OPWORD(OC_INFO, 0x01F1),	// FLDL2E
	/*0x01E3*/ MAKE_OPWORD(OC_INFO, 0x01F2),	// FLDPI
	/*0x01E4*/ MAKE_OPWORD(OC_INFO, 0x01F3),	// FLDLG2
	/*0x01E5*/ MAKE_OPWORD(OC_INFO, 0x01F4),	// FLDLN2
	/*0x01E6*/ MAKE_OPWORD(OC_INFO, 0x01F5),	// FLDZ
	/*0x01E7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E8*/ MAKE_OPWORD(OC_INFO, 0x01F6),	// F2XM1
	/*0x01E9*/ MAKE_OPWORD(OC_INFO, 0x01F7),	// FYL2X
	/*0x01EA*/ MAKE_OPWORD(OC_INFO, 0x01F8),	// FPTAN
	/*0x01EB*/ MAKE_OPWORD(OC_INFO, 0x01F9),	// FPATAN
	/*0x01EC*/ MAKE_OPWORD(OC_INFO, 0x01FA),	// FXTRACT
	/*0x01ED*/ MAKE_OPWORD(OC_INFO, 0x01FB),	// FPREM1
	/*0x01EE*/ MAKE_OPWORD(OC_INFO, 0x01FC),	// FDECSTP
	/*0x01EF*/ MAKE_OPWORD(OC_INFO, 0x01FD),	// FINCSTP
	/*0x01F0*/ MAKE_OPWORD(OC_INFO, 0x01FE),	// FPREM
	/*0x01F1*/ MAKE_OPWORD(OC_INFO, 0x01FF),	// FYL2XP1
	/*0x01F2*/ MAKE_OPWORD(OC_INFO, 0x0200),	// FSQRT
	/*0x01F3*/ MAKE_OPWORD(OC_INFO, 0x0201),	// FSINCOS
	/*0x01F4*/ MAKE_OPWORD(OC_INFO, 0x0202),	// FRNDINT
	/*0x01F5*/ MAKE_OPWORD(OC_INFO, 0x0203),	// FSCALE
	/*0x01F6*/ MAKE_OPWORD(OC_INFO, 0x0204),	// FSIN
	/*0x01F7*/ MAKE_OPWORD(OC_INFO, 0x0205),	// FCOS
	/*0x01F8*/ MAKE_OPWORD(OC_INFO, 0x046C),	// FNSTENV
	/*0x01F9*/ MAKE_OPWORD(OC_INFO, 0x046D),	// FSTENV
	/*0x01FA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0200*/ MAKE_OPWORD(OC_INFO, 0x046E),	// FNSTCW
	/*0x0201*/ MAKE_OPWORD(OC_INFO, 0x046F),	// FSTCW
	/*0x0202*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0203*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0204*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0205*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0206*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0207*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0208*/ MAKE_OPWORD(OC_INFO, 0x0206),	// FIADD
	/*0x0209*/ MAKE_OPWORD(OC_INFO, 0x0207),	// FIMUL
	/*0x020A*/ MAKE_OPWORD(OC_INFO, 0x0208),	// FICOM
	/*0x020B*/ MAKE_OPWORD(OC_INFO, 0x0209),	// FICOMP
	/*0x020C*/ MAKE_OPWORD(OC_INFO, 0x020A),	// FISUB
	/*0x020D*/ MAKE_OPWORD(OC_INFO, 0x020B),	// FISUBR
	/*0x020E*/ MAKE_OPWORD(OC_INFO, 0x020C),	// FIDIV
	/*0x020F*/ MAKE_OPWORD(OC_INFO, 0x020D),	// FIDIVR
	/*0x0210*/ MAKE_OPWORD(OC_INFO, 0x020E),	// FCMOVB
	/*0x0211*/ MAKE_OPWORD(OC_INFO, 0x020F),	// FCMOVB
	/*0x0212*/ MAKE_OPWORD(OC_INFO, 0x0210),	// FCMOVB
	/*0x0213*/ MAKE_OPWORD(OC_INFO, 0x0211),	// FCMOVB
	/*0x0214*/ MAKE_OPWORD(OC_INFO, 0x0212),	// FCMOVB
	/*0x0215*/ MAKE_OPWORD(OC_INFO, 0x0213),	// FCMOVB
	/*0x0216*/ MAKE_OPWORD(OC_INFO, 0x0214),	// FCMOVB
	/*0x0217*/ MAKE_OPWORD(OC_INFO, 0x0215),	// FCMOVB
	/*0x0218*/ MAKE_OPWORD(OC_INFO, 0x0216),	// FCMOVE
	/*0x0219*/ MAKE_OPWORD(OC_INFO, 0x0217),	// FCMOVE
	/*0x021A*/ MAKE_OPWORD(OC_INFO, 0x0218),	// FCMOVE
	/*0x021B*/ MAKE_OPWORD(OC_INFO, 0x0219),	// FCMOVE
	/*0x021C*/ MAKE_OPWORD(OC_INFO, 0x021A),	// FCMOVE
	/*0x021D*/ MAKE_OPWORD(OC_INFO, 0x021B),	// FCMOVE
	/*0x021E*/ MAKE_OPWORD(OC_INFO, 0x021C),	// FCMOVE
	/*0x021F*/ MAKE_OPWORD(OC_INFO, 0x021D),	// FCMOVE
	/*0x0220*/ MAKE_OPWORD(OC_INFO, 0x021E),	// FCMOVBE
	/*0x0221*/ MAKE_OPWORD(OC_INFO, 0x021F),	// FCMOVBE
	/*0x0222*/ MAKE_OPWORD(OC_INFO, 0x0220),	// FCMOVBE
	/*0x0223*/ MAKE_OPWORD(OC_INFO, 0x0221),	// FCMOVBE
	/*0x0224*/ MAKE_OPWORD(OC_INFO, 0x0222),	// FCMOVBE
	/*0x0225*/ MAKE_OPWORD(OC_INFO, 0x0223),	// FCMOVBE
	/*0x0226*/ MAKE_OPWORD(OC_INFO, 0x0224),	// FCMOVBE
	/*0x0227*/ MAKE_OPWORD(OC_INFO, 0x0225),	// FCMOVBE
	/*0x0228*/ MAKE_OPWORD(OC_INFO, 0x0226),	// FCMOVU
	/*0x0229*/ MAKE_OPWORD(OC_INFO, 0x0227),	// FCMOVU
	/*0x022A*/ MAKE_OPWORD(OC_INFO, 0x0228),	// FCMOVU
	/*0x022B*/ MAKE_OPWORD(OC_INFO, 0x0229),	// FCMOVU
	/*0x022C*/ MAKE_OPWORD(OC_INFO, 0x022A),	// FCMOVU
	/*0x022D*/ MAKE_OPWORD(OC_INFO, 0x022B),	// FCMOVU
	/*0x022E*/ MAKE_OPWORD(OC_INFO, 0x022C),	// FCMOVU
	/*0x022F*/ MAKE_OPWORD(OC_INFO, 0x022D),	// FCMOVU
	/*0x0230*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0231*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0232*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0233*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0234*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0235*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0236*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0237*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0238*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0239*/ MAKE_OPWORD(OC_INFO, 0x022E),	// FUCOMPP
	/*0x023A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x023B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x023C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x023D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x023E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x023F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0240*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0241*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0242*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0243*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0244*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0245*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0246*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0247*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0248*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0249*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x024A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x024B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x024C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x024D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x024E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x024F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0250*/ MAKE_OPWORD(OC_INFO, 0x022F),	// FILD
	/*0x0251*/ MAKE_OPWORD(OC_INFO, 0x0230),	// FISTTP
	/*0x0252*/ MAKE_OPWORD(OC_INFO, 0x0231),	// FIST
	/*0x0253*/ MAKE_OPWORD(OC_INFO, 0x0232),	// FISTP
	/*0x0254*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0255*/ MAKE_OPWORD(OC_INFO, 0x0233),	// FLD
	/*0x0256*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0257*/ MAKE_OPWORD(OC_INFO, 0x0234),	// FSTP
	/*0x0258*/ MAKE_OPWORD(OC_INFO, 0x0235),	// FCMOVNB
	/*0x0259*/ MAKE_OPWORD(OC_INFO, 0x0236),	// FCMOVNB
	/*0x025A*/ MAKE_OPWORD(OC_INFO, 0x0237),	// FCMOVNB
	/*0x025B*/ MAKE_OPWORD(OC_INFO, 0x0238),	// FCMOVNB
	/*0x025C*/ MAKE_OPWORD(OC_INFO, 0x0239),	// FCMOVNB
	/*0x025D*/ MAKE_OPWORD(OC_INFO, 0x023A),	// FCMOVNB
	/*0x025E*/ MAKE_OPWORD(OC_INFO, 0x023B),	// FCMOVNB
	/*0x025F*/ MAKE_OPWORD(OC_INFO, 0x023C),	// FCMOVNB
	/*0x0260*/ MAKE_OPWORD(OC_INFO, 0x023D),	// FCMOVNE
	/*0x0261*/ MAKE_OPWORD(OC_INFO, 0x023E),	// FCMOVNE
	/*0x0262*/ MAKE_OPWORD(OC_INFO, 0x023F),	// FCMOVNE
	/*0x0263*/ MAKE_OPWORD(OC_INFO, 0x0240),	// FCMOVNE
	/*0x0264*/ MAKE_OPWORD(OC_INFO, 0x0241),	// FCMOVNE
	/*0x0265*/ MAKE_OPWORD(OC_INFO, 0x0242),	// FCMOVNE
	/*0x0266*/ MAKE_OPWORD(OC_INFO, 0x0243),	// FCMOVNE
	/*0x0267*/ MAKE_OPWORD(OC_INFO, 0x0244),	// FCMOVNE
	/*0x0268*/ MAKE_OPWORD(OC_INFO, 0x0245),	// FCMOVNBE
	/*0x0269*/ MAKE_OPWORD(OC_INFO, 0x0246),	// FCMOVNBE
	/*0x026A*/ MAKE_OPWORD(OC_INFO, 0x0247),	// FCMOVNBE
	/*0x026B*/ MAKE_OPWORD(OC_INFO, 0x0248),	// FCMOVNBE
	/*0x026C*/ MAKE_OPWORD(OC_INFO, 0x0249),	// FCMOVNBE
	/*0x026D*/ MAKE_OPWORD(OC_INFO, 0x024A),	// FCMOVNBE
	/*0x026E*/ MAKE_OPWORD(OC_INFO, 0x024B),	// FCMOVNBE
	/*0x026F*/ MAKE_OPWORD(OC_INFO, 0x024C),	// FCMOVNBE
	/*0x0270*/ MAKE_OPWORD(OC_INFO, 0x024D),	// FCMOVNU
	/*0x0271*/ MAKE_OPWORD(OC_INFO, 0x024E),	// FCMOVNU
	/*0x0272*/ MAKE_OPWORD(OC_INFO, 0x024F),	// FCMOVNU
	/*0x0273*/ MAKE_OPWORD(OC_INFO, 0x0250),	// FCMOVNU
	/*0x0274*/ MAKE_OPWORD(OC_INFO, 0x0251),	// FCMOVNU
	/*0x0275*/ MAKE_OPWORD(OC_INFO, 0x0252),	// FCMOVNU
	/*0x0276*/ MAKE_OPWORD(OC_INFO, 0x0253),	// FCMOVNU
	/*0x0277*/ MAKE_OPWORD(OC_INFO, 0x0254),	// FCMOVNU
	/*0x0278*/ MAKE_OPWORD(OC_INFO, 0x0255),	// FENI
	/*0x0279*/ MAKE_OPWORD(OC_INFO, 0x0256),	// FEDISI
	/*0x027A*/ MAKE_OPWORD(OC_WITHPF, 0x0298),	// 
	/*0x027B*/ MAKE_OPWORD(OC_WITHPF, 0x02A0),	// 
	/*0x027C*/ MAKE_OPWORD(OC_INFO, 0x0257),	// FSETPM
	/*0x027D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x027E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x027F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0280*/ MAKE_OPWORD(OC_INFO, 0x0258),	// FUCOMI
	/*0x0281*/ MAKE_OPWORD(OC_INFO, 0x0259),	// FUCOMI
	/*0x0282*/ MAKE_OPWORD(OC_INFO, 0x025A),	// FUCOMI
	/*0x0283*/ MAKE_OPWORD(OC_INFO, 0x025B),	// FUCOMI
	/*0x0284*/ MAKE_OPWORD(OC_INFO, 0x025C),	// FUCOMI
	/*0x0285*/ MAKE_OPWORD(OC_INFO, 0x025D),	// FUCOMI
	/*0x0286*/ MAKE_OPWORD(OC_INFO, 0x025E),	// FUCOMI
	/*0x0287*/ MAKE_OPWORD(OC_INFO, 0x025F),	// FUCOMI
	/*0x0288*/ MAKE_OPWORD(OC_INFO, 0x0260),	// FCOMI
	/*0x0289*/ MAKE_OPWORD(OC_INFO, 0x0261),	// FCOMI
	/*0x028A*/ MAKE_OPWORD(OC_INFO, 0x0262),	// FCOMI
	/*0x028B*/ MAKE_OPWORD(OC_INFO, 0x0263),	// FCOMI
	/*0x028C*/ MAKE_OPWORD(OC_INFO, 0x0264),	// FCOMI
	/*0x028D*/ MAKE_OPWORD(OC_INFO, 0x0265),	// FCOMI
	/*0x028E*/ MAKE_OPWORD(OC_INFO, 0x0266),	// FCOMI
	/*0x028F*/ MAKE_OPWORD(OC_INFO, 0x0267),	// FCOMI
	/*0x0290*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0291*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0292*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0293*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0294*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0295*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0296*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0297*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0298*/ MAKE_OPWORD(OC_INFO, 0x0470),	// FNCLEX
	/*0x0299*/ MAKE_OPWORD(OC_INFO, 0x0471),	// FCLEX
	/*0x029A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A0*/ MAKE_OPWORD(OC_INFO, 0x0472),	// FNINIT
	/*0x02A1*/ MAKE_OPWORD(OC_INFO, 0x0473),	// FINIT
	/*0x02A2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A8*/ MAKE_OPWORD(OC_INFO, 0x0268),	// FADD
	/*0x02A9*/ MAKE_OPWORD(OC_INFO, 0x0269),	// FMUL
	/*0x02AA*/ MAKE_OPWORD(OC_INFO, 0x026A),	// FCOM
	/*0x02AB*/ MAKE_OPWORD(OC_INFO, 0x026B),	// FCOMP
	/*0x02AC*/ MAKE_OPWORD(OC_INFO, 0x026C),	// FSUB
	/*0x02AD*/ MAKE_OPWORD(OC_INFO, 0x026D),	// FSUBR
	/*0x02AE*/ MAKE_OPWORD(OC_INFO, 0x026E),	// FDIV
	/*0x02AF*/ MAKE_OPWORD(OC_INFO, 0x026F),	// FDIVR
	/*0x02B0*/ MAKE_OPWORD(OC_INFO, 0x0270),	// FADD
	/*0x02B1*/ MAKE_OPWORD(OC_INFO, 0x0271),	// FADD
	/*0x02B2*/ MAKE_OPWORD(OC_INFO, 0x0272),	// FADD
	/*0x02B3*/ MAKE_OPWORD(OC_INFO, 0x0273),	// FADD
	/*0x02B4*/ MAKE_OPWORD(OC_INFO, 0x0274),	// FADD
	/*0x02B5*/ MAKE_OPWORD(OC_INFO, 0x0275),	// FADD
	/*0x02B6*/ MAKE_OPWORD(OC_INFO, 0x0276),	// FADD
	/*0x02B7*/ MAKE_OPWORD(OC_INFO, 0x0277),	// FADD
	/*0x02B8*/ MAKE_OPWORD(OC_INFO, 0x0278),	// FMUL
	/*0x02B9*/ MAKE_OPWORD(OC_INFO, 0x0279),	// FMUL
	/*0x02BA*/ MAKE_OPWORD(OC_INFO, 0x027A),	// FMUL
	/*0x02BB*/ MAKE_OPWORD(OC_INFO, 0x027B),	// FMUL
	/*0x02BC*/ MAKE_OPWORD(OC_INFO, 0x027C),	// FMUL
	/*0x02BD*/ MAKE_OPWORD(OC_INFO, 0x027D),	// FMUL
	/*0x02BE*/ MAKE_OPWORD(OC_INFO, 0x027E),	// FMUL
	/*0x02BF*/ MAKE_OPWORD(OC_INFO, 0x027F),	// FMUL
	/*0x02C0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D0*/ MAKE_OPWORD(OC_INFO, 0x0280),	// FSUBR
	/*0x02D1*/ MAKE_OPWORD(OC_INFO, 0x0281),	// FSUBR
	/*0x02D2*/ MAKE_OPWORD(OC_INFO, 0x0282),	// FSUBR
	/*0x02D3*/ MAKE_OPWORD(OC_INFO, 0x0283),	// FSUBR
	/*0x02D4*/ MAKE_OPWORD(OC_INFO, 0x0284),	// FSUBR
	/*0x02D5*/ MAKE_OPWORD(OC_INFO, 0x0285),	// FSUBR
	/*0x02D6*/ MAKE_OPWORD(OC_INFO, 0x0286),	// FSUBR
	/*0x02D7*/ MAKE_OPWORD(OC_INFO, 0x0287),	// FSUBR
	/*0x02D8*/ MAKE_OPWORD(OC_INFO, 0x0288),	// FSUB
	/*0x02D9*/ MAKE_OPWORD(OC_INFO, 0x0289),	// FSUB
	/*0x02DA*/ MAKE_OPWORD(OC_INFO, 0x028A),	// FSUB
	/*0x02DB*/ MAKE_OPWORD(OC_INFO, 0x028B),	// FSUB
	/*0x02DC*/ MAKE_OPWORD(OC_INFO, 0x028C),	// FSUB
	/*0x02DD*/ MAKE_OPWORD(OC_INFO, 0x028D),	// FSUB
	/*0x02DE*/ MAKE_OPWORD(OC_INFO, 0x028E),	// FSUB
	/*0x02DF*/ MAKE_OPWORD(OC_INFO, 0x028F),	// FSUB
	/*0x02E0*/ MAKE_OPWORD(OC_INFO, 0x0290),	// FDIVR
	/*0x02E1*/ MAKE_OPWORD(OC_INFO, 0x0291),	// FDIVR
	/*0x02E2*/ MAKE_OPWORD(OC_INFO, 0x0292),	// FDIVR
	/*0x02E3*/ MAKE_OPWORD(OC_INFO, 0x0293),	// FDIVR
	/*0x02E4*/ MAKE_OPWORD(OC_INFO, 0x0294),	// FDIVR
	/*0x02E5*/ MAKE_OPWORD(OC_INFO, 0x0295),	// FDIVR
	/*0x02E6*/ MAKE_OPWORD(OC_INFO, 0x0296),	// FDIVR
	/*0x02E7*/ MAKE_OPWORD(OC_INFO, 0x0297),	// FDIVR
	/*0x02E8*/ MAKE_OPWORD(OC_INFO, 0x0298),	// FDIV
	/*0x02E9*/ MAKE_OPWORD(OC_INFO, 0x0299),	// FDIV
	/*0x02EA*/ MAKE_OPWORD(OC_INFO, 0x029A),	// FDIV
	/*0x02EB*/ MAKE_OPWORD(OC_INFO, 0x029B),	// FDIV
	/*0x02EC*/ MAKE_OPWORD(OC_INFO, 0x029C),	// FDIV
	/*0x02ED*/ MAKE_OPWORD(OC_INFO, 0x029D),	// FDIV
	/*0x02EE*/ MAKE_OPWORD(OC_INFO, 0x029E),	// FDIV
	/*0x02EF*/ MAKE_OPWORD(OC_INFO, 0x029F),	// FDIV
	/*0x02F0*/ MAKE_OPWORD(OC_INFO, 0x02A0),	// FLD
	/*0x02F1*/ MAKE_OPWORD(OC_INFO, 0x02A1),	// FISTTP
	/*0x02F2*/ MAKE_OPWORD(OC_INFO, 0x02A2),	// FST
	/*0x02F3*/ MAKE_OPWORD(OC_INFO, 0x02A3),	// FSTP
	/*0x02F4*/ MAKE_OPWORD(OC_INFO, 0x02A4),	// FRSTOR
	/*0x02F5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F6*/ MAKE_OPWORD(OC_WITHPF, 0x0338),	// 
	/*0x02F7*/ MAKE_OPWORD(OC_WITHPF, 0x0340),	// 
	/*0x02F8*/ MAKE_OPWORD(OC_INFO, 0x02A5),	// FFREE
	/*0x02F9*/ MAKE_OPWORD(OC_INFO, 0x02A6),	// FFREE
	/*0x02FA*/ MAKE_OPWORD(OC_INFO, 0x02A7),	// FFREE
	/*0x02FB*/ MAKE_OPWORD(OC_INFO, 0x02A8),	// FFREE
	/*0x02FC*/ MAKE_OPWORD(OC_INFO, 0x02A9),	// FFREE
	/*0x02FD*/ MAKE_OPWORD(OC_INFO, 0x02AA),	// FFREE
	/*0x02FE*/ MAKE_OPWORD(OC_INFO, 0x02AB),	// FFREE
	/*0x02FF*/ MAKE_OPWORD(OC_INFO, 0x02AC),	// FFREE
	/*0x0300*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0301*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0302*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0303*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0304*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0305*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0306*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0307*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0308*/ MAKE_OPWORD(OC_INFO, 0x02AD),	// FST
	/*0x0309*/ MAKE_OPWORD(OC_INFO, 0x02AE),	// FST
	/*0x030A*/ MAKE_OPWORD(OC_INFO, 0x02AF),	// FST
	/*0x030B*/ MAKE_OPWORD(OC_INFO, 0x02B0),	// FST
	/*0x030C*/ MAKE_OPWORD(OC_INFO, 0x02B1),	// FST
	/*0x030D*/ MAKE_OPWORD(OC_INFO, 0x02B2),	// FST
	/*0x030E*/ MAKE_OPWORD(OC_INFO, 0x02B3),	// FST
	/*0x030F*/ MAKE_OPWORD(OC_INFO, 0x02B4),	// FST
	/*0x0310*/ MAKE_OPWORD(OC_INFO, 0x02B5),	// FSTP
	/*0x0311*/ MAKE_OPWORD(OC_INFO, 0x02B6),	// FSTP
	/*0x0312*/ MAKE_OPWORD(OC_INFO, 0x02B7),	// FSTP
	/*0x0313*/ MAKE_OPWORD(OC_INFO, 0x02B8),	// FSTP
	/*0x0314*/ MAKE_OPWORD(OC_INFO, 0x02B9),	// FSTP
	/*0x0315*/ MAKE_OPWORD(OC_INFO, 0x02BA),	// FSTP
	/*0x0316*/ MAKE_OPWORD(OC_INFO, 0x02BB),	// FSTP
	/*0x0317*/ MAKE_OPWORD(OC_INFO, 0x02BC),	// FSTP
	/*0x0318*/ MAKE_OPWORD(OC_INFO, 0x02BD),	// FUCOM
	/*0x0319*/ MAKE_OPWORD(OC_INFO, 0x02BE),	// FUCOM
	/*0x031A*/ MAKE_OPWORD(OC_INFO, 0x02BF),	// FUCOM
	/*0x031B*/ MAKE_OPWORD(OC_INFO, 0x02C0),	// FUCOM
	/*0x031C*/ MAKE_OPWORD(OC_INFO, 0x02C1),	// FUCOM
	/*0x031D*/ MAKE_OPWORD(OC_INFO, 0x02C2),	// FUCOM
	/*0x031E*/ MAKE_OPWORD(OC_INFO, 0x02C3),	// FUCOM
	/*0x031F*/ MAKE_OPWORD(OC_INFO, 0x02C4),	// FUCOM
	/*0x0320*/ MAKE_OPWORD(OC_INFO, 0x02C5),	// FUCOMP
	/*0x0321*/ MAKE_OPWORD(OC_INFO, 0x02C6),	// FUCOMP
	/*0x0322*/ MAKE_OPWORD(OC_INFO, 0x02C7),	// FUCOMP
	/*0x0323*/ MAKE_OPWORD(OC_INFO, 0x02C8),	// FUCOMP
	/*0x0324*/ MAKE_OPWORD(OC_INFO, 0x02C9),	// FUCOMP
	/*0x0325*/ MAKE_OPWORD(OC_INFO, 0x02CA),	// FUCOMP
	/*0x0326*/ MAKE_OPWORD(OC_INFO, 0x02CB),	// FUCOMP
	/*0x0327*/ MAKE_OPWORD(OC_INFO, 0x02CC),	// FUCOMP
	/*0x0328*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0329*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0330*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0331*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0332*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0333*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0334*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0335*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0336*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0337*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0338*/ MAKE_OPWORD(OC_INFO, 0x0474),	// FNSAVE
	/*0x0339*/ MAKE_OPWORD(OC_INFO, 0x0475),	// FSAVE
	/*0x033A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x033B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x033C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x033D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x033E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x033F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0340*/ MAKE_OPWORD(OC_INFO, 0x0476),	// FNSTSW
	/*0x0341*/ MAKE_OPWORD(OC_INFO, 0x0477),	// FSTSW
	/*0x0342*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0343*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0344*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0345*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0346*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0347*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0348*/ MAKE_OPWORD(OC_INFO, 0x02CD),	// FIADD
	/*0x0349*/ MAKE_OPWORD(OC_INFO, 0x02CE),	// FIMUL
	/*0x034A*/ MAKE_OPWORD(OC_INFO, 0x02CF),	// FICOM
	/*0x034B*/ MAKE_OPWORD(OC_INFO, 0x02D0),	// FICOMP
	/*0x034C*/ MAKE_OPWORD(OC_INFO, 0x02D1),	// FISUB
	/*0x034D*/ MAKE_OPWORD(OC_INFO, 0x02D2),	// FISUBR
	/*0x034E*/ MAKE_OPWORD(OC_INFO, 0x02D3),	// FIDIV
	/*0x034F*/ MAKE_OPWORD(OC_INFO, 0x02D4),	// FIDIVR
	/*0x0350*/ MAKE_OPWORD(OC_INFO, 0x02D5),	// FADDP
	/*0x0351*/ MAKE_OPWORD(OC_INFO, 0x02D6),	// FADDP
	/*0x0352*/ MAKE_OPWORD(OC_INFO, 0x02D7),	// FADDP
	/*0x0353*/ MAKE_OPWORD(OC_INFO, 0x02D8),	// FADDP
	/*0x0354*/ MAKE_OPWORD(OC_INFO, 0x02D9),	// FADDP
	/*0x0355*/ MAKE_OPWORD(OC_INFO, 0x02DA),	// FADDP
	/*0x0356*/ MAKE_OPWORD(OC_INFO, 0x02DB),	// FADDP
	/*0x0357*/ MAKE_OPWORD(OC_INFO, 0x02DC),	// FADDP
	/*0x0358*/ MAKE_OPWORD(OC_INFO, 0x02DD),	// FMULP
	/*0x0359*/ MAKE_OPWORD(OC_INFO, 0x02DE),	// FMULP
	/*0x035A*/ MAKE_OPWORD(OC_INFO, 0x02DF),	// FMULP
	/*0x035B*/ MAKE_OPWORD(OC_INFO, 0x02E0),	// FMULP
	/*0x035C*/ MAKE_OPWORD(OC_INFO, 0x02E1),	// FMULP
	/*0x035D*/ MAKE_OPWORD(OC_INFO, 0x02E2),	// FMULP
	/*0x035E*/ MAKE_OPWORD(OC_INFO, 0x02E3),	// FMULP
	/*0x035F*/ MAKE_OPWORD(OC_INFO, 0x02E4),	// FMULP
	/*0x0360*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0361*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0362*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0363*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0364*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0365*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0366*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0367*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0368*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0369*/ MAKE_OPWORD(OC_INFO, 0x02E5),	// FCOMPP
	/*0x036A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0370*/ MAKE_OPWORD(OC_INFO, 0x02E6),	// FSUBRP
	/*0x0371*/ MAKE_OPWORD(OC_INFO, 0x02E7),	// FSUBRP
	/*0x0372*/ MAKE_OPWORD(OC_INFO, 0x02E8),	// FSUBRP
	/*0x0373*/ MAKE_OPWORD(OC_INFO, 0x02E9),	// FSUBRP
	/*0x0374*/ MAKE_OPWORD(OC_INFO, 0x02EA),	// FSUBRP
	/*0x0375*/ MAKE_OPWORD(OC_INFO, 0x02EB),	// FSUBRP
	/*0x0376*/ MAKE_OPWORD(OC_INFO, 0x02EC),	// FSUBRP
	/*0x0377*/ MAKE_OPWORD(OC_INFO, 0x02ED),	// FSUBRP
	/*0x0378*/ MAKE_OPWORD(OC_INFO, 0x02EE),	// FSUBP
	/*0x0379*/ MAKE_OPWORD(OC_INFO, 0x02EF),	// FSUBP
	/*0x037A*/ MAKE_OPWORD(OC_INFO, 0x02F0),	// FSUBP
	/*0x037B*/ MAKE_OPWORD(OC_INFO, 0x02F1),	// FSUBP
	/*0x037C*/ MAKE_OPWORD(OC_INFO, 0x02F2),	// FSUBP
	/*0x037D*/ MAKE_OPWORD(OC_INFO, 0x02F3),	// FSUBP
	/*0x037E*/ MAKE_OPWORD(OC_INFO, 0x02F4),	// FSUBP
	/*0x037F*/ MAKE_OPWORD(OC_INFO, 0x02F5),	// FSUBP
	/*0x0380*/ MAKE_OPWORD(OC_INFO, 0x02F6),	// FDIVRP
	/*0x0381*/ MAKE_OPWORD(OC_INFO, 0x02F7),	// FDIVRP
	/*0x0382*/ MAKE_OPWORD(OC_INFO, 0x02F8),	// FDIVRP
	/*0x0383*/ MAKE_OPWORD(OC_INFO, 0x02F9),	// FDIVRP
	/*0x0384*/ MAKE_OPWORD(OC_INFO, 0x02FA),	// FDIVRP
	/*0x0385*/ MAKE_OPWORD(OC_INFO, 0x02FB),	// FDIVRP
	/*0x0386*/ MAKE_OPWORD(OC_INFO, 0x02FC),	// FDIVRP
	/*0x0387*/ MAKE_OPWORD(OC_INFO, 0x02FD),	// FDIVRP
	/*0x0388*/ MAKE_OPWORD(OC_INFO, 0x02FE),	// FDIVP
	/*0x0389*/ MAKE_OPWORD(OC_INFO, 0x02FF),	// FDIVP
	/*0x038A*/ MAKE_OPWORD(OC_INFO, 0x0300),	// FDIVP
	/*0x038B*/ MAKE_OPWORD(OC_INFO, 0x0301),	// FDIVP
	/*0x038C*/ MAKE_OPWORD(OC_INFO, 0x0302),	// FDIVP
	/*0x038D*/ MAKE_OPWORD(OC_INFO, 0x0303),	// FDIVP
	/*0x038E*/ MAKE_OPWORD(OC_INFO, 0x0304),	// FDIVP
	/*0x038F*/ MAKE_OPWORD(OC_INFO, 0x0305),	// FDIVP
	/*0x0390*/ MAKE_OPWORD(OC_INFO, 0x0306),	// FILD
	/*0x0391*/ MAKE_OPWORD(OC_INFO, 0x0307),	// FISTTP
	/*0x0392*/ MAKE_OPWORD(OC_INFO, 0x0308),	// FIST
	/*0x0393*/ MAKE_OPWORD(OC_INFO, 0x0309),	// FISTP
	/*0x0394*/ MAKE_OPWORD(OC_INFO, 0x030A),	// FBLD
	/*0x0395*/ MAKE_OPWORD(OC_INFO, 0x030B),	// FILD
	/*0x0396*/ MAKE_OPWORD(OC_INFO, 0x030C),	// FBSTP
	/*0x0397*/ MAKE_OPWORD(OC_INFO, 0x030D),	// FISTP
	/*0x0398*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0399*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03AA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03AB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03AC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03AD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03AE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03AF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B8*/ MAKE_OPWORD(OC_WITHPF, 0x03D8),	// 
	/*0x03B9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C0*/ MAKE_OPWORD(OC_INFO, 0x030E),	// FUCOMIP
	/*0x03C1*/ MAKE_OPWORD(OC_INFO, 0x030F),	// FUCOMIP
	/*0x03C2*/ MAKE_OPWORD(OC_INFO, 0x0310),	// FUCOMIP
	/*0x03C3*/ MAKE_OPWORD(OC_INFO, 0x0311),	// FUCOMIP
	/*0x03C4*/ MAKE_OPWORD(OC_INFO, 0x0312),	// FUCOMIP
	/*0x03C5*/ MAKE_OPWORD(OC_INFO, 0x0313),	// FUCOMIP
	/*0x03C6*/ MAKE_OPWORD(OC_INFO, 0x0314),	// FUCOMIP
	/*0x03C7*/ MAKE_OPWORD(OC_INFO, 0x0315),	// FUCOMIP
	/*0x03C8*/ MAKE_OPWORD(OC_INFO, 0x0316),	// FCOMIP
	/*0x03C9*/ MAKE_OPWORD(OC_INFO, 0x0317),	// FCOMIP
	/*0x03CA*/ MAKE_OPWORD(OC_INFO, 0x0318),	// FCOMIP
	/*0x03CB*/ MAKE_OPWORD(OC_INFO, 0x0319),	// FCOMIP
	/*0x03CC*/ MAKE_OPWORD(OC_INFO, 0x031A),	// FCOMIP
	/*0x03CD*/ MAKE_OPWORD(OC_INFO, 0x031B),	// FCOMIP
	/*0x03CE*/ MAKE_OPWORD(OC_INFO, 0x031C),	// FCOMIP
	/*0x03CF*/ MAKE_OPWORD(OC_INFO, 0x031D),	// FCOMIP
	/*0x03D0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D8*/ MAKE_OPWORD(OC_INFO, 0x0478),	// FNSTSW
	/*0x03D9*/ MAKE_OPWORD(OC_INFO, 0x0479),	// FSTSW
	/*0x03DA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E0*/ MAKE_OPWORD(OC_INFO, 0x031E),	// TEST
	/*0x03E1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E2*/ MAKE_OPWORD(OC_INFO, 0x031F),	// NOT
	/*0x03E3*/ MAKE_OPWORD(OC_INFO, 0x0320),	// NEG
	/*0x03E4*/ MAKE_OPWORD(OC_INFO, 0x0321),	// MUL
	/*0x03E5*/ MAKE_OPWORD(OC_INFO, 0x0322),	// IMUL
	/*0x03E6*/ MAKE_OPWORD(OC_INFO, 0x0323),	// DIV
	/*0x03E7*/ MAKE_OPWORD(OC_INFO, 0x0324),	// IDIV
	/*0x03E8*/ MAKE_OPWORD(OC_INFO, 0x0325),	// TEST
	/*0x03E9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03EA*/ MAKE_OPWORD(OC_INFO, 0x0326),	// NOT
	/*0x03EB*/ MAKE_OPWORD(OC_INFO, 0x0327),	// NEG
	/*0x03EC*/ MAKE_OPWORD(OC_INFO, 0x0328),	// MUL
	/*0x03ED*/ MAKE_OPWORD(OC_INFO, 0x0329),	// IMUL
	/*0x03EE*/ MAKE_OPWORD(OC_INFO, 0x032A),	// DIV
	/*0x03EF*/ MAKE_OPWORD(OC_INFO, 0x032B),	// IDIV
	/*0x03F0*/ MAKE_OPWORD(OC_INFO, 0x032C),	// INC
	/*0x03F1*/ MAKE_OPWORD(OC_INFO, 0x032D),	// DEC
	/*0x03F2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F8*/ MAKE_OPWORD(OC_INFO, 0x032E),	// INC
	/*0x03F9*/ MAKE_OPWORD(OC_INFO, 0x032F),	// DEC
	/*0x03FA*/ MAKE_OPWORD(OC_INFO, 0x0330),	// CALL
	/*0x03FB*/ MAKE_OPWORD(OC_INFO, 0x0331),	// CALL_FAR
	/*0x03FC*/ MAKE_OPWORD(OC_INFO, 0x0332),	// JMP
	/*0x03FD*/ MAKE_OPWORD(OC_INFO, 0x0333),	// JMP_FAR
	/*0x03FE*/ MAKE_OPWORD(OC_INFO, 0x0334),	// PUSH
	/*0x03FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
};

OPBYTE_INFO PEDisAsm::G_2BCODE_TBL[CTBL_LEN_2BCODE] =
{
	/*0x0000*/ MAKE_OPWORD(OC_GROUP, 0x0100),	// Group6
	/*0x0001*/ MAKE_OPWORD(OC_FULL, 0x0108),	// Group7
	/*0x0002*/ MAKE_OPWORD(OC_INFO, 0x00D5),	// LAR
	/*0x0003*/ MAKE_OPWORD(OC_INFO, 0x00D6),	// LSL
	/*0x0004*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0005*/ MAKE_OPWORD(OC_INFO, 0x00D7),	// SYSCALL
	/*0x0006*/ MAKE_OPWORD(OC_INFO, 0x00D8),	// CLTS
	/*0x0007*/ MAKE_OPWORD(OC_INFO, 0x00D9),	// SYSRET
	/*0x0008*/ MAKE_OPWORD(OC_INFO, 0x00DA),	// INVD
	/*0x0009*/ MAKE_OPWORD(OC_INFO, 0x00DB),	// WBINVD
	/*0x000A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x000B*/ MAKE_OPWORD(OC_INFO, 0x00DC),	// UD2
	/*0x000C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x000D*/ MAKE_OPWORD(OC_GROUP, 0x0150),	// AMD64_prefetch_Group
	/*0x000E*/ MAKE_OPWORD(OC_INFO,  0x00DD),	// FEMMS
	/*0x000F*/ MAKE_OPWORD(OC_EXT,   0x0004),	// 3-Bytes 3DNow! Escape
	/*0x0010*/ MAKE_OPWORD(OC_WITHPF, 0x0158),	// 
	/*0x0011*/ MAKE_OPWORD(OC_WITHPF, 0x0164),	// 
	/*0x0012*/ MAKE_OPWORD(OC_WITHPF, 0x0170),	// 
	/*0x0013*/ MAKE_OPWORD(OC_WITHPF, 0x0178),	// 
	/*0x0014*/ MAKE_OPWORD(OC_WITHPF, 0x0180),	// 
	/*0x0015*/ MAKE_OPWORD(OC_WITHPF, 0x0188),	// 
	/*0x0016*/ MAKE_OPWORD(OC_WITHPF, 0x0190),	// 
	/*0x0017*/ MAKE_OPWORD(OC_WITHPF, 0x0198),	// 
	/*0x0018*/ MAKE_OPWORD(OC_GROUP, 0x01A0),	// Group16
	/*0x0019*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001F*/ MAKE_OPWORD(OC_INFO, 0x00DE),	// NOP
	/*0x0020*/ MAKE_OPWORD(OC_INFO, 0x00DF),	// MOV
	/*0x0021*/ MAKE_OPWORD(OC_INFO, 0x00E0),	// MOV
	/*0x0022*/ MAKE_OPWORD(OC_INFO, 0x00E1),	// MOV
	/*0x0023*/ MAKE_OPWORD(OC_INFO, 0x00E2),	// MOV
	/*0x0024*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0025*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0026*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0027*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0028*/ MAKE_OPWORD(OC_WITHPF, 0x01A8),	// 
	/*0x0029*/ MAKE_OPWORD(OC_WITHPF, 0x01B0),	// 
	/*0x002A*/ MAKE_OPWORD(OC_WITHPF, 0x01B8),	// 
	/*0x002B*/ MAKE_OPWORD(OC_WITHPF, 0x01C0),	// 
	/*0x002C*/ MAKE_OPWORD(OC_WITHPF, 0x01C8),	// 
	/*0x002D*/ MAKE_OPWORD(OC_WITHPF, 0x01D0),	// 
	/*0x002E*/ MAKE_OPWORD(OC_WITHPF, 0x01D8),	// 
	/*0x002F*/ MAKE_OPWORD(OC_WITHPF, 0x01E0),	// 
	/*0x0030*/ MAKE_OPWORD(OC_INFO, 0x00E3),	// WRMSR
	/*0x0031*/ MAKE_OPWORD(OC_INFO, 0x00E4),	// RDTSC
	/*0x0032*/ MAKE_OPWORD(OC_INFO, 0x00E5),	// RDMSR
	/*0x0033*/ MAKE_OPWORD(OC_INFO, 0x00E6),	// RDPMC
	/*0x0034*/ MAKE_OPWORD(OC_INFO, 0x00E7),	// SYSENTER
	/*0x0035*/ MAKE_OPWORD(OC_INFO, 0x00E8),	// SYSEXIT
	/*0x0036*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0037*/ MAKE_OPWORD(OC_INFO, 0x00E9),	// GETSEC
	/*0x0038*/ MAKE_OPWORD(OC_EXT,  0x0002),	// 3-Bytes FF-38 Escape 
	/*0x0039*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003A*/ MAKE_OPWORD(OC_EXT,  0x0003),	// 3-Bytes FF-3A Escape 
	/*0x003B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0040*/ MAKE_OPWORD(OC_INFO, 0x00EA),	// CMOVO
	/*0x0041*/ MAKE_OPWORD(OC_INFO, 0x00EB),	// CMOVNO
	/*0x0042*/ MAKE_OPWORD(OC_INFO, 0x00EC),	// CMOVB
	/*0x0043*/ MAKE_OPWORD(OC_INFO, 0x00ED),	// CMOVAE
	/*0x0044*/ MAKE_OPWORD(OC_INFO, 0x00EE),	// CMOVZ
	/*0x0045*/ MAKE_OPWORD(OC_INFO, 0x00EF),	// CMOVNZ
	/*0x0046*/ MAKE_OPWORD(OC_INFO, 0x00F0),	// CMOVBE
	/*0x0047*/ MAKE_OPWORD(OC_INFO, 0x00F1),	// CMOVA
	/*0x0048*/ MAKE_OPWORD(OC_INFO, 0x00F2),	// CMOVS
	/*0x0049*/ MAKE_OPWORD(OC_INFO, 0x00F3),	// CMOVNS
	/*0x004A*/ MAKE_OPWORD(OC_INFO, 0x00F4),	// CMOVP
	/*0x004B*/ MAKE_OPWORD(OC_INFO, 0x00F5),	// CMOVNP
	/*0x004C*/ MAKE_OPWORD(OC_INFO, 0x00F6),	// CMOVL
	/*0x004D*/ MAKE_OPWORD(OC_INFO, 0x00F7),	// CMOVGE
	/*0x004E*/ MAKE_OPWORD(OC_INFO, 0x00F8),	// CMOVLE
	/*0x004F*/ MAKE_OPWORD(OC_INFO, 0x00F9),	// CMOVG
	/*0x0050*/ MAKE_OPWORD(OC_WITHPF, 0x01E8),	// 
	/*0x0051*/ MAKE_OPWORD(OC_WITHPF, 0x01F0),	// 
	/*0x0052*/ MAKE_OPWORD(OC_WITHPF, 0x01F8),	// 
	/*0x0053*/ MAKE_OPWORD(OC_WITHPF, 0x0200),	// 
	/*0x0054*/ MAKE_OPWORD(OC_WITHPF, 0x0208),	// 
	/*0x0055*/ MAKE_OPWORD(OC_WITHPF, 0x0210),	// 
	/*0x0056*/ MAKE_OPWORD(OC_WITHPF, 0x0218),	// 
	/*0x0057*/ MAKE_OPWORD(OC_WITHPF, 0x0220),	// 
	/*0x0058*/ MAKE_OPWORD(OC_WITHPF, 0x0228),	// 
	/*0x0059*/ MAKE_OPWORD(OC_WITHPF, 0x0230),	// 
	/*0x005A*/ MAKE_OPWORD(OC_WITHPF, 0x0238),	// 
	/*0x005B*/ MAKE_OPWORD(OC_WITHPF, 0x0240),	// 
	/*0x005C*/ MAKE_OPWORD(OC_WITHPF, 0x0248),	// 
	/*0x005D*/ MAKE_OPWORD(OC_WITHPF, 0x0250),	// 
	/*0x005E*/ MAKE_OPWORD(OC_WITHPF, 0x0258),	// 
	/*0x005F*/ MAKE_OPWORD(OC_WITHPF, 0x0260),	// 
	/*0x0060*/ MAKE_OPWORD(OC_WITHPF, 0x0268),	// 
	/*0x0061*/ MAKE_OPWORD(OC_WITHPF, 0x0270),	// 
	/*0x0062*/ MAKE_OPWORD(OC_WITHPF, 0x0278),	// 
	/*0x0063*/ MAKE_OPWORD(OC_WITHPF, 0x0280),	// 
	/*0x0064*/ MAKE_OPWORD(OC_WITHPF, 0x0288),	// 
	/*0x0065*/ MAKE_OPWORD(OC_WITHPF, 0x0290),	// 
	/*0x0066*/ MAKE_OPWORD(OC_WITHPF, 0x0298),	// 
	/*0x0067*/ MAKE_OPWORD(OC_WITHPF, 0x02A0),	// 
	/*0x0068*/ MAKE_OPWORD(OC_WITHPF, 0x02A8),	// 
	/*0x0069*/ MAKE_OPWORD(OC_WITHPF, 0x02B0),	// 
	/*0x006A*/ MAKE_OPWORD(OC_WITHPF, 0x02B8),	// 
	/*0x006B*/ MAKE_OPWORD(OC_WITHPF, 0x02C0),	// 
	/*0x006C*/ MAKE_OPWORD(OC_WITHPF, 0x02C8),	// 
	/*0x006D*/ MAKE_OPWORD(OC_WITHPF, 0x02D0),	// 
	/*0x006E*/ MAKE_OPWORD(OC_WITHPF, 0x02D8),	// 
	/*0x006F*/ MAKE_OPWORD(OC_WITHPF, 0x02E0),	// 
	/*0x0070*/ MAKE_OPWORD(OC_WITHPF, 0x02E8),	// 
	/*0x0071*/ MAKE_OPWORD(OC_GROUP, 0x02F0),	// Group12
	/*0x0072*/ MAKE_OPWORD(OC_GROUP, 0x0310),	// Group13
	/*0x0073*/ MAKE_OPWORD(OC_GROUP, 0x0330),	// Group14
	/*0x0074*/ MAKE_OPWORD(OC_WITHPF, 0x0358),	// 
	/*0x0075*/ MAKE_OPWORD(OC_WITHPF, 0x0360),	// 
	/*0x0076*/ MAKE_OPWORD(OC_WITHPF, 0x0368),	// 
	/*0x0077*/ MAKE_OPWORD(OC_WITHPF, 0x0370),	// 
	/*0x0078*/ MAKE_OPWORD(OC_WITHPF, 0x0378),	// 
	/*0x0079*/ MAKE_OPWORD(OC_WITHPF, 0x0380),	// 
	/*0x007A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007C*/ MAKE_OPWORD(OC_WITHPF, 0x0388),	// 
	/*0x007D*/ MAKE_OPWORD(OC_WITHPF, 0x0390),	// 
	/*0x007E*/ MAKE_OPWORD(OC_WITHPF, 0x0398),	// 
	/*0x007F*/ MAKE_OPWORD(OC_WITHPF, 0x03A0),	// 
	/*0x0080*/ MAKE_OPWORD(OC_INFO, 0x00FA),	// JO
	/*0x0081*/ MAKE_OPWORD(OC_INFO, 0x00FB),	// JNO
	/*0x0082*/ MAKE_OPWORD(OC_INFO, 0x00FC),	// JB
	/*0x0083*/ MAKE_OPWORD(OC_INFO, 0x00FD),	// JNB
	/*0x0084*/ MAKE_OPWORD(OC_INFO, 0x00FE),	// JZ
	/*0x0085*/ MAKE_OPWORD(OC_INFO, 0x00FF),	// JNZ
	/*0x0086*/ MAKE_OPWORD(OC_INFO, 0x0100),	// JBE
	/*0x0087*/ MAKE_OPWORD(OC_INFO, 0x0101),	// JNBE
	/*0x0088*/ MAKE_OPWORD(OC_INFO, 0x0102),	// JS
	/*0x0089*/ MAKE_OPWORD(OC_INFO, 0x0103),	// JNS
	/*0x008A*/ MAKE_OPWORD(OC_INFO, 0x0104),	// JP
	/*0x008B*/ MAKE_OPWORD(OC_INFO, 0x0105),	// JNP
	/*0x008C*/ MAKE_OPWORD(OC_INFO, 0x0106),	// JL
	/*0x008D*/ MAKE_OPWORD(OC_INFO, 0x0107),	// JNL
	/*0x008E*/ MAKE_OPWORD(OC_INFO, 0x0108),	// JLE
	/*0x008F*/ MAKE_OPWORD(OC_INFO, 0x0109),	// JNLE
	/*0x0090*/ MAKE_OPWORD(OC_INFO, 0x010A),	// SETO
	/*0x0091*/ MAKE_OPWORD(OC_INFO, 0x010B),	// SETNO
	/*0x0092*/ MAKE_OPWORD(OC_INFO, 0x010C),	// SETB
	/*0x0093*/ MAKE_OPWORD(OC_INFO, 0x010D),	// SETAE
	/*0x0094*/ MAKE_OPWORD(OC_INFO, 0x010E),	// SETZ
	/*0x0095*/ MAKE_OPWORD(OC_INFO, 0x010F),	// SETNZ
	/*0x0096*/ MAKE_OPWORD(OC_INFO, 0x0110),	// SETBE
	/*0x0097*/ MAKE_OPWORD(OC_INFO, 0x0111),	// SETA
	/*0x0098*/ MAKE_OPWORD(OC_INFO, 0x0112),	// SETS
	/*0x0099*/ MAKE_OPWORD(OC_INFO, 0x0113),	// SETNS
	/*0x009A*/ MAKE_OPWORD(OC_INFO, 0x0114),	// SETP
	/*0x009B*/ MAKE_OPWORD(OC_INFO, 0x0115),	// SETNP
	/*0x009C*/ MAKE_OPWORD(OC_INFO, 0x0116),	// SETL
	/*0x009D*/ MAKE_OPWORD(OC_INFO, 0x0117),	// SETGE
	/*0x009E*/ MAKE_OPWORD(OC_INFO, 0x0118),	// SETLE
	/*0x009F*/ MAKE_OPWORD(OC_INFO, 0x0119),	// SETG
	/*0x00A0*/ MAKE_OPWORD(OC_INFO, 0x011A),	// PUSH
	/*0x00A1*/ MAKE_OPWORD(OC_INFO, 0x011B),	// POP
	/*0x00A2*/ MAKE_OPWORD(OC_INFO, 0x011C),	// CPUID
	/*0x00A3*/ MAKE_OPWORD(OC_INFO, 0x011D),	// BT
	/*0x00A4*/ MAKE_OPWORD(OC_INFOEX, 0x0005),	// SHLD
	/*0x00A5*/ MAKE_OPWORD(OC_INFOEX, 0x0006),	// SHLD
	/*0x00A6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A8*/ MAKE_OPWORD(OC_INFO, 0x011E),	// PUSH
	/*0x00A9*/ MAKE_OPWORD(OC_INFO, 0x011F),	// POP
	/*0x00AA*/ MAKE_OPWORD(OC_INFO, 0x0120),	// RSM
	/*0x00AB*/ MAKE_OPWORD(OC_INFO, 0x0121),	// BTS
	/*0x00AC*/ MAKE_OPWORD(OC_INFOEX, 0x0007),	// SHRD
	/*0x00AD*/ MAKE_OPWORD(OC_INFOEX, 0x0008),	// SHRD
	/*0x00AE*/ MAKE_OPWORD(OC_GRP_C0, 0x03A8),	// Group15
	/*0x00AF*/ MAKE_OPWORD(OC_INFO, 0x0122),	// IMUL
	/*0x00B0*/ MAKE_OPWORD(OC_INFO, 0x0123),	// CMPXCHG
	/*0x00B1*/ MAKE_OPWORD(OC_INFO, 0x0124),	// CMPXCHG
	/*0x00B2*/ MAKE_OPWORD(OC_INFO, 0x0125),	// LSS
	/*0x00B3*/ MAKE_OPWORD(OC_INFO, 0x0126),	// BTR
	/*0x00B4*/ MAKE_OPWORD(OC_INFO, 0x0127),	// LFS
	/*0x00B5*/ MAKE_OPWORD(OC_INFO, 0x0128),	// LGS
	/*0x00B6*/ MAKE_OPWORD(OC_INFO, 0x0129),	// MOVZX
	/*0x00B7*/ MAKE_OPWORD(OC_INFO, 0x012A),	// MOVZX
	/*0x00B8*/ MAKE_OPWORD(OC_WITHPF, 0x03C8),	// 
	/*0x00B9*/ MAKE_OPWORD(OC_INFO, 0x012B),	// UD2
	/*0x00BA*/ MAKE_OPWORD(OC_GROUP, 0x03D0),	// Group8
	/*0x00BB*/ MAKE_OPWORD(OC_INFO, 0x012C),	// BTC
	/*0x00BC*/ MAKE_OPWORD(OC_WITHPF, 0x03D8),	// 
	/*0x00BD*/ MAKE_OPWORD(OC_WITHPF, 0x03E0),	// 
	/*0x00BE*/ MAKE_OPWORD(OC_INFO, 0x012D),	// MOVSX
	/*0x00BF*/ MAKE_OPWORD(OC_INFO, 0x012E),	// MOVSX
	/*0x00C0*/ MAKE_OPWORD(OC_INFO, 0x012F),	// XADD
	/*0x00C1*/ MAKE_OPWORD(OC_INFO, 0x0130),	// XADD
	/*0x00C2*/ MAKE_OPWORD(OC_WITHPF, 0x03E8),	// 
	/*0x00C3*/ MAKE_OPWORD(OC_INFO, 0x0131),	// MOVNTI
	/*0x00C4*/ MAKE_OPWORD(OC_WITHPF, 0x03F0),	// 
	/*0x00C5*/ MAKE_OPWORD(OC_WITHPF, 0x03F8),	// 
	/*0x00C6*/ MAKE_OPWORD(OC_WITHPF, 0x0400),	// 
	/*0x00C7*/ MAKE_OPWORD(OC_GRP_C0, 0x0408),	// Group9
	/*0x00C8*/ MAKE_OPWORD(OC_INFO, 0x0132),	// BSWAP
	/*0x00C9*/ MAKE_OPWORD(OC_INFO, 0x0133),	// BSWAP
	/*0x00CA*/ MAKE_OPWORD(OC_INFO, 0x0134),	// BSWAP
	/*0x00CB*/ MAKE_OPWORD(OC_INFO, 0x0135),	// BSWAP
	/*0x00CC*/ MAKE_OPWORD(OC_INFO, 0x0136),	// BSWAP
	/*0x00CD*/ MAKE_OPWORD(OC_INFO, 0x0137),	// BSWAP
	/*0x00CE*/ MAKE_OPWORD(OC_INFO, 0x0138),	// BSWAP
	/*0x00CF*/ MAKE_OPWORD(OC_INFO, 0x0139),	// BSWAP
	/*0x00D0*/ MAKE_OPWORD(OC_WITHPF, 0x0420),	// 
	/*0x00D1*/ MAKE_OPWORD(OC_WITHPF, 0x0428),	// 
	/*0x00D2*/ MAKE_OPWORD(OC_WITHPF, 0x0430),	// 
	/*0x00D3*/ MAKE_OPWORD(OC_WITHPF, 0x0438),	// 
	/*0x00D4*/ MAKE_OPWORD(OC_WITHPF, 0x0440),	// 
	/*0x00D5*/ MAKE_OPWORD(OC_WITHPF, 0x0448),	// 
	/*0x00D6*/ MAKE_OPWORD(OC_WITHPF, 0x0450),	// 
	/*0x00D7*/ MAKE_OPWORD(OC_WITHPF, 0x0458),	// 
	/*0x00D8*/ MAKE_OPWORD(OC_WITHPF, 0x0460),	// 
	/*0x00D9*/ MAKE_OPWORD(OC_WITHPF, 0x0468),	// 
	/*0x00DA*/ MAKE_OPWORD(OC_WITHPF, 0x0470),	// 
	/*0x00DB*/ MAKE_OPWORD(OC_WITHPF, 0x0478),	// 
	/*0x00DC*/ MAKE_OPWORD(OC_WITHPF, 0x0480),	// 
	/*0x00DD*/ MAKE_OPWORD(OC_WITHPF, 0x0488),	// 
	/*0x00DE*/ MAKE_OPWORD(OC_WITHPF, 0x0490),	// 
	/*0x00DF*/ MAKE_OPWORD(OC_WITHPF, 0x0498),	// 
	/*0x00E0*/ MAKE_OPWORD(OC_WITHPF, 0x04A0),	// 
	/*0x00E1*/ MAKE_OPWORD(OC_WITHPF, 0x04A8),	// 
	/*0x00E2*/ MAKE_OPWORD(OC_WITHPF, 0x04B0),	// 
	/*0x00E3*/ MAKE_OPWORD(OC_WITHPF, 0x04B8),	// 
	/*0x00E4*/ MAKE_OPWORD(OC_WITHPF, 0x04C0),	// 
	/*0x00E5*/ MAKE_OPWORD(OC_WITHPF, 0x04C8),	// 
	/*0x00E6*/ MAKE_OPWORD(OC_WITHPF, 0x04D0),	// 
	/*0x00E7*/ MAKE_OPWORD(OC_WITHPF, 0x04D8),	// 
	/*0x00E8*/ MAKE_OPWORD(OC_WITHPF, 0x04E0),	// 
	/*0x00E9*/ MAKE_OPWORD(OC_WITHPF, 0x04E8),	// 
	/*0x00EA*/ MAKE_OPWORD(OC_WITHPF, 0x04F0),	// 
	/*0x00EB*/ MAKE_OPWORD(OC_WITHPF, 0x04F8),	// 
	/*0x00EC*/ MAKE_OPWORD(OC_WITHPF, 0x0500),	// 
	/*0x00ED*/ MAKE_OPWORD(OC_WITHPF, 0x0508),	// 
	/*0x00EE*/ MAKE_OPWORD(OC_WITHPF, 0x0510),	// 
	/*0x00EF*/ MAKE_OPWORD(OC_WITHPF, 0x0518),	// 
	/*0x00F0*/ MAKE_OPWORD(OC_WITHPF, 0x0520),	// 
	/*0x00F1*/ MAKE_OPWORD(OC_WITHPF, 0x0528),	// 
	/*0x00F2*/ MAKE_OPWORD(OC_WITHPF, 0x0530),	// 
	/*0x00F3*/ MAKE_OPWORD(OC_WITHPF, 0x0538),	// 
	/*0x00F4*/ MAKE_OPWORD(OC_WITHPF, 0x0540),	// 
	/*0x00F5*/ MAKE_OPWORD(OC_WITHPF, 0x0548),	// 
	/*0x00F6*/ MAKE_OPWORD(OC_WITHPF, 0x0550),	// 
	/*0x00F7*/ MAKE_OPWORD(OC_WITHPF, 0x0558),	// 
	/*0x00F8*/ MAKE_OPWORD(OC_WITHPF, 0x0560),	// 
	/*0x00F9*/ MAKE_OPWORD(OC_WITHPF, 0x0568),	// 
	/*0x00FA*/ MAKE_OPWORD(OC_WITHPF, 0x0570),	// 
	/*0x00FB*/ MAKE_OPWORD(OC_WITHPF, 0x0578),	// 
	/*0x00FC*/ MAKE_OPWORD(OC_WITHPF, 0x0580),	// 
	/*0x00FD*/ MAKE_OPWORD(OC_WITHPF, 0x0588),	// 
	/*0x00FE*/ MAKE_OPWORD(OC_WITHPF, 0x0590),	// 
	/*0x00FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0100*/ MAKE_OPWORD(OC_INFO, 0x0335),	// SLDT
	/*0x0101*/ MAKE_OPWORD(OC_INFO, 0x0336),	// STR
	/*0x0102*/ MAKE_OPWORD(OC_INFO, 0x0337),	// LLDT
	/*0x0103*/ MAKE_OPWORD(OC_INFO, 0x0338),	// LTR
	/*0x0104*/ MAKE_OPWORD(OC_INFO, 0x0339),	// VERR
	/*0x0105*/ MAKE_OPWORD(OC_INFO, 0x033A),	// VERW
	/*0x0106*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0107*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0108*/ MAKE_OPWORD(OC_INFO, 0x033B),	// SGDT
	/*0x0109*/ MAKE_OPWORD(OC_INFO, 0x033C),	// SIDT
	/*0x010A*/ MAKE_OPWORD(OC_INFO, 0x033D),	// LGDT
	/*0x010B*/ MAKE_OPWORD(OC_INFO, 0x033E),	// LIDT
	/*0x010C*/ MAKE_OPWORD(OC_INFO, 0x033F),	// SMSW
	/*0x010D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x010E*/ MAKE_OPWORD(OC_INFO, 0x0340),	// LMSW
	/*0x010F*/ MAKE_OPWORD(OC_INFO, 0x0341),	// INVLPG
	/*0x0110*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0111*/ MAKE_OPWORD(OC_INFO, 0x0342),	// VMCALL
	/*0x0112*/ MAKE_OPWORD(OC_INFO, 0x0343),	// VMLAUNCH
	/*0x0113*/ MAKE_OPWORD(OC_INFO, 0x0344),	// VMRESUME
	/*0x0114*/ MAKE_OPWORD(OC_INFO, 0x0345),	// VMXOFF
	/*0x0115*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0116*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0117*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0118*/ MAKE_OPWORD(OC_INFO, 0x0346),	// MONITOR
	/*0x0119*/ MAKE_OPWORD(OC_INFO, 0x0347),	// MWAIT
	/*0x011A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0120*/ MAKE_OPWORD(OC_INFO, 0x0348),	// XGETBV
	/*0x0121*/ MAKE_OPWORD(OC_INFO, 0x0349),	// XSETBV
	/*0x0122*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0123*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0124*/ MAKE_OPWORD(OC_INFO, 0x034A),	// VMFUNC
	/*0x0125*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0126*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0127*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0128*/ MAKE_OPWORD(OC_INFO, 0x034B),	// VMRUN
	/*0x0129*/ MAKE_OPWORD(OC_INFO, 0x034C),	// VMMCALL
	/*0x012A*/ MAKE_OPWORD(OC_INFO, 0x034D),	// VMLOAD
	/*0x012B*/ MAKE_OPWORD(OC_INFO, 0x034E),	// VMSAVE
	/*0x012C*/ MAKE_OPWORD(OC_INFO, 0x034F),	// STGI
	/*0x012D*/ MAKE_OPWORD(OC_INFO, 0x0350),	// CLGI
	/*0x012E*/ MAKE_OPWORD(OC_INFO, 0x0351),	// SKINIT
	/*0x012F*/ MAKE_OPWORD(OC_INFO, 0x0352),	// INVLPGA
	/*0x0130*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0131*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0132*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0133*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0134*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0135*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0136*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0137*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0138*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0139*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0140*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0141*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0142*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0143*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0144*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0145*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0146*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0147*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0148*/ MAKE_OPWORD(OC_INFO, 0x0353),	// SWAPGS
	/*0x0149*/ MAKE_OPWORD(OC_INFO, 0x0354),	// RDTSCP
	/*0x014A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x014B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x014C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x014D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x014E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x014F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0150*/ MAKE_OPWORD(OC_INFO, 0x0355),	// PREFETCH
	/*0x0151*/ MAKE_OPWORD(OC_INFO, 0x0356),	// PREFETCHW
	/*0x0152*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0153*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0154*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0155*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0156*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0157*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0158*/ MAKE_OPWORD(OC_INFO, 0x036F),	// MOVUPS
	/*0x0159*/ MAKE_OPWORD(OC_INFO, 0x0370),	// MOVUPD
	/*0x015A*/ MAKE_OPWORD(OC_INFO, 0x0371),	// MOVSS
	/*0x015B*/ MAKE_OPWORD(OC_INFO, 0x0372),	// MOVSD
	/*0x015C*/ MAKE_OPWORD(OC_INFOEX, 0x0009),	// VMOVUPS
	/*0x015D*/ MAKE_OPWORD(OC_INFOEX, 0x000A),	// VMOVUPD
	/*0x015E*/ MAKE_OPWORD(OC_VEX_C0, 0x0160),	// 
	/*0x015F*/ MAKE_OPWORD(OC_VEX_C0, 0x0162),	// 
	/*0x0160*/ MAKE_OPWORD(OC_INFOEX, 0x000B),	// VMOVSS
	/*0x0161*/ MAKE_OPWORD(OC_INFOEX, 0x000D),	// VMOVSS
	/*0x0162*/ MAKE_OPWORD(OC_INFOEX, 0x000C),	// VMOVSD
	/*0x0163*/ MAKE_OPWORD(OC_INFOEX, 0x000E),	// VMOVSD
	/*0x0164*/ MAKE_OPWORD(OC_INFO, 0x0373),	// MOVUPS
	/*0x0165*/ MAKE_OPWORD(OC_INFO, 0x0374),	// MOVUPD
	/*0x0166*/ MAKE_OPWORD(OC_INFO, 0x0375),	// MOVSS
	/*0x0167*/ MAKE_OPWORD(OC_INFO, 0x0376),	// MOVSD
	/*0x0168*/ MAKE_OPWORD(OC_INFOEX, 0x000F),	// VMOVUPS
	/*0x0169*/ MAKE_OPWORD(OC_INFOEX, 0x0010),	// VMOVUPD
	/*0x016A*/ MAKE_OPWORD(OC_VEX_C0, 0x016C),	// 
	/*0x016B*/ MAKE_OPWORD(OC_VEX_C0, 0x016E),	// 
	/*0x016C*/ MAKE_OPWORD(OC_INFOEX, 0x0011),	// VMOVSS
	/*0x016D*/ MAKE_OPWORD(OC_INFOEX, 0x0013),	// VMOVSS
	/*0x016E*/ MAKE_OPWORD(OC_INFOEX, 0x0012),	// VMOVSD
	/*0x016F*/ MAKE_OPWORD(OC_INFOEX, 0x0014),	// VMOVSD
	/*0x0170*/ MAKE_OPWORD(OC_INFOEX, 0x0015),	// MOVHLPS
	/*0x0171*/ MAKE_OPWORD(OC_INFO, 0x0377),	// MOVLPD
	/*0x0172*/ MAKE_OPWORD(OC_INFO, 0x0378),	// MOVSLDUP
	/*0x0173*/ MAKE_OPWORD(OC_INFO, 0x0379),	// MOVDDUP
	/*0x0174*/ MAKE_OPWORD(OC_INFOEX, 0x0016),	// VMOVHLPS
	/*0x0175*/ MAKE_OPWORD(OC_INFOEX, 0x0017),	// VMOVLPD
	/*0x0176*/ MAKE_OPWORD(OC_INFOEX, 0x0018),	// VMOVSLDUP
	/*0x0177*/ MAKE_OPWORD(OC_INFOEX, 0x0019),	// VMOVDDUP
	/*0x0178*/ MAKE_OPWORD(OC_INFO, 0x037A),	// MOVLPS
	/*0x0179*/ MAKE_OPWORD(OC_INFO, 0x037B),	// MOVLPD
	/*0x017A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x017B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x017C*/ MAKE_OPWORD(OC_INFOEX, 0x001A),	// VMOVLPS
	/*0x017D*/ MAKE_OPWORD(OC_INFOEX, 0x001B),	// VMOVLPD
	/*0x017E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x017F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0180*/ MAKE_OPWORD(OC_INFO, 0x037C),	// UNPCKLPS
	/*0x0181*/ MAKE_OPWORD(OC_INFO, 0x037D),	// UNPCKLPD
	/*0x0182*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0183*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0184*/ MAKE_OPWORD(OC_INFOEX, 0x001C),	// VUNPCKLPS
	/*0x0185*/ MAKE_OPWORD(OC_INFOEX, 0x001D),	// VUNPCKLPD
	/*0x0186*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0187*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0188*/ MAKE_OPWORD(OC_INFO, 0x037E),	// UNPCKHPS
	/*0x0189*/ MAKE_OPWORD(OC_INFO, 0x037F),	// UNPCKHPD
	/*0x018A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x018B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x018C*/ MAKE_OPWORD(OC_INFOEX, 0x001E),	// VUNPCKHPS
	/*0x018D*/ MAKE_OPWORD(OC_INFOEX, 0x001F),	// VUNPCKHPD
	/*0x018E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x018F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0190*/ MAKE_OPWORD(OC_INFOEX, 0x0020),	// MOVLHPS
	/*0x0191*/ MAKE_OPWORD(OC_INFO, 0x0380),	// MOVHPD
	/*0x0192*/ MAKE_OPWORD(OC_INFO, 0x0381),	// MOVSHDUP
	/*0x0193*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0194*/ MAKE_OPWORD(OC_INFOEX, 0x0021),	// VMOVLHPS
	/*0x0195*/ MAKE_OPWORD(OC_INFOEX, 0x0022),	// VMOVHPD
	/*0x0196*/ MAKE_OPWORD(OC_INFOEX, 0x0023),	// VMOVSHDUP
	/*0x0197*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0198*/ MAKE_OPWORD(OC_INFO, 0x0382),	// MOVHPS
	/*0x0199*/ MAKE_OPWORD(OC_INFO, 0x0383),	// MOVHPD
	/*0x019A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x019B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x019C*/ MAKE_OPWORD(OC_INFOEX, 0x0024),	// VMOVHPS
	/*0x019D*/ MAKE_OPWORD(OC_INFOEX, 0x0025),	// VMOVHPD
	/*0x019E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x019F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A0*/ MAKE_OPWORD(OC_INFO, 0x0384),	// PREFETCHNTA
	/*0x01A1*/ MAKE_OPWORD(OC_INFO, 0x0385),	// PREFETCHT0
	/*0x01A2*/ MAKE_OPWORD(OC_INFO, 0x0386),	// PREFETCHT1
	/*0x01A3*/ MAKE_OPWORD(OC_INFO, 0x0387),	// PREFETCHT2
	/*0x01A4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A8*/ MAKE_OPWORD(OC_INFO, 0x0388),	// MOVAPS
	/*0x01A9*/ MAKE_OPWORD(OC_INFO, 0x0389),	// MOVAPD
	/*0x01AA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01AB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01AC*/ MAKE_OPWORD(OC_INFOEX, 0x0026),	// VMOVAPS
	/*0x01AD*/ MAKE_OPWORD(OC_INFOEX, 0x0027),	// VMOVAPD
	/*0x01AE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01AF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B0*/ MAKE_OPWORD(OC_INFO, 0x038A),	// MOVAPS
	/*0x01B1*/ MAKE_OPWORD(OC_INFO, 0x038B),	// MOVAPD
	/*0x01B2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B4*/ MAKE_OPWORD(OC_INFOEX, 0x0028),	// VMOVAPS
	/*0x01B5*/ MAKE_OPWORD(OC_INFOEX, 0x0029),	// VMOVAPD
	/*0x01B6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B8*/ MAKE_OPWORD(OC_INFO, 0x038C),	// CVTPI2PS
	/*0x01B9*/ MAKE_OPWORD(OC_INFO, 0x038D),	// CVTPI2PD
	/*0x01BA*/ MAKE_OPWORD(OC_INFO, 0x038E),	// CVTSI2SS
	/*0x01BB*/ MAKE_OPWORD(OC_INFO, 0x038F),	// CVTSI2SD
	/*0x01BC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01BD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01BE*/ MAKE_OPWORD(OC_INFOEX, 0x002A),	// VCVTSI2SS
	/*0x01BF*/ MAKE_OPWORD(OC_INFOEX, 0x002B),	// VCVTSI2SD
	/*0x01C0*/ MAKE_OPWORD(OC_INFO, 0x0390),	// MOVNTPS
	/*0x01C1*/ MAKE_OPWORD(OC_INFO, 0x0391),	// MOVNTPD
	/*0x01C2*/ MAKE_OPWORD(OC_INFO, 0x0392),	// MOVNTSS
	/*0x01C3*/ MAKE_OPWORD(OC_INFO, 0x0393),	// MOVNTSD
	/*0x01C4*/ MAKE_OPWORD(OC_INFOEX, 0x002C),	// VMOVNTPS
	/*0x01C5*/ MAKE_OPWORD(OC_INFOEX, 0x002D),	// VMOVNTPD
	/*0x01C6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C8*/ MAKE_OPWORD(OC_INFO, 0x0394),	// CVTTPS2PI
	/*0x01C9*/ MAKE_OPWORD(OC_INFO, 0x0395),	// CVTTPD2PI
	/*0x01CA*/ MAKE_OPWORD(OC_INFO, 0x0396),	// CVTTSS2SI
	/*0x01CB*/ MAKE_OPWORD(OC_INFO, 0x0397),	// CVTTSD2SI
	/*0x01CC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CE*/ MAKE_OPWORD(OC_INFOEX, 0x002E),	// VCVTTSS2SI
	/*0x01CF*/ MAKE_OPWORD(OC_INFOEX, 0x002F),	// VCVTTSD2SI
	/*0x01D0*/ MAKE_OPWORD(OC_INFO, 0x0398),	// CVTPS2PI
	/*0x01D1*/ MAKE_OPWORD(OC_INFO, 0x0399),	// CVTPD2PI
	/*0x01D2*/ MAKE_OPWORD(OC_INFO, 0x039A),	// CVTSS2SI
	/*0x01D3*/ MAKE_OPWORD(OC_INFO, 0x039B),	// CVTSD2SI
	/*0x01D4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D6*/ MAKE_OPWORD(OC_INFOEX, 0x0030),	// VCVTSS2SI
	/*0x01D7*/ MAKE_OPWORD(OC_INFOEX, 0x0031),	// VCVTSD2SI
	/*0x01D8*/ MAKE_OPWORD(OC_INFO, 0x039C),	// UCOMISS
	/*0x01D9*/ MAKE_OPWORD(OC_INFO, 0x039D),	// UCOMISD
	/*0x01DA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01DB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01DC*/ MAKE_OPWORD(OC_INFOEX, 0x0032),	// VUCOMISS
	/*0x01DD*/ MAKE_OPWORD(OC_INFOEX, 0x0033),	// VUCOMISD
	/*0x01DE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01DF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E0*/ MAKE_OPWORD(OC_INFO, 0x039E),	// COMISS
	/*0x01E1*/ MAKE_OPWORD(OC_INFO, 0x039F),	// COMISD
	/*0x01E2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E4*/ MAKE_OPWORD(OC_INFOEX, 0x0034),	// VCOMISS
	/*0x01E5*/ MAKE_OPWORD(OC_INFOEX, 0x0035),	// VCOMISD
	/*0x01E6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E8*/ MAKE_OPWORD(OC_INFO, 0x03A0),	// MOVMSKPS
	/*0x01E9*/ MAKE_OPWORD(OC_INFO, 0x03A1),	// MOVMSKPD
	/*0x01EA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01EB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01EC*/ MAKE_OPWORD(OC_INFOEX, 0x0036),	// VMOVMSKPS
	/*0x01ED*/ MAKE_OPWORD(OC_INFOEX, 0x0037),	// VMOVMSKPD
	/*0x01EE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01EF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F0*/ MAKE_OPWORD(OC_INFO, 0x03A2),	// SQRTPS
	/*0x01F1*/ MAKE_OPWORD(OC_INFO, 0x03A3),	// SQRTPD
	/*0x01F2*/ MAKE_OPWORD(OC_INFO, 0x03A4),	// SQRTSS
	/*0x01F3*/ MAKE_OPWORD(OC_INFO, 0x03A5),	// SQRTSD
	/*0x01F4*/ MAKE_OPWORD(OC_INFOEX, 0x0038),	// VSQRTPS
	/*0x01F5*/ MAKE_OPWORD(OC_INFOEX, 0x0039),	// VSQRTPD
	/*0x01F6*/ MAKE_OPWORD(OC_INFOEX, 0x003A),	// VSQRTSS
	/*0x01F7*/ MAKE_OPWORD(OC_INFOEX, 0x003B),	// VSQRTSD
	/*0x01F8*/ MAKE_OPWORD(OC_INFO, 0x03A6),	// RSQRTPS
	/*0x01F9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FA*/ MAKE_OPWORD(OC_INFO, 0x03A7),	// RSQRTSS
	/*0x01FB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FC*/ MAKE_OPWORD(OC_INFOEX, 0x003C),	// VRSQRTPS
	/*0x01FD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FE*/ MAKE_OPWORD(OC_INFOEX, 0x003D),	// VRSQRTSS
	/*0x01FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0200*/ MAKE_OPWORD(OC_INFO, 0x03A8),	// RCPPS
	/*0x0201*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0202*/ MAKE_OPWORD(OC_INFO, 0x03A9),	// RCPSS
	/*0x0203*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0204*/ MAKE_OPWORD(OC_INFOEX, 0x003E),	// VRCPPS
	/*0x0205*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0206*/ MAKE_OPWORD(OC_INFOEX, 0x003F),	// VRCPSS
	/*0x0207*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0208*/ MAKE_OPWORD(OC_INFO, 0x03AA),	// ANDPS
	/*0x0209*/ MAKE_OPWORD(OC_INFO, 0x03AB),	// ANDPD
	/*0x020A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x020B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x020C*/ MAKE_OPWORD(OC_INFOEX, 0x0040),	// VANDPS
	/*0x020D*/ MAKE_OPWORD(OC_INFOEX, 0x0041),	// VANDPD
	/*0x020E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x020F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0210*/ MAKE_OPWORD(OC_INFO, 0x03AC),	// ANDNPS
	/*0x0211*/ MAKE_OPWORD(OC_INFO, 0x03AD),	// ANDNPD
	/*0x0212*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0213*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0214*/ MAKE_OPWORD(OC_INFOEX, 0x0042),	// VANDNPS
	/*0x0215*/ MAKE_OPWORD(OC_INFOEX, 0x0043),	// VANDNPD
	/*0x0216*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0217*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0218*/ MAKE_OPWORD(OC_INFO, 0x03AE),	// ORPS
	/*0x0219*/ MAKE_OPWORD(OC_INFO, 0x03AF),	// ORPD
	/*0x021A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x021B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x021C*/ MAKE_OPWORD(OC_INFOEX, 0x0044),	// VORPS
	/*0x021D*/ MAKE_OPWORD(OC_INFOEX, 0x0045),	// VORPD
	/*0x021E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x021F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0220*/ MAKE_OPWORD(OC_INFO, 0x03B0),	// XORPS
	/*0x0221*/ MAKE_OPWORD(OC_INFO, 0x03B1),	// XORPD
	/*0x0222*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0223*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0224*/ MAKE_OPWORD(OC_INFOEX, 0x0046),	// VXORPS
	/*0x0225*/ MAKE_OPWORD(OC_INFOEX, 0x0047),	// VXORPD
	/*0x0226*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0227*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0228*/ MAKE_OPWORD(OC_INFO, 0x03B2),	// ADDPS
	/*0x0229*/ MAKE_OPWORD(OC_INFO, 0x03B3),	// ADDPD
	/*0x022A*/ MAKE_OPWORD(OC_INFO, 0x03B4),	// ADDSS
	/*0x022B*/ MAKE_OPWORD(OC_INFO, 0x03B5),	// ADDSD
	/*0x022C*/ MAKE_OPWORD(OC_INFOEX, 0x0048),	// VADDPS
	/*0x022D*/ MAKE_OPWORD(OC_INFOEX, 0x0049),	// VADDPD
	/*0x022E*/ MAKE_OPWORD(OC_INFOEX, 0x004A),	// VADDSS
	/*0x022F*/ MAKE_OPWORD(OC_INFOEX, 0x004B),	// VADDSD
	/*0x0230*/ MAKE_OPWORD(OC_INFO, 0x03B6),	// MULPS
	/*0x0231*/ MAKE_OPWORD(OC_INFO, 0x03B7),	// MULPD
	/*0x0232*/ MAKE_OPWORD(OC_INFO, 0x03B8),	// MULSS
	/*0x0233*/ MAKE_OPWORD(OC_INFO, 0x03B9),	// MULSD
	/*0x0234*/ MAKE_OPWORD(OC_INFOEX, 0x004C),	// VMULPS
	/*0x0235*/ MAKE_OPWORD(OC_INFOEX, 0x004D),	// VMULPD
	/*0x0236*/ MAKE_OPWORD(OC_INFOEX, 0x004E),	// VMULSS
	/*0x0237*/ MAKE_OPWORD(OC_INFOEX, 0x004F),	// VMULSD
	/*0x0238*/ MAKE_OPWORD(OC_INFO, 0x03BA),	// CVTPS2PD
	/*0x0239*/ MAKE_OPWORD(OC_INFO, 0x03BB),	// CVTPD2PS
	/*0x023A*/ MAKE_OPWORD(OC_INFO, 0x03BC),	// CVTSS2SD
	/*0x023B*/ MAKE_OPWORD(OC_INFO, 0x03BD),	// CVTSD2SS
	/*0x023C*/ MAKE_OPWORD(OC_INFOEX, 0x0050),	// VCVTPS2PD
	/*0x023D*/ MAKE_OPWORD(OC_INFOEX, 0x0051),	// VCVTPD2PS
	/*0x023E*/ MAKE_OPWORD(OC_INFOEX, 0x0052),	// VCVTSS2SD
	/*0x023F*/ MAKE_OPWORD(OC_INFOEX, 0x0053),	// VCVTSD2SS
	/*0x0240*/ MAKE_OPWORD(OC_INFO, 0x03BE),	// CVTDQ2PS
	/*0x0241*/ MAKE_OPWORD(OC_INFO, 0x03BF),	// CVTPS2DQ
	/*0x0242*/ MAKE_OPWORD(OC_INFO, 0x03C0),	// CVTTPS2DQ
	/*0x0243*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0244*/ MAKE_OPWORD(OC_INFOEX, 0x0054),	// VCVTDQ2PS
	/*0x0245*/ MAKE_OPWORD(OC_INFOEX, 0x0055),	// VCVTPS2DQ
	/*0x0246*/ MAKE_OPWORD(OC_INFOEX, 0x0056),	// VCVTTPS2DQ
	/*0x0247*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0248*/ MAKE_OPWORD(OC_INFO, 0x03C1),	// SUBPS
	/*0x0249*/ MAKE_OPWORD(OC_INFO, 0x03C2),	// SUBPD
	/*0x024A*/ MAKE_OPWORD(OC_INFO, 0x03C3),	// SUBSS
	/*0x024B*/ MAKE_OPWORD(OC_INFO, 0x03C4),	// SUBSD
	/*0x024C*/ MAKE_OPWORD(OC_INFOEX, 0x0057),	// VSUBPS
	/*0x024D*/ MAKE_OPWORD(OC_INFOEX, 0x0058),	// VSUBPD
	/*0x024E*/ MAKE_OPWORD(OC_INFOEX, 0x0059),	// VSUBSS
	/*0x024F*/ MAKE_OPWORD(OC_INFOEX, 0x005A),	// VSUBSD
	/*0x0250*/ MAKE_OPWORD(OC_INFO, 0x03C5),	// MINPS
	/*0x0251*/ MAKE_OPWORD(OC_INFO, 0x03C6),	// MINPD
	/*0x0252*/ MAKE_OPWORD(OC_INFO, 0x03C7),	// MINSS
	/*0x0253*/ MAKE_OPWORD(OC_INFO, 0x03C8),	// MINSD
	/*0x0254*/ MAKE_OPWORD(OC_INFOEX, 0x005B),	// VMINPS
	/*0x0255*/ MAKE_OPWORD(OC_INFOEX, 0x005C),	// VMINPD
	/*0x0256*/ MAKE_OPWORD(OC_INFOEX, 0x005D),	// VMINSS
	/*0x0257*/ MAKE_OPWORD(OC_INFOEX, 0x005E),	// VMINSD
	/*0x0258*/ MAKE_OPWORD(OC_INFO, 0x03C9),	// DIVPS
	/*0x0259*/ MAKE_OPWORD(OC_INFO, 0x03CA),	// DIVPD
	/*0x025A*/ MAKE_OPWORD(OC_INFO, 0x03CB),	// DIVSS
	/*0x025B*/ MAKE_OPWORD(OC_INFO, 0x03CC),	// DIVSD
	/*0x025C*/ MAKE_OPWORD(OC_INFOEX, 0x005F),	// VDIVPS
	/*0x025D*/ MAKE_OPWORD(OC_INFOEX, 0x0060),	// VDIVPD
	/*0x025E*/ MAKE_OPWORD(OC_INFOEX, 0x0061),	// VDIVSS
	/*0x025F*/ MAKE_OPWORD(OC_INFOEX, 0x0062),	// VDIVSD
	/*0x0260*/ MAKE_OPWORD(OC_INFO, 0x03CD),	// MAXPS
	/*0x0261*/ MAKE_OPWORD(OC_INFO, 0x03CE),	// MAXPD
	/*0x0262*/ MAKE_OPWORD(OC_INFO, 0x03CF),	// MAXSS
	/*0x0263*/ MAKE_OPWORD(OC_INFO, 0x03D0),	// MAXSD
	/*0x0264*/ MAKE_OPWORD(OC_INFOEX, 0x0063),	// VMAXPS
	/*0x0265*/ MAKE_OPWORD(OC_INFOEX, 0x0064),	// VMAXPD
	/*0x0266*/ MAKE_OPWORD(OC_INFOEX, 0x0065),	// VMAXSS
	/*0x0267*/ MAKE_OPWORD(OC_INFOEX, 0x0066),	// VMAXSD
	/*0x0268*/ MAKE_OPWORD(OC_INFO, 0x03D1),	// PUNPCKLBW
	/*0x0269*/ MAKE_OPWORD(OC_INFO, 0x03D2),	// PUNPCKLBW
	/*0x026A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x026B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x026C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x026D*/ MAKE_OPWORD(OC_INFOEX, 0x0067),	// VPUNPCKLBW
	/*0x026E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x026F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0270*/ MAKE_OPWORD(OC_INFO, 0x03D3),	// PUNPCKLWD
	/*0x0271*/ MAKE_OPWORD(OC_INFO, 0x03D4),	// PUNPCKLWD
	/*0x0272*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0273*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0274*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0275*/ MAKE_OPWORD(OC_INFOEX, 0x0068),	// VPUNPCKLWD
	/*0x0276*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0277*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0278*/ MAKE_OPWORD(OC_INFO, 0x03D5),	// PUNPCKLDQ
	/*0x0279*/ MAKE_OPWORD(OC_INFO, 0x03D6),	// PUNPCKLDQ
	/*0x027A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x027B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x027C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x027D*/ MAKE_OPWORD(OC_INFOEX, 0x0069),	// VPUNPCKLDQ
	/*0x027E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x027F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0280*/ MAKE_OPWORD(OC_INFO, 0x03D7),	// PACKSSWB
	/*0x0281*/ MAKE_OPWORD(OC_INFO, 0x03D8),	// PACKSSWB
	/*0x0282*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0283*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0284*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0285*/ MAKE_OPWORD(OC_INFOEX, 0x006A),	// VPACKSSWB
	/*0x0286*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0287*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0288*/ MAKE_OPWORD(OC_INFO, 0x03D9),	// PCMPGTB
	/*0x0289*/ MAKE_OPWORD(OC_INFO, 0x03DA),	// PCMPGTB
	/*0x028A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x028B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x028C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x028D*/ MAKE_OPWORD(OC_INFOEX, 0x006B),	// VPCMPGTB
	/*0x028E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x028F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0290*/ MAKE_OPWORD(OC_INFO, 0x03DB),	// PCMPGTW
	/*0x0291*/ MAKE_OPWORD(OC_INFO, 0x03DC),	// PCMPGTW
	/*0x0292*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0293*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0294*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0295*/ MAKE_OPWORD(OC_INFOEX, 0x006C),	// VPCMPGTW
	/*0x0296*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0297*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0298*/ MAKE_OPWORD(OC_INFO, 0x03DD),	// PCMPGTD
	/*0x0299*/ MAKE_OPWORD(OC_INFO, 0x03DE),	// PCMPGTD
	/*0x029A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029D*/ MAKE_OPWORD(OC_INFOEX, 0x006D),	// VPCMPGTD
	/*0x029E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A0*/ MAKE_OPWORD(OC_INFO, 0x03DF),	// PACKUSWB
	/*0x02A1*/ MAKE_OPWORD(OC_INFO, 0x03E0),	// PACKUSWB
	/*0x02A2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A5*/ MAKE_OPWORD(OC_INFOEX, 0x006E),	// VPACKUSWB
	/*0x02A6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A8*/ MAKE_OPWORD(OC_INFO, 0x03E1),	// PUNPCKHBW
	/*0x02A9*/ MAKE_OPWORD(OC_INFO, 0x03E2),	// PUNPCKHBW
	/*0x02AA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02AB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02AC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02AD*/ MAKE_OPWORD(OC_INFOEX, 0x006F),	// VPUNPCKHBW
	/*0x02AE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02AF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B0*/ MAKE_OPWORD(OC_INFO, 0x03E3),	// PUNPCKHWD
	/*0x02B1*/ MAKE_OPWORD(OC_INFO, 0x03E4),	// PUNPCKHWD
	/*0x02B2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B5*/ MAKE_OPWORD(OC_INFOEX, 0x0070),	// VPUNPCKHWD
	/*0x02B6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B8*/ MAKE_OPWORD(OC_INFO, 0x03E5),	// PUNPCKHDQ
	/*0x02B9*/ MAKE_OPWORD(OC_INFO, 0x03E6),	// PUNPCKHDQ
	/*0x02BA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02BB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02BC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02BD*/ MAKE_OPWORD(OC_INFOEX, 0x0071),	// VPUNPCKHDQ
	/*0x02BE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02BF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C0*/ MAKE_OPWORD(OC_INFO, 0x03E7),	// PACKSSDW
	/*0x02C1*/ MAKE_OPWORD(OC_INFO, 0x03E8),	// PACKSSDW
	/*0x02C2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C5*/ MAKE_OPWORD(OC_INFOEX, 0x0072),	// VPACKSSDW
	/*0x02C6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C9*/ MAKE_OPWORD(OC_INFO, 0x03E9),	// PUNPCKLQDQ
	/*0x02CA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CD*/ MAKE_OPWORD(OC_INFOEX, 0x0073),	// VPUNPCKLQDQ
	/*0x02CE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D1*/ MAKE_OPWORD(OC_INFO, 0x03EA),	// PUNPCKHQDQ
	/*0x02D2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D5*/ MAKE_OPWORD(OC_INFOEX, 0x0074),	// VPUNPCKHQDQ
	/*0x02D6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D8*/ MAKE_OPWORD(OC_INFOEX, 0x0075),	// MOVD
	/*0x02D9*/ MAKE_OPWORD(OC_INFOEX, 0x0076),	// MOVD
	/*0x02DA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02DB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02DC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02DD*/ MAKE_OPWORD(OC_INFOEX, 0x0077),	// VMOVD
	/*0x02DE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02DF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02E0*/ MAKE_OPWORD(OC_INFO, 0x03EB),	// MOVQ
	/*0x02E1*/ MAKE_OPWORD(OC_INFO, 0x03EC),	// MOVDQA
	/*0x02E2*/ MAKE_OPWORD(OC_INFO, 0x03ED),	// MOVDQU
	/*0x02E3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02E4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02E5*/ MAKE_OPWORD(OC_INFOEX, 0x0078),	// VMOVDQA
	/*0x02E6*/ MAKE_OPWORD(OC_INFOEX, 0x0079),	// VMOVDQU
	/*0x02E7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02E8*/ MAKE_OPWORD(OC_INFOEX, 0x007A),	// PSHUFW
	/*0x02E9*/ MAKE_OPWORD(OC_INFOEX, 0x007B),	// PSHUFD
	/*0x02EA*/ MAKE_OPWORD(OC_INFOEX, 0x007C),	// PSHUFHW
	/*0x02EB*/ MAKE_OPWORD(OC_INFOEX, 0x007D),	// PSHUFLW
	/*0x02EC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02ED*/ MAKE_OPWORD(OC_INFOEX, 0x007E),	// VPSHUFD
	/*0x02EE*/ MAKE_OPWORD(OC_INFOEX, 0x007F),	// VPSHUFHW
	/*0x02EF*/ MAKE_OPWORD(OC_INFOEX, 0x0080),	// VPSHUFLW
	/*0x02F0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F2*/ MAKE_OPWORD(OC_WITHPF, 0x02F8),	// 
	/*0x02F3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F4*/ MAKE_OPWORD(OC_WITHPF, 0x0300),	// 
	/*0x02F5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F6*/ MAKE_OPWORD(OC_WITHPF, 0x0308),	// 
	/*0x02F7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F8*/ MAKE_OPWORD(OC_INFO, 0x04C0),	// PSRLW
	/*0x02F9*/ MAKE_OPWORD(OC_INFO, 0x04C1),	// PSRLW
	/*0x02FA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02FB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02FC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02FD*/ MAKE_OPWORD(OC_INFOEX, 0x016F),	// VPSRLW
	/*0x02FE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0300*/ MAKE_OPWORD(OC_INFO, 0x04C2),	// PSRAW
	/*0x0301*/ MAKE_OPWORD(OC_INFO, 0x04C3),	// PSRAW
	/*0x0302*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0303*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0304*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0305*/ MAKE_OPWORD(OC_INFOEX, 0x0170),	// VPSRAW
	/*0x0306*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0307*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0308*/ MAKE_OPWORD(OC_INFO, 0x04C4),	// PSLLW
	/*0x0309*/ MAKE_OPWORD(OC_INFO, 0x04C5),	// PSLLW
	/*0x030A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x030B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x030C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x030D*/ MAKE_OPWORD(OC_INFOEX, 0x0171),	// VPSLLW
	/*0x030E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x030F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0310*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0311*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0312*/ MAKE_OPWORD(OC_WITHPF, 0x0318),	// 
	/*0x0313*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0314*/ MAKE_OPWORD(OC_WITHPF, 0x0320),	// 
	/*0x0315*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0316*/ MAKE_OPWORD(OC_WITHPF, 0x0328),	// 
	/*0x0317*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0318*/ MAKE_OPWORD(OC_INFO, 0x04C6),	// PSRLD
	/*0x0319*/ MAKE_OPWORD(OC_INFO, 0x04C7),	// PSRLD
	/*0x031A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x031B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x031C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x031D*/ MAKE_OPWORD(OC_INFOEX, 0x0172),	// VPSRLD
	/*0x031E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x031F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0320*/ MAKE_OPWORD(OC_INFO, 0x04C8),	// PSRAD
	/*0x0321*/ MAKE_OPWORD(OC_INFO, 0x04C9),	// PSRAD
	/*0x0322*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0323*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0324*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0325*/ MAKE_OPWORD(OC_INFOEX, 0x0173),	// VPSRAD
	/*0x0326*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0327*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0328*/ MAKE_OPWORD(OC_INFO, 0x04CA),	// PSLLD
	/*0x0329*/ MAKE_OPWORD(OC_INFO, 0x04CB),	// PSLLD
	/*0x032A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032D*/ MAKE_OPWORD(OC_INFOEX, 0x0174),	// VPSLLD
	/*0x032E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0330*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0331*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0332*/ MAKE_OPWORD(OC_WITHPF, 0x0338),	// 
	/*0x0333*/ MAKE_OPWORD(OC_WITHPF, 0x0340),	// 
	/*0x0334*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0335*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0336*/ MAKE_OPWORD(OC_WITHPF, 0x0348),	// 
	/*0x0337*/ MAKE_OPWORD(OC_WITHPF, 0x0350),	// 
	/*0x0338*/ MAKE_OPWORD(OC_INFO, 0x04CC),	// PSRLQ
	/*0x0339*/ MAKE_OPWORD(OC_INFO, 0x04CD),	// PSRLQ
	/*0x033A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x033B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x033C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x033D*/ MAKE_OPWORD(OC_INFOEX, 0x0175),	// VPSRLQ
	/*0x033E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x033F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0340*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0341*/ MAKE_OPWORD(OC_INFO, 0x04CE),	// PSRLDQ
	/*0x0342*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0343*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0344*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0345*/ MAKE_OPWORD(OC_INFOEX, 0x0176),	// VPSRLDQ
	/*0x0346*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0347*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0348*/ MAKE_OPWORD(OC_INFO, 0x04CF),	// PSLLQ
	/*0x0349*/ MAKE_OPWORD(OC_INFO, 0x04D0),	// PSLLQ
	/*0x034A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x034B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x034C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x034D*/ MAKE_OPWORD(OC_INFOEX, 0x0177),	// VPSLLQ
	/*0x034E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x034F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0350*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0351*/ MAKE_OPWORD(OC_INFO, 0x04D1),	// PSLLDQ
	/*0x0352*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0353*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0354*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0355*/ MAKE_OPWORD(OC_INFOEX, 0x0178),	// VPSLLDQ
	/*0x0356*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0357*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0358*/ MAKE_OPWORD(OC_INFO, 0x03EE),	// PCMPEQB
	/*0x0359*/ MAKE_OPWORD(OC_INFO, 0x03EF),	// PCMPEQB
	/*0x035A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x035B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x035C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x035D*/ MAKE_OPWORD(OC_INFOEX, 0x0081),	// VPCMPEQB
	/*0x035E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x035F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0360*/ MAKE_OPWORD(OC_INFO, 0x03F0),	// PCMPEQW
	/*0x0361*/ MAKE_OPWORD(OC_INFO, 0x03F1),	// PCMPEQW
	/*0x0362*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0363*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0364*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0365*/ MAKE_OPWORD(OC_INFOEX, 0x0082),	// VPCMPEQW
	/*0x0366*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0367*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0368*/ MAKE_OPWORD(OC_INFO, 0x03F2),	// PCMPEQD
	/*0x0369*/ MAKE_OPWORD(OC_INFO, 0x03F3),	// PCMPEQD
	/*0x036A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036D*/ MAKE_OPWORD(OC_INFOEX, 0x0083),	// VPCMPEQD
	/*0x036E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0370*/ MAKE_OPWORD(OC_INFO, 0x03F4),	// EMMS
	/*0x0371*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0372*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0373*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0374*/ MAKE_OPWORD(OC_INFOEX, 0x0084),	// VZEROUPPER
	/*0x0375*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0376*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0377*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0378*/ MAKE_OPWORD(OC_INFO, 0x03F5),	// VMREAD
	/*0x0379*/ MAKE_OPWORD(OC_INFOEX, 0x0085),	// EXTRQ
	/*0x037A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x037B*/ MAKE_OPWORD(OC_INFOEX, 0x0086),	// INSERTQ
	/*0x037C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x037D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x037E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x037F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0380*/ MAKE_OPWORD(OC_INFO, 0x03F6),	// VMWRITE
	/*0x0381*/ MAKE_OPWORD(OC_INFO, 0x03F7),	// EXTRQ
	/*0x0382*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0383*/ MAKE_OPWORD(OC_INFO, 0x03F8),	// INSERTQ
	/*0x0384*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0385*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0386*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0387*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0388*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0389*/ MAKE_OPWORD(OC_INFO, 0x03FB),	// HADDPD
	/*0x038A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x038B*/ MAKE_OPWORD(OC_INFO, 0x03FC),	// HADDPS
	/*0x038C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x038D*/ MAKE_OPWORD(OC_INFOEX, 0x0087),	// VHADDPD
	/*0x038E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x038F*/ MAKE_OPWORD(OC_INFOEX, 0x0088),	// VHADDPS
	/*0x0390*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0391*/ MAKE_OPWORD(OC_INFO, 0x03FD),	// HSUBPD
	/*0x0392*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0393*/ MAKE_OPWORD(OC_INFO, 0x03FE),	// HSUBPS
	/*0x0394*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0395*/ MAKE_OPWORD(OC_INFOEX, 0x0089),	// VHSUBPD
	/*0x0396*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0397*/ MAKE_OPWORD(OC_INFOEX, 0x008A),	// VHSUBPS
	/*0x0398*/ MAKE_OPWORD(OC_INFOEX, 0x008B),	// MOVD
	/*0x0399*/ MAKE_OPWORD(OC_INFOEX, 0x008C),	// MOVD
	/*0x039A*/ MAKE_OPWORD(OC_INFO, 0x03FF),	// MOVQ
	/*0x039B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039D*/ MAKE_OPWORD(OC_INFOEX, 0x008D),	// VMOVD
	/*0x039E*/ MAKE_OPWORD(OC_INFOEX, 0x008E),	// VMOVQ
	/*0x039F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A0*/ MAKE_OPWORD(OC_INFO, 0x0400),	// MOVQ
	/*0x03A1*/ MAKE_OPWORD(OC_INFO, 0x0401),	// MOVDQA
	/*0x03A2*/ MAKE_OPWORD(OC_INFO, 0x0402),	// MOVDQU
	/*0x03A3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A5*/ MAKE_OPWORD(OC_INFOEX, 0x008F),	// VMOVDQA
	/*0x03A6*/ MAKE_OPWORD(OC_INFOEX, 0x0090),	// VMOVDQU
	/*0x03A7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A8*/ MAKE_OPWORD(OC_INFOEX, 0x0179),	// FXSAVE
	/*0x03A9*/ MAKE_OPWORD(OC_INFOEX, 0x017A),	// FXRSTOR
	/*0x03AA*/ MAKE_OPWORD(OC_WITHPF, 0x03B8),	// 
	/*0x03AB*/ MAKE_OPWORD(OC_WITHPF, 0x03C0),	// 
	/*0x03AC*/ MAKE_OPWORD(OC_INFOEX, 0x0091),	// XSAVE
	/*0x03AD*/ MAKE_OPWORD(OC_INFOEX, 0x0092),	// XRSTOR
	/*0x03AE*/ MAKE_OPWORD(OC_INFOEX, 0x0093),	// XSAVEOPT
	/*0x03AF*/ MAKE_OPWORD(OC_INFOEX, 0x0094),	// CLFLUSH
	/*0x03B0*/ MAKE_OPWORD(OC_INFO, 0x04D2),	// RDFSBASE
	/*0x03B1*/ MAKE_OPWORD(OC_INFO, 0x04D3),	// RDGSBASE
	/*0x03B2*/ MAKE_OPWORD(OC_INFO, 0x04D5),	// WRFSBASE
	/*0x03B3*/ MAKE_OPWORD(OC_INFO, 0x04D7),	// WRGSBASE
	/*0x03B4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B5*/ MAKE_OPWORD(OC_INFO, 0x04DE),	// LFENCE
	/*0x03B6*/ MAKE_OPWORD(OC_INFO, 0x04DF),	// MFENCE
	/*0x03B7*/ MAKE_OPWORD(OC_INFO, 0x04E0),	// SFENCE
	/*0x03B8*/ MAKE_OPWORD(OC_INFO, 0x04D4),	// LDMXCSR
	/*0x03B9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BC*/ MAKE_OPWORD(OC_INFOEX, 0x017B),	// VLDMXCSR
	/*0x03BD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C0*/ MAKE_OPWORD(OC_INFO, 0x04D6),	// STMXCSR
	/*0x03C1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C4*/ MAKE_OPWORD(OC_INFOEX, 0x017C),	// VSTMXCSR
	/*0x03C5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03CA*/ MAKE_OPWORD(OC_INFO, 0x0403),	// POPCNT
	/*0x03CB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03CC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03CD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03CE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03CF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D4*/ MAKE_OPWORD(OC_INFO, 0x0404),	// BT
	/*0x03D5*/ MAKE_OPWORD(OC_INFO, 0x0405),	// BTS
	/*0x03D6*/ MAKE_OPWORD(OC_INFO, 0x0406),	// BTR
	/*0x03D7*/ MAKE_OPWORD(OC_INFO, 0x0407),	// BTC
	/*0x03D8*/ MAKE_OPWORD(OC_INFO, 0x0408),	// BSF
	/*0x03D9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DA*/ MAKE_OPWORD(OC_INFO, 0x0409),	// TZCNT
	/*0x03DB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E0*/ MAKE_OPWORD(OC_INFO, 0x040A),	// BSR
	/*0x03E1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E2*/ MAKE_OPWORD(OC_INFO, 0x040B),	// LZCNT
	/*0x03E3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E8*/ MAKE_OPWORD(OC_INFOEX, 0x0095),	// CMPEQPS
	/*0x03E9*/ MAKE_OPWORD(OC_INFOEX, 0x0096),	// CMPEQPD
	/*0x03EA*/ MAKE_OPWORD(OC_INFOEX, 0x0097),	// CMPEQSS
	/*0x03EB*/ MAKE_OPWORD(OC_INFOEX, 0x0098),	// CMPEQSD
	/*0x03EC*/ MAKE_OPWORD(OC_INFOEX, 0x0099),	// VCMPEQPS
	/*0x03ED*/ MAKE_OPWORD(OC_INFOEX, 0x009A),	// VCMPEQPD
	/*0x03EE*/ MAKE_OPWORD(OC_INFOEX, 0x009B),	// VCMPEQSS
	/*0x03EF*/ MAKE_OPWORD(OC_INFOEX, 0x009C),	// VCMPEQSD
	/*0x03F0*/ MAKE_OPWORD(OC_INFOEX, 0x009D),	// PINSRW
	/*0x03F1*/ MAKE_OPWORD(OC_INFOEX, 0x009E),	// PINSRW
	/*0x03F2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F5*/ MAKE_OPWORD(OC_INFOEX, 0x009F),	// VPINSRW
	/*0x03F6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F8*/ MAKE_OPWORD(OC_INFOEX, 0x00A0),	// PEXTRW
	/*0x03F9*/ MAKE_OPWORD(OC_INFOEX, 0x00A1),	// PEXTRW
	/*0x03FA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03FB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03FC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03FD*/ MAKE_OPWORD(OC_INFOEX, 0x00A2),	// VPEXTRW
	/*0x03FE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0400*/ MAKE_OPWORD(OC_INFOEX, 0x00A3),	// SHUFPS
	/*0x0401*/ MAKE_OPWORD(OC_INFOEX, 0x00A4),	// SHUFPD
	/*0x0402*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0403*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0404*/ MAKE_OPWORD(OC_INFOEX, 0x00A5),	// VSHUFPS
	/*0x0405*/ MAKE_OPWORD(OC_INFOEX, 0x00A6),	// VSHUFPD
	/*0x0406*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0407*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0408*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0409*/ MAKE_OPWORD(OC_INFOEX, 0x00A7),	// CMPXCHG8B
	/*0x040A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x040B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x040C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x040D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x040E*/ MAKE_OPWORD(OC_WITHPF, 0x0418),	// 
	/*0x040F*/ MAKE_OPWORD(OC_INFO, 0x040C),	// VMPTRST
	/*0x0410*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0411*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0412*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0413*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0414*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0415*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0416*/ MAKE_OPWORD(OC_INFO, 0x04E1),	// RDRAND
	/*0x0417*/ MAKE_OPWORD(OC_INFO, 0x04E2),	// RDSEED
	/*0x0418*/ MAKE_OPWORD(OC_INFO, 0x04D8),	// VMPTRLD
	/*0x0419*/ MAKE_OPWORD(OC_INFO, 0x04D9),	// VMCLEAR
	/*0x041A*/ MAKE_OPWORD(OC_INFO, 0x04DA),	// VMXON
	/*0x041B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x041C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x041D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x041E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x041F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0420*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0421*/ MAKE_OPWORD(OC_INFO, 0x040D),	// ADDSUBPD
	/*0x0422*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0423*/ MAKE_OPWORD(OC_INFO, 0x040E),	// ADDSUBPS
	/*0x0424*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0425*/ MAKE_OPWORD(OC_INFOEX, 0x00A8),	// VADDSUBPD
	/*0x0426*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0427*/ MAKE_OPWORD(OC_INFOEX, 0x00A9),	// VADDSUBPS
	/*0x0428*/ MAKE_OPWORD(OC_INFO, 0x040F),	// PSRLW
	/*0x0429*/ MAKE_OPWORD(OC_INFO, 0x0410),	// PSRLW
	/*0x042A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x042B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x042C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x042D*/ MAKE_OPWORD(OC_INFOEX, 0x00AA),	// VPSRLW
	/*0x042E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x042F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0430*/ MAKE_OPWORD(OC_INFO, 0x0411),	// PSRLD
	/*0x0431*/ MAKE_OPWORD(OC_INFO, 0x0412),	// PSRLD
	/*0x0432*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0433*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0434*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0435*/ MAKE_OPWORD(OC_INFOEX, 0x00AB),	// VPSRLD
	/*0x0436*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0437*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0438*/ MAKE_OPWORD(OC_INFO, 0x0413),	// PSRLQ
	/*0x0439*/ MAKE_OPWORD(OC_INFO, 0x0414),	// PSRLQ
	/*0x043A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x043B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x043C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x043D*/ MAKE_OPWORD(OC_INFOEX, 0x00AC),	// VPSRLQ
	/*0x043E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x043F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0440*/ MAKE_OPWORD(OC_INFO, 0x0415),	// PADDQ
	/*0x0441*/ MAKE_OPWORD(OC_INFO, 0x0416),	// PADDQ
	/*0x0442*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0443*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0444*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0445*/ MAKE_OPWORD(OC_INFOEX, 0x00AD),	// VPADDQ
	/*0x0446*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0447*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0448*/ MAKE_OPWORD(OC_INFO, 0x0417),	// PMULLW
	/*0x0449*/ MAKE_OPWORD(OC_INFO, 0x0418),	// PMULLW
	/*0x044A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x044B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x044C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x044D*/ MAKE_OPWORD(OC_INFOEX, 0x00AE),	// VPMULLW
	/*0x044E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x044F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0450*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0451*/ MAKE_OPWORD(OC_INFO, 0x0419),	// MOVQ
	/*0x0452*/ MAKE_OPWORD(OC_INFO, 0x041A),	// MOVQ2DQ
	/*0x0453*/ MAKE_OPWORD(OC_INFO, 0x041B),	// MOVDQ2Q
	/*0x0454*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0455*/ MAKE_OPWORD(OC_INFOEX, 0x00AF),	// VMOVQ
	/*0x0456*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0457*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0458*/ MAKE_OPWORD(OC_INFO, 0x041C),	// PMOVMSKB
	/*0x0459*/ MAKE_OPWORD(OC_INFO, 0x041D),	// PMOVMSKB
	/*0x045A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x045B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x045C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x045D*/ MAKE_OPWORD(OC_INFOEX, 0x00B0),	// VPMOVMSKB
	/*0x045E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x045F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0460*/ MAKE_OPWORD(OC_INFO, 0x041E),	// PSUBUSB
	/*0x0461*/ MAKE_OPWORD(OC_INFO, 0x041F),	// PSUBUSB
	/*0x0462*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0463*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0464*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0465*/ MAKE_OPWORD(OC_INFOEX, 0x00B1),	// VPSUBUSB
	/*0x0466*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0467*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0468*/ MAKE_OPWORD(OC_INFO, 0x0420),	// PSUBUSW
	/*0x0469*/ MAKE_OPWORD(OC_INFO, 0x0421),	// PSUBUSW
	/*0x046A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x046B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x046C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x046D*/ MAKE_OPWORD(OC_INFOEX, 0x00B2),	// VPSUBUSW
	/*0x046E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x046F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0470*/ MAKE_OPWORD(OC_INFO, 0x0422),	// PMINUB
	/*0x0471*/ MAKE_OPWORD(OC_INFO, 0x0423),	// PMINUB
	/*0x0472*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0473*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0474*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0475*/ MAKE_OPWORD(OC_INFOEX, 0x00B3),	// VPMINUB
	/*0x0476*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0477*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0478*/ MAKE_OPWORD(OC_INFO, 0x0424),	// PAND
	/*0x0479*/ MAKE_OPWORD(OC_INFO, 0x0425),	// PAND
	/*0x047A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x047B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x047C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x047D*/ MAKE_OPWORD(OC_INFOEX, 0x00B4),	// VPAND
	/*0x047E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x047F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0480*/ MAKE_OPWORD(OC_INFO, 0x0426),	// PADDUSB
	/*0x0481*/ MAKE_OPWORD(OC_INFO, 0x0427),	// PADDUSB
	/*0x0482*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0483*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0484*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0485*/ MAKE_OPWORD(OC_INFOEX, 0x00B5),	// VPADDUSW
	/*0x0486*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0487*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0488*/ MAKE_OPWORD(OC_INFO, 0x0428),	// PADDUSW
	/*0x0489*/ MAKE_OPWORD(OC_INFO, 0x0429),	// PADDUSW
	/*0x048A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x048B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x048C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x048D*/ MAKE_OPWORD(OC_INFOEX, 0x00B6),	// VPADDUSW
	/*0x048E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x048F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0490*/ MAKE_OPWORD(OC_INFO, 0x042A),	// PMAXUB
	/*0x0491*/ MAKE_OPWORD(OC_INFO, 0x042B),	// PMAXUB
	/*0x0492*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0493*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0494*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0495*/ MAKE_OPWORD(OC_INFOEX, 0x00B7),	// VPMAXUB
	/*0x0496*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0497*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0498*/ MAKE_OPWORD(OC_INFO, 0x042C),	// PANDN
	/*0x0499*/ MAKE_OPWORD(OC_INFO, 0x042D),	// PANDN
	/*0x049A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x049B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x049C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x049D*/ MAKE_OPWORD(OC_INFOEX, 0x00B8),	// VPANDN
	/*0x049E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x049F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A0*/ MAKE_OPWORD(OC_INFO, 0x042E),	// PAVGB
	/*0x04A1*/ MAKE_OPWORD(OC_INFO, 0x042F),	// PAVGB
	/*0x04A2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A5*/ MAKE_OPWORD(OC_INFOEX, 0x00B9),	// VPAVGB
	/*0x04A6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A8*/ MAKE_OPWORD(OC_INFO, 0x0430),	// PSRAW
	/*0x04A9*/ MAKE_OPWORD(OC_INFO, 0x0431),	// PSRAW
	/*0x04AA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04AB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04AC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04AD*/ MAKE_OPWORD(OC_INFOEX, 0x00BA),	// VPSRAW
	/*0x04AE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04AF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B0*/ MAKE_OPWORD(OC_INFO, 0x0432),	// PSRAD
	/*0x04B1*/ MAKE_OPWORD(OC_INFO, 0x0433),	// PSRAD
	/*0x04B2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B5*/ MAKE_OPWORD(OC_INFOEX, 0x00BB),	// VPSRAD
	/*0x04B6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B8*/ MAKE_OPWORD(OC_INFO, 0x0434),	// PAVGW
	/*0x04B9*/ MAKE_OPWORD(OC_INFO, 0x0435),	// PAVGW
	/*0x04BA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04BB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04BC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04BD*/ MAKE_OPWORD(OC_INFOEX, 0x00BC),	// VPAVGW
	/*0x04BE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04BF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C0*/ MAKE_OPWORD(OC_INFO, 0x0436),	// PMULHUW
	/*0x04C1*/ MAKE_OPWORD(OC_INFO, 0x0437),	// PMULHUW
	/*0x04C2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C5*/ MAKE_OPWORD(OC_INFOEX, 0x00BD),	// VPMULHUW
	/*0x04C6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C8*/ MAKE_OPWORD(OC_INFO, 0x0438),	// PMULHW
	/*0x04C9*/ MAKE_OPWORD(OC_INFO, 0x0439),	// PMULHW
	/*0x04CA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04CB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04CC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04CD*/ MAKE_OPWORD(OC_INFOEX, 0x00BE),	// VPMULHW
	/*0x04CE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04CF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04D0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04D1*/ MAKE_OPWORD(OC_INFO, 0x043A),	// CVTTPD2DQ
	/*0x04D2*/ MAKE_OPWORD(OC_INFO, 0x043B),	// CVTDQ2PD
	/*0x04D3*/ MAKE_OPWORD(OC_INFO, 0x043C),	// CVTPD2DQ
	/*0x04D4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04D5*/ MAKE_OPWORD(OC_INFOEX, 0x00BF),	// VCVTTPD2DQ
	/*0x04D6*/ MAKE_OPWORD(OC_INFOEX, 0x00C0),	// VCVTDQ2PD
	/*0x04D7*/ MAKE_OPWORD(OC_INFOEX, 0x00C1),	// VCVTPD2DQ
	/*0x04D8*/ MAKE_OPWORD(OC_INFO, 0x043D),	// MOVNTQ
	/*0x04D9*/ MAKE_OPWORD(OC_INFO, 0x043E),	// MOVNTDQ
	/*0x04DA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04DB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04DC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04DD*/ MAKE_OPWORD(OC_INFOEX, 0x00C2),	// VMOVNTDQ
	/*0x04DE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04DF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04E0*/ MAKE_OPWORD(OC_INFO, 0x043F),	// PSUBSB
	/*0x04E1*/ MAKE_OPWORD(OC_INFO, 0x0440),	// PSUBSB
	/*0x04E2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04E3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04E4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04E5*/ MAKE_OPWORD(OC_INFOEX, 0x00C3),	// VPSUBSB
	/*0x04E6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04E7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04E8*/ MAKE_OPWORD(OC_INFO, 0x0441),	// PSUBSW
	/*0x04E9*/ MAKE_OPWORD(OC_INFO, 0x0442),	// PSUBSW
	/*0x04EA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04EB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04EC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04ED*/ MAKE_OPWORD(OC_INFOEX, 0x00C4),	// VPSUBSW
	/*0x04EE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04EF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F0*/ MAKE_OPWORD(OC_INFO, 0x0443),	// PMINSW
	/*0x04F1*/ MAKE_OPWORD(OC_INFO, 0x0444),	// PMINSW
	/*0x04F2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F5*/ MAKE_OPWORD(OC_INFOEX, 0x00C5),	// VPMINSW
	/*0x04F6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F8*/ MAKE_OPWORD(OC_INFO, 0x0445),	// POR
	/*0x04F9*/ MAKE_OPWORD(OC_INFO, 0x0446),	// POR
	/*0x04FA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04FB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04FC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04FD*/ MAKE_OPWORD(OC_INFOEX, 0x00C6),	// VPOR
	/*0x04FE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0500*/ MAKE_OPWORD(OC_INFO, 0x0447),	// PADDSB
	/*0x0501*/ MAKE_OPWORD(OC_INFO, 0x0448),	// PADDSB
	/*0x0502*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0503*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0504*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0505*/ MAKE_OPWORD(OC_INFOEX, 0x00C7),	// VPADDSB
	/*0x0506*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0507*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0508*/ MAKE_OPWORD(OC_INFO, 0x0449),	// PADDSW
	/*0x0509*/ MAKE_OPWORD(OC_INFO, 0x044A),	// PADDSW
	/*0x050A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x050B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x050C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x050D*/ MAKE_OPWORD(OC_INFOEX, 0x00C8),	// VPADDSW
	/*0x050E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x050F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0510*/ MAKE_OPWORD(OC_INFO, 0x044B),	// PMAXSW
	/*0x0511*/ MAKE_OPWORD(OC_INFO, 0x044C),	// PMAXSW
	/*0x0512*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0513*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0514*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0515*/ MAKE_OPWORD(OC_INFOEX, 0x00C9),	// VPMAXSW
	/*0x0516*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0517*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0518*/ MAKE_OPWORD(OC_INFO, 0x044D),	// PXOR
	/*0x0519*/ MAKE_OPWORD(OC_INFO, 0x044E),	// PXOR
	/*0x051A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x051B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x051C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x051D*/ MAKE_OPWORD(OC_INFOEX, 0x00CA),	// VPXOR
	/*0x051E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x051F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0520*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0521*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0522*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0523*/ MAKE_OPWORD(OC_INFO, 0x044F),	// LDDQU
	/*0x0524*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0525*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0526*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0527*/ MAKE_OPWORD(OC_INFOEX, 0x00CB),	// VLDDQU
	/*0x0528*/ MAKE_OPWORD(OC_INFO, 0x0450),	// PSLLW
	/*0x0529*/ MAKE_OPWORD(OC_INFO, 0x0451),	// PSLLW
	/*0x052A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x052B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x052C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x052D*/ MAKE_OPWORD(OC_INFOEX, 0x00CC),	// VPSLLW
	/*0x052E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x052F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0530*/ MAKE_OPWORD(OC_INFO, 0x0452),	// PSLLD
	/*0x0531*/ MAKE_OPWORD(OC_INFO, 0x0453),	// PSLLD
	/*0x0532*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0533*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0534*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0535*/ MAKE_OPWORD(OC_INFOEX, 0x00CD),	// VPSLLD
	/*0x0536*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0537*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0538*/ MAKE_OPWORD(OC_INFO, 0x0454),	// PSLLQ
	/*0x0539*/ MAKE_OPWORD(OC_INFO, 0x0455),	// PSLLQ
	/*0x053A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x053B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x053C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x053D*/ MAKE_OPWORD(OC_INFOEX, 0x00CE),	// VPSLLQ
	/*0x053E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x053F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0540*/ MAKE_OPWORD(OC_INFO, 0x0456),	// PMULUDQ
	/*0x0541*/ MAKE_OPWORD(OC_INFO, 0x0457),	// PMULUDQ
	/*0x0542*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0543*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0544*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0545*/ MAKE_OPWORD(OC_INFOEX, 0x00CF),	// VPMULUDQ
	/*0x0546*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0547*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0548*/ MAKE_OPWORD(OC_INFO, 0x0458),	// PMADDWD
	/*0x0549*/ MAKE_OPWORD(OC_INFO, 0x0459),	// PMADDWD
	/*0x054A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x054B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x054C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x054D*/ MAKE_OPWORD(OC_INFOEX, 0x00D0),	// VPMADDWD
	/*0x054E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x054F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0550*/ MAKE_OPWORD(OC_INFO, 0x045A),	// PSADBW
	/*0x0551*/ MAKE_OPWORD(OC_INFO, 0x045B),	// PSADBW
	/*0x0552*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0553*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0554*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0555*/ MAKE_OPWORD(OC_INFOEX, 0x00D1),	// VPSADBW
	/*0x0556*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0557*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0558*/ MAKE_OPWORD(OC_INFO, 0x045C),	// MASKMOVQ
	/*0x0559*/ MAKE_OPWORD(OC_INFO, 0x045D),	// MASKMOVDQU
	/*0x055A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x055B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x055C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x055D*/ MAKE_OPWORD(OC_INFOEX, 0x00D2),	// VMASKMOVDQU
	/*0x055E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x055F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0560*/ MAKE_OPWORD(OC_INFO, 0x045E),	// PSUBB
	/*0x0561*/ MAKE_OPWORD(OC_INFO, 0x045F),	// PSUBB
	/*0x0562*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0563*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0564*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0565*/ MAKE_OPWORD(OC_INFOEX, 0x00D3),	// VPSUBB
	/*0x0566*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0567*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0568*/ MAKE_OPWORD(OC_INFO, 0x0460),	// PSUBW
	/*0x0569*/ MAKE_OPWORD(OC_INFO, 0x0461),	// PSUBW
	/*0x056A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x056B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x056C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x056D*/ MAKE_OPWORD(OC_INFOEX, 0x00D4),	// VPSUBW
	/*0x056E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x056F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0570*/ MAKE_OPWORD(OC_INFO, 0x0462),	// PSUBD
	/*0x0571*/ MAKE_OPWORD(OC_INFO, 0x0463),	// PSUBD
	/*0x0572*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0573*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0574*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0575*/ MAKE_OPWORD(OC_INFOEX, 0x00D5),	// VPSUBD
	/*0x0576*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0577*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0578*/ MAKE_OPWORD(OC_INFO, 0x0464),	// PSUBQ
	/*0x0579*/ MAKE_OPWORD(OC_INFO, 0x0465),	// PSUBQ
	/*0x057A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x057B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x057C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x057D*/ MAKE_OPWORD(OC_INFOEX, 0x00D6),	// VPSUBQ
	/*0x057E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x057F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0580*/ MAKE_OPWORD(OC_INFO, 0x0466),	// PADDB
	/*0x0581*/ MAKE_OPWORD(OC_INFO, 0x0467),	// PADDB
	/*0x0582*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0583*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0584*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0585*/ MAKE_OPWORD(OC_INFOEX, 0x00D7),	// VPADDB
	/*0x0586*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0587*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0588*/ MAKE_OPWORD(OC_INFO, 0x0468),	// PADDW
	/*0x0589*/ MAKE_OPWORD(OC_INFO, 0x0469),	// PADDW
	/*0x058A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x058B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x058C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x058D*/ MAKE_OPWORD(OC_INFOEX, 0x00D8),	// VPADDW
	/*0x058E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x058F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0590*/ MAKE_OPWORD(OC_INFO, 0x046A),	// PADDD
	/*0x0591*/ MAKE_OPWORD(OC_INFO, 0x046B),	// PADDD
	/*0x0592*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0593*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0594*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0595*/ MAKE_OPWORD(OC_INFOEX, 0x00D9),	// VPADDD
	/*0x0596*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0597*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
};

OPBYTE_INFO PEDisAsm::G_3B_38_TBL[CTBL_LEN_3B_38] =
{
	/*0x0000*/ MAKE_OPWORD(OC_WITHPF, 0x0100),	// 
	/*0x0001*/ MAKE_OPWORD(OC_WITHPF, 0x0108),	// 
	/*0x0002*/ MAKE_OPWORD(OC_WITHPF, 0x0110),	// 
	/*0x0003*/ MAKE_OPWORD(OC_WITHPF, 0x0118),	// 
	/*0x0004*/ MAKE_OPWORD(OC_WITHPF, 0x0120),	// 
	/*0x0005*/ MAKE_OPWORD(OC_WITHPF, 0x0128),	// 
	/*0x0006*/ MAKE_OPWORD(OC_WITHPF, 0x0130),	// 
	/*0x0007*/ MAKE_OPWORD(OC_WITHPF, 0x0138),	// 
	/*0x0008*/ MAKE_OPWORD(OC_WITHPF, 0x0140),	// 
	/*0x0009*/ MAKE_OPWORD(OC_WITHPF, 0x0148),	// 
	/*0x000A*/ MAKE_OPWORD(OC_WITHPF, 0x0150),	// 
	/*0x000B*/ MAKE_OPWORD(OC_WITHPF, 0x0158),	// 
	/*0x000C*/ MAKE_OPWORD(OC_WITHPF, 0x0160),	// 
	/*0x000D*/ MAKE_OPWORD(OC_WITHPF, 0x0168),	// 
	/*0x000E*/ MAKE_OPWORD(OC_WITHPF, 0x0170),	// 
	/*0x000F*/ MAKE_OPWORD(OC_WITHPF, 0x0178),	// 
	/*0x0010*/ MAKE_OPWORD(OC_WITHPF, 0x0180),	// 
	/*0x0011*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0012*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0013*/ MAKE_OPWORD(OC_WITHPF, 0x0188),	// 
	/*0x0014*/ MAKE_OPWORD(OC_WITHPF, 0x01F4),	// 
	/*0x0015*/ MAKE_OPWORD(OC_WITHPF, 0x01FC),	// 
	/*0x0016*/ MAKE_OPWORD(OC_WITHPF, 0x0204),	// 
	/*0x0017*/ MAKE_OPWORD(OC_WITHPF, 0x020C),	// 
	/*0x0018*/ MAKE_OPWORD(OC_WITHPF, 0x0214),	// 
	/*0x0019*/ MAKE_OPWORD(OC_WITHPF, 0x021C),	// 
	/*0x001A*/ MAKE_OPWORD(OC_WITHPF, 0x0224),	// 
	/*0x001B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001C*/ MAKE_OPWORD(OC_WITHPF, 0x022C),	// 
	/*0x001D*/ MAKE_OPWORD(OC_WITHPF, 0x0234),	// 
	/*0x001E*/ MAKE_OPWORD(OC_WITHPF, 0x023C),	// 
	/*0x001F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0020*/ MAKE_OPWORD(OC_WITHPF, 0x0244),	// 
	/*0x0021*/ MAKE_OPWORD(OC_WITHPF, 0x024C),	// 
	/*0x0022*/ MAKE_OPWORD(OC_WITHPF, 0x0254),	// 
	/*0x0023*/ MAKE_OPWORD(OC_WITHPF, 0x025C),	// 
	/*0x0024*/ MAKE_OPWORD(OC_WITHPF, 0x0264),	// 
	/*0x0025*/ MAKE_OPWORD(OC_WITHPF, 0x026C),	// 
	/*0x0026*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0027*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0028*/ MAKE_OPWORD(OC_WITHPF, 0x0274),	// 
	/*0x0029*/ MAKE_OPWORD(OC_WITHPF, 0x027C),	// 
	/*0x002A*/ MAKE_OPWORD(OC_WITHPF, 0x0284),	// 
	/*0x002B*/ MAKE_OPWORD(OC_WITHPF, 0x028C),	// 
	/*0x002C*/ MAKE_OPWORD(OC_WITHPF, 0x0294),	// 
	/*0x002D*/ MAKE_OPWORD(OC_WITHPF, 0x029C),	// 
	/*0x002E*/ MAKE_OPWORD(OC_WITHPF, 0x02A4),	// 
	/*0x002F*/ MAKE_OPWORD(OC_WITHPF, 0x02AC),	// 
	/*0x0030*/ MAKE_OPWORD(OC_WITHPF, 0x02B4),	// 
	/*0x0031*/ MAKE_OPWORD(OC_WITHPF, 0x02BC),	// 
	/*0x0032*/ MAKE_OPWORD(OC_WITHPF, 0x02C4),	// 
	/*0x0033*/ MAKE_OPWORD(OC_WITHPF, 0x02CC),	// 
	/*0x0034*/ MAKE_OPWORD(OC_WITHPF, 0x02D4),	// 
	/*0x0035*/ MAKE_OPWORD(OC_WITHPF, 0x02DC),	// 
	/*0x0036*/ MAKE_OPWORD(OC_WITHPF, 0x02E4),	// 
	/*0x0037*/ MAKE_OPWORD(OC_WITHPF, 0x02EC),	// 
	/*0x0038*/ MAKE_OPWORD(OC_WITHPF, 0x02F4),	// 
	/*0x0039*/ MAKE_OPWORD(OC_WITHPF, 0x02FC),	// 
	/*0x003A*/ MAKE_OPWORD(OC_WITHPF, 0x0304),	// 
	/*0x003B*/ MAKE_OPWORD(OC_WITHPF, 0x030C),	// 
	/*0x003C*/ MAKE_OPWORD(OC_WITHPF, 0x0314),	// 
	/*0x003D*/ MAKE_OPWORD(OC_WITHPF, 0x031C),	// 
	/*0x003E*/ MAKE_OPWORD(OC_WITHPF, 0x0324),	// 
	/*0x003F*/ MAKE_OPWORD(OC_WITHPF, 0x032C),	// 
	/*0x0040*/ MAKE_OPWORD(OC_WITHPF, 0x0334),	// 
	/*0x0041*/ MAKE_OPWORD(OC_WITHPF, 0x033C),	// 
	/*0x0042*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0043*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0044*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0045*/ MAKE_OPWORD(OC_WITHPF, 0x0344),	// 
	/*0x0046*/ MAKE_OPWORD(OC_WITHPF, 0x034C),	// 
	/*0x0047*/ MAKE_OPWORD(OC_WITHPF, 0x0354),	// 
	/*0x0048*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0049*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0050*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0051*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0052*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0053*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0054*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0055*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0056*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0057*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0058*/ MAKE_OPWORD(OC_WITHPF, 0x035C),	// 
	/*0x0059*/ MAKE_OPWORD(OC_WITHPF, 0x0364),	// 
	/*0x005A*/ MAKE_OPWORD(OC_WITHPF, 0x036C),	// 
	/*0x005B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0060*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0061*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0062*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0063*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0064*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0065*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0066*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0067*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0068*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0069*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0070*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0071*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0072*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0073*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0074*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0075*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0076*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0077*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0078*/ MAKE_OPWORD(OC_WITHPF, 0x0374),	// 
	/*0x0079*/ MAKE_OPWORD(OC_WITHPF, 0x037C),	// 
	/*0x007A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0080*/ MAKE_OPWORD(OC_WITHPF, 0x0384),	// 
	/*0x0081*/ MAKE_OPWORD(OC_WITHPF, 0x038C),	// 
	/*0x0082*/ MAKE_OPWORD(OC_WITHPF, 0x0394),	// 
	/*0x0083*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0084*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0085*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0086*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0087*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0088*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0089*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008C*/ MAKE_OPWORD(OC_WITHPF, 0x039C),	// 
	/*0x008D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008E*/ MAKE_OPWORD(OC_WITHPF, 0x03A4),	// 
	/*0x008F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0090*/ MAKE_OPWORD(OC_WITHPF, 0x03AC),	// 
	/*0x0091*/ MAKE_OPWORD(OC_WITHPF, 0x03B4),	// 
	/*0x0092*/ MAKE_OPWORD(OC_WITHPF, 0x03BC),	// 
	/*0x0093*/ MAKE_OPWORD(OC_WITHPF, 0x03C4),	// 
	/*0x0094*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0095*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0096*/ MAKE_OPWORD(OC_WITHPF, 0x03CC),	// 
	/*0x0097*/ MAKE_OPWORD(OC_WITHPF, 0x03D4),	// 
	/*0x0098*/ MAKE_OPWORD(OC_WITHPF, 0x03DC),	// 
	/*0x0099*/ MAKE_OPWORD(OC_WITHPF, 0x03E4),	// 
	/*0x009A*/ MAKE_OPWORD(OC_WITHPF, 0x03EC),	// 
	/*0x009B*/ MAKE_OPWORD(OC_WITHPF, 0x03F4),	// 
	/*0x009C*/ MAKE_OPWORD(OC_WITHPF, 0x03FC),	// 
	/*0x009D*/ MAKE_OPWORD(OC_WITHPF, 0x0404),	// 
	/*0x009E*/ MAKE_OPWORD(OC_WITHPF, 0x040C),	// 
	/*0x009F*/ MAKE_OPWORD(OC_WITHPF, 0x0414),	// 
	/*0x00A0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A6*/ MAKE_OPWORD(OC_WITHPF, 0x041C),	// 
	/*0x00A7*/ MAKE_OPWORD(OC_WITHPF, 0x0424),	// 
	/*0x00A8*/ MAKE_OPWORD(OC_WITHPF, 0x042C),	// 
	/*0x00A9*/ MAKE_OPWORD(OC_WITHPF, 0x0434),	// 
	/*0x00AA*/ MAKE_OPWORD(OC_WITHPF, 0x043C),	// 
	/*0x00AB*/ MAKE_OPWORD(OC_WITHPF, 0x0444),	// 
	/*0x00AC*/ MAKE_OPWORD(OC_WITHPF, 0x044C),	// 
	/*0x00AD*/ MAKE_OPWORD(OC_WITHPF, 0x0454),	// 
	/*0x00AE*/ MAKE_OPWORD(OC_WITHPF, 0x045C),	// 
	/*0x00AF*/ MAKE_OPWORD(OC_WITHPF, 0x0464),	// 
	/*0x00B0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B6*/ MAKE_OPWORD(OC_WITHPF, 0x046C),	// 
	/*0x00B7*/ MAKE_OPWORD(OC_WITHPF, 0x0474),	// 
	/*0x00B8*/ MAKE_OPWORD(OC_WITHPF, 0x047C),	// 
	/*0x00B9*/ MAKE_OPWORD(OC_WITHPF, 0x0484),	// 
	/*0x00BA*/ MAKE_OPWORD(OC_WITHPF, 0x048C),	// 
	/*0x00BB*/ MAKE_OPWORD(OC_WITHPF, 0x0494),	// 
	/*0x00BC*/ MAKE_OPWORD(OC_WITHPF, 0x049C),	// 
	/*0x00BD*/ MAKE_OPWORD(OC_WITHPF, 0x04A4),	// 
	/*0x00BE*/ MAKE_OPWORD(OC_WITHPF, 0x04AC),	// 
	/*0x00BF*/ MAKE_OPWORD(OC_WITHPF, 0x04B4),	// 
	/*0x00C0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DB*/ MAKE_OPWORD(OC_WITHPF, 0x04BC),	// 
	/*0x00DC*/ MAKE_OPWORD(OC_WITHPF, 0x04C4),	// 
	/*0x00DD*/ MAKE_OPWORD(OC_WITHPF, 0x04CC),	// 
	/*0x00DE*/ MAKE_OPWORD(OC_WITHPF, 0x04D4),	// 
	/*0x00DF*/ MAKE_OPWORD(OC_WITHPF, 0x04DC),	// 
	/*0x00E0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00ED*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F0*/ MAKE_OPWORD(OC_WITHPF, 0x04E4),	// 
	/*0x00F1*/ MAKE_OPWORD(OC_WITHPF, 0x04EC),	// 
	/*0x00F2*/ MAKE_OPWORD(OC_WITHPF, 0x04F4),	// 
	/*0x00F3*/ MAKE_OPWORD(OC_GRP_VEX, 0x04FC),	// 
	/*0x00F4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F5*/ MAKE_OPWORD(OC_WITHPF, 0x0500),	// 
	/*0x00F6*/ MAKE_OPWORD(OC_WITHPF, 0x0508),	// 
	/*0x00F7*/ MAKE_OPWORD(OC_WITHPF, 0x0510),	// 
	/*0x00F8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0100*/ MAKE_OPWORD(OC_INFO, 0x047A),	// PSHUFB
	/*0x0101*/ MAKE_OPWORD(OC_INFO, 0x047B),	// PSHUFB
	/*0x0102*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0103*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0104*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0105*/ MAKE_OPWORD(OC_INFOEX, 0x00DA),	// VPSHUFB
	/*0x0106*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0107*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0108*/ MAKE_OPWORD(OC_INFO, 0x047C),	// PHADDW
	/*0x0109*/ MAKE_OPWORD(OC_INFO, 0x047D),	// PHADDW
	/*0x010A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x010B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x010C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x010D*/ MAKE_OPWORD(OC_INFOEX, 0x00DB),	// VPHADDW
	/*0x010E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x010F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0110*/ MAKE_OPWORD(OC_INFO, 0x047E),	// PHADDD
	/*0x0111*/ MAKE_OPWORD(OC_INFO, 0x047F),	// PHADDD
	/*0x0112*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0113*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0114*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0115*/ MAKE_OPWORD(OC_INFOEX, 0x00DC),	// VPHADDD
	/*0x0116*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0117*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0118*/ MAKE_OPWORD(OC_INFO, 0x0480),	// PHADDSW
	/*0x0119*/ MAKE_OPWORD(OC_INFO, 0x0481),	// PHADDSW
	/*0x011A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011D*/ MAKE_OPWORD(OC_INFOEX, 0x00DD),	// VPHADDSW
	/*0x011E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0120*/ MAKE_OPWORD(OC_INFO, 0x0482),	// PMADDUBSW
	/*0x0121*/ MAKE_OPWORD(OC_INFO, 0x0483),	// PMADDUBSW
	/*0x0122*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0123*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0124*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0125*/ MAKE_OPWORD(OC_INFOEX, 0x00DE),	// VPMADDUBSW
	/*0x0126*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0127*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0128*/ MAKE_OPWORD(OC_INFO, 0x0484),	// PHSUBW
	/*0x0129*/ MAKE_OPWORD(OC_INFO, 0x0485),	// PHSUBW
	/*0x012A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x012B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x012C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x012D*/ MAKE_OPWORD(OC_INFOEX, 0x00DF),	// VPHSUBW
	/*0x012E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x012F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0130*/ MAKE_OPWORD(OC_INFO, 0x0486),	// PHSUBD
	/*0x0131*/ MAKE_OPWORD(OC_INFO, 0x0487),	// PHSUBD
	/*0x0132*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0133*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0134*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0135*/ MAKE_OPWORD(OC_INFOEX, 0x00E0),	// VPHSUBD
	/*0x0136*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0137*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0138*/ MAKE_OPWORD(OC_INFO, 0x0488),	// PHSUBSW
	/*0x0139*/ MAKE_OPWORD(OC_INFO, 0x0489),	// PHSUBSW
	/*0x013A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013D*/ MAKE_OPWORD(OC_INFOEX, 0x00E1),	// VPHSUBSW
	/*0x013E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0140*/ MAKE_OPWORD(OC_INFO, 0x048A),	// PSIGNB
	/*0x0141*/ MAKE_OPWORD(OC_INFO, 0x048B),	// PSIGNB
	/*0x0142*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0143*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0144*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0145*/ MAKE_OPWORD(OC_INFOEX, 0x00E2),	// VPSIGNB
	/*0x0146*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0147*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0148*/ MAKE_OPWORD(OC_INFO, 0x048C),	// PSIGNW
	/*0x0149*/ MAKE_OPWORD(OC_INFO, 0x048D),	// PSIGNW
	/*0x014A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x014B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x014C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x014D*/ MAKE_OPWORD(OC_INFOEX, 0x00E3),	// VPSIGNW
	/*0x014E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x014F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0150*/ MAKE_OPWORD(OC_INFO, 0x048E),	// PSIGND
	/*0x0151*/ MAKE_OPWORD(OC_INFO, 0x048F),	// PSIGND
	/*0x0152*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0153*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0154*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0155*/ MAKE_OPWORD(OC_INFOEX, 0x00E4),	// VPSIGND
	/*0x0156*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0157*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0158*/ MAKE_OPWORD(OC_INFO, 0x0490),	// PMULHRSW
	/*0x0159*/ MAKE_OPWORD(OC_INFO, 0x0491),	// PMULHRSW
	/*0x015A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x015B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x015C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x015D*/ MAKE_OPWORD(OC_INFOEX, 0x00E5),	// VPMULHRSW
	/*0x015E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x015F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0160*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0161*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0162*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0163*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0164*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0165*/ MAKE_OPWORD(OC_INFOEX, 0x00E6),	// VPERMILPS
	/*0x0166*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0167*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0168*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0169*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x016A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x016B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x016C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x016D*/ MAKE_OPWORD(OC_INFOEX, 0x00E7),	// VPERMILPD
	/*0x016E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x016F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0170*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0171*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0172*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0173*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0174*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0175*/ MAKE_OPWORD(OC_INFOEX, 0x00E8),	// VTESTPS
	/*0x0176*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0177*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0178*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0179*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x017A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x017B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x017C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x017D*/ MAKE_OPWORD(OC_INFOEX, 0x00E9),	// VTESTPD
	/*0x017E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x017F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0180*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0181*/ MAKE_OPWORD(OC_INFOEX, 0x00EA),	// PBLENDVB
	/*0x0182*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0183*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0184*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0185*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0186*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0187*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0188*/ MAKE_OPWORD(OC_WITHPF, 0x0194),	// 
	/*0x0189*/ MAKE_OPWORD(OC_WITHPF, 0x019C),	// 
	/*0x018A*/ MAKE_OPWORD(OC_WITHPF, 0x01A4),	// 
	/*0x018B*/ MAKE_OPWORD(OC_WITHPF, 0x01AC),	// 
	/*0x018C*/ MAKE_OPWORD(OC_WITHPF, 0x01B4),	// 
	/*0x018D*/ MAKE_OPWORD(OC_WITHPF, 0x01BC),	// 
	/*0x018E*/ MAKE_OPWORD(OC_WITHPF, 0x01C4),	// 
	/*0x018F*/ MAKE_OPWORD(OC_WITHPF, 0x01CC),	// 
	/*0x0190*/ MAKE_OPWORD(OC_WITHPF, 0x01D4),	// 
	/*0x0191*/ MAKE_OPWORD(OC_WITHPF, 0x01DC),	// 
	/*0x0192*/ MAKE_OPWORD(OC_WITHPF, 0x01E4),	// 
	/*0x0193*/ MAKE_OPWORD(OC_WITHPF, 0x01EC),	// 
	/*0x0194*/ MAKE_OPWORD(OC_INFO, 0x047A),	// PSHUFB
	/*0x0195*/ MAKE_OPWORD(OC_INFO, 0x047B),	// PSHUFB
	/*0x0196*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0197*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0198*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0199*/ MAKE_OPWORD(OC_INFOEX, 0x00DA),	// VPSHUFB
	/*0x019A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x019B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x019C*/ MAKE_OPWORD(OC_INFO, 0x047C),	// PHADDW
	/*0x019D*/ MAKE_OPWORD(OC_INFO, 0x047D),	// PHADDW
	/*0x019E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x019F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A1*/ MAKE_OPWORD(OC_INFOEX, 0x00DB),	// VPHADDW
	/*0x01A2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A4*/ MAKE_OPWORD(OC_INFO, 0x047E),	// PHADDD
	/*0x01A5*/ MAKE_OPWORD(OC_INFO, 0x047F),	// PHADDD
	/*0x01A6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A9*/ MAKE_OPWORD(OC_INFOEX, 0x00DC),	// VPHADDD
	/*0x01AA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01AB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01AC*/ MAKE_OPWORD(OC_INFO, 0x0480),	// PHADDSW
	/*0x01AD*/ MAKE_OPWORD(OC_INFO, 0x0481),	// PHADDSW
	/*0x01AE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01AF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B1*/ MAKE_OPWORD(OC_INFOEX, 0x00DD),	// VPHADDSW
	/*0x01B2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B4*/ MAKE_OPWORD(OC_INFO, 0x0482),	// PMADDUBSW
	/*0x01B5*/ MAKE_OPWORD(OC_INFO, 0x0483),	// PMADDUBSW
	/*0x01B6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B9*/ MAKE_OPWORD(OC_INFOEX, 0x00DE),	// VPMADDUBSW
	/*0x01BA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01BB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01BC*/ MAKE_OPWORD(OC_INFO, 0x0484),	// PHSUBW
	/*0x01BD*/ MAKE_OPWORD(OC_INFO, 0x0485),	// PHSUBW
	/*0x01BE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01BF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C1*/ MAKE_OPWORD(OC_INFOEX, 0x00DF),	// VPHSUBW
	/*0x01C2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C4*/ MAKE_OPWORD(OC_INFO, 0x0486),	// PHSUBD
	/*0x01C5*/ MAKE_OPWORD(OC_INFO, 0x0487),	// PHSUBD
	/*0x01C6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C9*/ MAKE_OPWORD(OC_INFOEX, 0x00E0),	// VPHSUBD
	/*0x01CA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CC*/ MAKE_OPWORD(OC_INFO, 0x0488),	// PHSUBSW
	/*0x01CD*/ MAKE_OPWORD(OC_INFO, 0x0489),	// PHSUBSW
	/*0x01CE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D1*/ MAKE_OPWORD(OC_INFOEX, 0x00E1),	// VPHSUBSW
	/*0x01D2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D4*/ MAKE_OPWORD(OC_INFO, 0x048A),	// PSIGNB
	/*0x01D5*/ MAKE_OPWORD(OC_INFO, 0x048B),	// PSIGNB
	/*0x01D6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D9*/ MAKE_OPWORD(OC_INFOEX, 0x00E2),	// VPSIGNB
	/*0x01DA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01DB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01DC*/ MAKE_OPWORD(OC_INFO, 0x048C),	// PSIGNW
	/*0x01DD*/ MAKE_OPWORD(OC_INFO, 0x048D),	// PSIGNW
	/*0x01DE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01DF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E1*/ MAKE_OPWORD(OC_INFOEX, 0x00E3),	// VPSIGNW
	/*0x01E2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E4*/ MAKE_OPWORD(OC_INFO, 0x048E),	// PSIGND
	/*0x01E5*/ MAKE_OPWORD(OC_INFO, 0x048F),	// PSIGND
	/*0x01E6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E9*/ MAKE_OPWORD(OC_INFOEX, 0x00E4),	// VPSIGND
	/*0x01EA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01EB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01EC*/ MAKE_OPWORD(OC_INFO, 0x0490),	// PMULHRSW
	/*0x01ED*/ MAKE_OPWORD(OC_INFO, 0x0491),	// PMULHRSW
	/*0x01EE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01EF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F1*/ MAKE_OPWORD(OC_INFOEX, 0x00E5),	// VPMULHRSW
	/*0x01F2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F5*/ MAKE_OPWORD(OC_INFOEX, 0x00EB),	// BLENDVPS
	/*0x01F6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FD*/ MAKE_OPWORD(OC_INFOEX, 0x00EC),	// BLENDVPD
	/*0x01FE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0200*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0201*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0202*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0203*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0204*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0205*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0206*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0207*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0208*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0209*/ MAKE_OPWORD(OC_INFOEX, 0x0185),	// VPERMPS
	/*0x020A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x020B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x020C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x020D*/ MAKE_OPWORD(OC_INFO, 0x0492),	// PTEST
	/*0x020E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x020F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0210*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0211*/ MAKE_OPWORD(OC_INFOEX, 0x00ED),	// VPTEST
	/*0x0212*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0213*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0214*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0215*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0216*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0217*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0218*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0219*/ MAKE_OPWORD(OC_INFOEX, 0x00EE),	// VBROADCASTSS
	/*0x021A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x021B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x021C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x021D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x021E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x021F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0220*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0221*/ MAKE_OPWORD(OC_INFOEX, 0x00EF),	// VBROADCASTSD
	/*0x0222*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0223*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0224*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0225*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0226*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0227*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0228*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0229*/ MAKE_OPWORD(OC_INFOEX, 0x00F0),	// VBROADCASTF128
	/*0x022A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x022B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x022C*/ MAKE_OPWORD(OC_INFO, 0x0493),	// PABSB
	/*0x022D*/ MAKE_OPWORD(OC_INFO, 0x0494),	// PABSB
	/*0x022E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x022F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0230*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0231*/ MAKE_OPWORD(OC_INFOEX, 0x00F1),	// VPABSB
	/*0x0232*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0233*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0234*/ MAKE_OPWORD(OC_INFO, 0x0495),	// PABSW
	/*0x0235*/ MAKE_OPWORD(OC_INFO, 0x0496),	// PABSW
	/*0x0236*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0237*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0238*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0239*/ MAKE_OPWORD(OC_INFOEX, 0x00F2),	// VPABSW
	/*0x023A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x023B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x023C*/ MAKE_OPWORD(OC_INFO, 0x0497),	// PABSD
	/*0x023D*/ MAKE_OPWORD(OC_INFO, 0x0498),	// PABSD
	/*0x023E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x023F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0240*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0241*/ MAKE_OPWORD(OC_INFOEX, 0x00F3),	// VPABSD
	/*0x0242*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0243*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0244*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0245*/ MAKE_OPWORD(OC_INFO, 0x0499),	// PMOVSXBW
	/*0x0246*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0247*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0248*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0249*/ MAKE_OPWORD(OC_INFOEX, 0x00F4),	// VPMOVSXBW
	/*0x024A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x024B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x024C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x024D*/ MAKE_OPWORD(OC_INFO, 0x049A),	// PMOVSXBD
	/*0x024E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x024F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0250*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0251*/ MAKE_OPWORD(OC_INFOEX, 0x00F5),	// VPMOVSXBD
	/*0x0252*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0253*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0254*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0255*/ MAKE_OPWORD(OC_INFO, 0x049B),	// PMOVSXBQ
	/*0x0256*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0257*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0258*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0259*/ MAKE_OPWORD(OC_INFOEX, 0x00F6),	// VPMOVSXBQ
	/*0x025A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x025B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x025C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x025D*/ MAKE_OPWORD(OC_INFO, 0x049C),	// PMOVSXWD
	/*0x025E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x025F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0260*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0261*/ MAKE_OPWORD(OC_INFOEX, 0x00F7),	// VPMOVSXWD
	/*0x0262*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0263*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0264*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0265*/ MAKE_OPWORD(OC_INFO, 0x049D),	// PMOVSXWQ
	/*0x0266*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0267*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0268*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0269*/ MAKE_OPWORD(OC_INFOEX, 0x00F8),	// VPMOVSXWQ
	/*0x026A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x026B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x026C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x026D*/ MAKE_OPWORD(OC_INFO, 0x049E),	// PMOVSXDQ
	/*0x026E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x026F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0270*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0271*/ MAKE_OPWORD(OC_INFOEX, 0x00F9),	// VPMOVSXDQ
	/*0x0272*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0273*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0274*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0275*/ MAKE_OPWORD(OC_INFO, 0x049F),	// PMULDQ
	/*0x0276*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0277*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0278*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0279*/ MAKE_OPWORD(OC_INFOEX, 0x00FA),	// VPMULDQ
	/*0x027A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x027B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x027C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x027D*/ MAKE_OPWORD(OC_INFO, 0x04A0),	// PCMPEQQ
	/*0x027E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x027F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0280*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0281*/ MAKE_OPWORD(OC_INFOEX, 0x00FB),	// VPCMPEQQ
	/*0x0282*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0283*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0284*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0285*/ MAKE_OPWORD(OC_INFO, 0x04A1),	// MOVNTDQA
	/*0x0286*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0287*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0288*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0289*/ MAKE_OPWORD(OC_INFOEX, 0x00FC),	// VMOVNTDQA
	/*0x028A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x028B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x028C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x028D*/ MAKE_OPWORD(OC_INFO, 0x04A2),	// PACKUSDW
	/*0x028E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x028F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0290*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0291*/ MAKE_OPWORD(OC_INFOEX, 0x00FD),	// VPACKUSDW
	/*0x0292*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0293*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0294*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0295*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0296*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0297*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0298*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0299*/ MAKE_OPWORD(OC_INFOEX, 0x00FE),	// VMASKMOVPS
	/*0x029A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x029F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A1*/ MAKE_OPWORD(OC_INFOEX, 0x00FF),	// VMASKMOVPD
	/*0x02A2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02A9*/ MAKE_OPWORD(OC_INFOEX, 0x0100),	// VMASKMOVPS
	/*0x02AA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02AB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02AC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02AD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02AE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02AF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B1*/ MAKE_OPWORD(OC_INFOEX, 0x0101),	// VMASKMOVPD
	/*0x02B2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B5*/ MAKE_OPWORD(OC_INFO, 0x04A3),	// PMOVZXBW
	/*0x02B6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02B9*/ MAKE_OPWORD(OC_INFOEX, 0x0102),	// VPMOVZXBW
	/*0x02BA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02BB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02BC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02BD*/ MAKE_OPWORD(OC_INFO, 0x04A4),	// PMOVZXBD
	/*0x02BE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02BF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C1*/ MAKE_OPWORD(OC_INFOEX, 0x0103),	// VPMOVZXBD
	/*0x02C2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C5*/ MAKE_OPWORD(OC_INFO, 0x04A5),	// PMOVZXBQ
	/*0x02C6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02C9*/ MAKE_OPWORD(OC_INFOEX, 0x0104),	// VPMOVZXBQ
	/*0x02CA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CD*/ MAKE_OPWORD(OC_INFO, 0x04A6),	// PMOVZXWD
	/*0x02CE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02CF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D1*/ MAKE_OPWORD(OC_INFOEX, 0x0105),	// VPMOVZXWD
	/*0x02D2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D5*/ MAKE_OPWORD(OC_INFO, 0x04A7),	// PMOVZXWQ
	/*0x02D6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02D9*/ MAKE_OPWORD(OC_INFOEX, 0x0106),	// VPMOVZXWQ
	/*0x02DA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02DB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02DC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02DD*/ MAKE_OPWORD(OC_INFO, 0x04A8),	// PMOVZXDQ
	/*0x02DE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02DF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02E0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02E1*/ MAKE_OPWORD(OC_INFOEX, 0x0107),	// VPMOVZXDQ
	/*0x02E2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02E3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02E4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02E5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02E6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02E7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02E8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02E9*/ MAKE_OPWORD(OC_INFOEX, 0x0186),	// VPERMD
	/*0x02EA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02EB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02EC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02ED*/ MAKE_OPWORD(OC_INFO, 0x04A9),	// PCMPGTQ
	/*0x02EE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02EF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F1*/ MAKE_OPWORD(OC_INFOEX, 0x0108),	// VPCMPGTQ
	/*0x02F2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F5*/ MAKE_OPWORD(OC_INFO, 0x04AA),	// PMINSB
	/*0x02F6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02F9*/ MAKE_OPWORD(OC_INFOEX, 0x0109),	// VPMINSB
	/*0x02FA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02FB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02FC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02FD*/ MAKE_OPWORD(OC_INFO, 0x04AB),	// PMINSD
	/*0x02FE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x02FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0300*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0301*/ MAKE_OPWORD(OC_INFOEX, 0x010A),	// VPMINSD
	/*0x0302*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0303*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0304*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0305*/ MAKE_OPWORD(OC_INFO, 0x04AC),	// PMINUW
	/*0x0306*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0307*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0308*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0309*/ MAKE_OPWORD(OC_INFOEX, 0x010B),	// VPMINUW
	/*0x030A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x030B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x030C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x030D*/ MAKE_OPWORD(OC_INFO, 0x04AD),	// PMINUD
	/*0x030E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x030F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0310*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0311*/ MAKE_OPWORD(OC_INFOEX, 0x010C),	// VPMINUD
	/*0x0312*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0313*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0314*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0315*/ MAKE_OPWORD(OC_INFO, 0x04AE),	// PMAXSB
	/*0x0316*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0317*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0318*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0319*/ MAKE_OPWORD(OC_INFOEX, 0x010D),	// VPMAXSB
	/*0x031A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x031B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x031C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x031D*/ MAKE_OPWORD(OC_INFO, 0x04AF),	// PMAXSD
	/*0x031E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x031F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0320*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0321*/ MAKE_OPWORD(OC_INFOEX, 0x010E),	// VPMAXSD
	/*0x0322*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0323*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0324*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0325*/ MAKE_OPWORD(OC_INFO, 0x04B0),	// PMAXUW
	/*0x0326*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0327*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0328*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0329*/ MAKE_OPWORD(OC_INFOEX, 0x010F),	// VPMAXUW
	/*0x032A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032D*/ MAKE_OPWORD(OC_INFO, 0x04B1),	// PMAXUD
	/*0x032E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x032F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0330*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0331*/ MAKE_OPWORD(OC_INFOEX, 0x0110),	// VPMAXUD
	/*0x0332*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0333*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0334*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0335*/ MAKE_OPWORD(OC_INFO, 0x04B2),	// PMULLD
	/*0x0336*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0337*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0338*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0339*/ MAKE_OPWORD(OC_INFOEX, 0x0111),	// VPMULLD
	/*0x033A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x033B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x033C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x033D*/ MAKE_OPWORD(OC_INFO, 0x04B3),	// PHMINPOSUW
	/*0x033E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x033F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0340*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0341*/ MAKE_OPWORD(OC_INFOEX, 0x0112),	// VPHMINPOSUW
	/*0x0342*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0343*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0344*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0345*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0346*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0347*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0348*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0349*/ MAKE_OPWORD(OC_INFOEX, 0x0187),	// VPSRLVD
	/*0x034A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x034B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x034C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x034D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x034E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x034F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0350*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0351*/ MAKE_OPWORD(OC_INFOEX, 0x0188),	// VPSRAVD
	/*0x0352*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0353*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0354*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0355*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0356*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0357*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0358*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0359*/ MAKE_OPWORD(OC_INFOEX, 0x0189),	// VPSLLVD
	/*0x035A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x035B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x035C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x035D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x035E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x035F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0360*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0361*/ MAKE_OPWORD(OC_INFOEX, 0x018A),	// VPBROADCASTD
	/*0x0362*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0363*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0364*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0365*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0366*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0367*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0368*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0369*/ MAKE_OPWORD(OC_INFOEX, 0x018B),	// VPBROADCASTQ
	/*0x036A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x036F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0370*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0371*/ MAKE_OPWORD(OC_INFOEX, 0x018C),	// VBROADCASTI128
	/*0x0372*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0373*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0374*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0375*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0376*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0377*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0378*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0379*/ MAKE_OPWORD(OC_INFOEX, 0x018D),	// VPBROADCASTB
	/*0x037A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x037B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x037C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x037D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x037E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x037F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0380*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0381*/ MAKE_OPWORD(OC_INFOEX, 0x018E),	// VPBROADCASTW
	/*0x0382*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0383*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0384*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0385*/ MAKE_OPWORD(OC_INFO, 0x04B4),	// INVEPT
	/*0x0386*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0387*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0388*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0389*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x038A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x038B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x038C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x038D*/ MAKE_OPWORD(OC_INFO, 0x04B5),	// INVVPID
	/*0x038E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x038F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0390*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0391*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0392*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0393*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0394*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0395*/ MAKE_OPWORD(OC_INFO, 0x04B6),	// INVPCID
	/*0x0396*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0397*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0398*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0399*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x039F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A1*/ MAKE_OPWORD(OC_INFOEX, 0x0193),	// VPMASKMOVD
	/*0x03A2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03A9*/ MAKE_OPWORD(OC_INFOEX, 0x0194),	// VPMASKMOVD
	/*0x03AA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03AB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03AC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03AD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03AE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03AF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B1*/ MAKE_OPWORD(OC_INFOEX, 0x018F),	// VPGATHERDD
	/*0x03B2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03B9*/ MAKE_OPWORD(OC_INFOEX, 0x0190),	// VPGATHERQD
	/*0x03BA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03BF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C1*/ MAKE_OPWORD(OC_INFOEX, 0x0191),	// VGATHERDPS
	/*0x03C2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03C9*/ MAKE_OPWORD(OC_INFOEX, 0x0192),	// VGATHERQPS
	/*0x03CA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03CB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03CC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03CD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03CE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03CF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D1*/ MAKE_OPWORD(OC_INFOEX, 0x0113),	// VFMADDSUB132PS
	/*0x03D2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03D9*/ MAKE_OPWORD(OC_INFOEX, 0x0114),	// VFMSUBADD132PS
	/*0x03DA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03DF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E1*/ MAKE_OPWORD(OC_INFOEX, 0x0115),	// VFMADD132PS
	/*0x03E2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03E9*/ MAKE_OPWORD(OC_INFOEX, 0x0116),	// VFMADD132SS
	/*0x03EA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03EB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03EC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03ED*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03EE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03EF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F1*/ MAKE_OPWORD(OC_INFOEX, 0x0117),	// VFMSUB132PS
	/*0x03F2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03F9*/ MAKE_OPWORD(OC_INFOEX, 0x0118),	// VFMSUB132SS
	/*0x03FA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03FB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03FC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03FD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03FE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x03FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0400*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0401*/ MAKE_OPWORD(OC_INFOEX, 0x0119),	// VFNMADD132PS
	/*0x0402*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0403*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0404*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0405*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0406*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0407*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0408*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0409*/ MAKE_OPWORD(OC_INFOEX, 0x011A),	// VFNMADD132SS
	/*0x040A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x040B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x040C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x040D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x040E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x040F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0410*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0411*/ MAKE_OPWORD(OC_INFOEX, 0x011B),	// VFNMSUB132PS
	/*0x0412*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0413*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0414*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0415*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0416*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0417*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0418*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0419*/ MAKE_OPWORD(OC_INFOEX, 0x011C),	// VFNMSUB132SS
	/*0x041A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x041B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x041C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x041D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x041E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x041F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0420*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0421*/ MAKE_OPWORD(OC_INFOEX, 0x011D),	// VFMADDSUB213PS
	/*0x0422*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0423*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0424*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0425*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0426*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0427*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0428*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0429*/ MAKE_OPWORD(OC_INFOEX, 0x011E),	// VFMSUBADD213PS
	/*0x042A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x042B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x042C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x042D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x042E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x042F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0430*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0431*/ MAKE_OPWORD(OC_INFOEX, 0x011F),	// VFMADD213PS
	/*0x0432*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0433*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0434*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0435*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0436*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0437*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0438*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0439*/ MAKE_OPWORD(OC_INFOEX, 0x0120),	// VFMADD213SS
	/*0x043A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x043B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x043C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x043D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x043E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x043F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0440*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0441*/ MAKE_OPWORD(OC_INFOEX, 0x0121),	// VFMSUB213PS
	/*0x0442*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0443*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0444*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0445*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0446*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0447*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0448*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0449*/ MAKE_OPWORD(OC_INFOEX, 0x0122),	// VFMSUB213SS
	/*0x044A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x044B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x044C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x044D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x044E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x044F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0450*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0451*/ MAKE_OPWORD(OC_INFOEX, 0x0123),	// VFNMADD213PS
	/*0x0452*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0453*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0454*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0455*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0456*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0457*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0458*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0459*/ MAKE_OPWORD(OC_INFOEX, 0x0124),	// VFNMADD213SS
	/*0x045A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x045B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x045C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x045D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x045E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x045F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0460*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0461*/ MAKE_OPWORD(OC_INFOEX, 0x0125),	// VFNMSUB213PS
	/*0x0462*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0463*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0464*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0465*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0466*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0467*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0468*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0469*/ MAKE_OPWORD(OC_INFOEX, 0x0126),	// VFNMSUB213SS
	/*0x046A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x046B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x046C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x046D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x046E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x046F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0470*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0471*/ MAKE_OPWORD(OC_INFOEX, 0x0127),	// VFMADDSUB231PS
	/*0x0472*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0473*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0474*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0475*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0476*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0477*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0478*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0479*/ MAKE_OPWORD(OC_INFOEX, 0x0128),	// VFMSUBADD231PS
	/*0x047A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x047B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x047C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x047D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x047E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x047F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0480*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0481*/ MAKE_OPWORD(OC_INFOEX, 0x0129),	// VFMADD231PS
	/*0x0482*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0483*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0484*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0485*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0486*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0487*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0488*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0489*/ MAKE_OPWORD(OC_INFOEX, 0x012A),	// VFMADD231SS
	/*0x048A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x048B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x048C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x048D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x048E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x048F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0490*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0491*/ MAKE_OPWORD(OC_INFOEX, 0x012B),	// VFMSUB231PS
	/*0x0492*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0493*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0494*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0495*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0496*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0497*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0498*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0499*/ MAKE_OPWORD(OC_INFOEX, 0x012C),	// VFMSUB231SS
	/*0x049A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x049B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x049C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x049D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x049E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x049F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A1*/ MAKE_OPWORD(OC_INFOEX, 0x012D),	// VFNMADD231PS
	/*0x04A2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04A9*/ MAKE_OPWORD(OC_INFOEX, 0x012E),	// VFNMADD231SS
	/*0x04AA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04AB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04AC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04AD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04AE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04AF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B1*/ MAKE_OPWORD(OC_INFOEX, 0x012F),	// VFNMSUB231PS
	/*0x04B2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04B9*/ MAKE_OPWORD(OC_INFOEX, 0x0130),	// VFNMSUB231SS
	/*0x04BA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04BB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04BC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04BD*/ MAKE_OPWORD(OC_INFO, 0x04B7),	// AESIMC
	/*0x04BE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04BF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C1*/ MAKE_OPWORD(OC_INFOEX, 0x0131),	// VAESIMC
	/*0x04C2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C5*/ MAKE_OPWORD(OC_INFO, 0x04B8),	// AESENC
	/*0x04C6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04C9*/ MAKE_OPWORD(OC_INFOEX, 0x0132),	// VAESENC
	/*0x04CA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04CB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04CC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04CD*/ MAKE_OPWORD(OC_INFO, 0x04B9),	// AESENCLAST
	/*0x04CE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04CF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04D0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04D1*/ MAKE_OPWORD(OC_INFOEX, 0x0133),	// VAESENCLAST
	/*0x04D2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04D3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04D4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04D5*/ MAKE_OPWORD(OC_INFO, 0x04BA),	// AESDEC
	/*0x04D6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04D7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04D8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04D9*/ MAKE_OPWORD(OC_INFOEX, 0x0134),	// VAESDEC
	/*0x04DA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04DB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04DC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04DD*/ MAKE_OPWORD(OC_INFO, 0x04BB),	// AESDECLAST
	/*0x04DE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04DF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04E0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04E1*/ MAKE_OPWORD(OC_INFOEX, 0x0135),	// VAESDECLAST
	/*0x04E2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04E3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04E4*/ MAKE_OPWORD(OC_INFO, 0x04BC),	// MOVBE
	/*0x04E5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04E6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04E7*/ MAKE_OPWORD(OC_INFO, 0x04BD),	// CRC32
	/*0x04E8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04E9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04EA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04EB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04EC*/ MAKE_OPWORD(OC_INFO, 0x04BE),	// MOVBE
	/*0x04ED*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04EE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04EF*/ MAKE_OPWORD(OC_INFO, 0x04BF),	// CRC32
	/*0x04F0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04F8*/ MAKE_OPWORD(OC_INFOEX, 0x0196),	// ANDN
	/*0x04F9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04FA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04FB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04FC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x04FD*/ MAKE_OPWORD(OC_INFOEX, 0x019F),	// BLSR
	/*0x04FE*/ MAKE_OPWORD(OC_INFOEX, 0x01A0),	// BLSMSK
	/*0x04FF*/ MAKE_OPWORD(OC_INFOEX, 0x01A1),	// BLSI
	/*0x0500*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0501*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0502*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0503*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0504*/ MAKE_OPWORD(OC_INFOEX, 0x0197),	// BZHI
	/*0x0505*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0506*/ MAKE_OPWORD(OC_INFOEX, 0x0199),	// PEXT
	/*0x0507*/ MAKE_OPWORD(OC_INFOEX, 0x019A),	// PDEP
	/*0x0508*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0509*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x050A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x050B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x050C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x050D*/ MAKE_OPWORD(OC_INFO, 0x04DC),	// ADCX
	/*0x050E*/ MAKE_OPWORD(OC_INFO, 0x04DD),	// ADOX
	/*0x050F*/ MAKE_OPWORD(OC_INFOEX, 0x019B),	// MULX
	/*0x0510*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0511*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0512*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0513*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0514*/ MAKE_OPWORD(OC_INFOEX, 0x0198),	// BEXTR
	/*0x0515*/ MAKE_OPWORD(OC_INFOEX, 0x019C),	// SHLX
	/*0x0516*/ MAKE_OPWORD(OC_INFOEX, 0x019D),	// SARX
	/*0x0517*/ MAKE_OPWORD(OC_INFOEX, 0x019E),	// SHRX
};

OPBYTE_INFO PEDisAsm::G_3B_3A_TBL[CTBL_LEN_3B_3A] =
{
	/*0x0000*/ MAKE_OPWORD(OC_WITHPF, 0x0100),	// 
	/*0x0001*/ MAKE_OPWORD(OC_WITHPF, 0x0108),	// 
	/*0x0002*/ MAKE_OPWORD(OC_WITHPF, 0x0110),	// 
	/*0x0003*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0004*/ MAKE_OPWORD(OC_WITHPF, 0x0118),	// 
	/*0x0005*/ MAKE_OPWORD(OC_WITHPF, 0x0120),	// 
	/*0x0006*/ MAKE_OPWORD(OC_WITHPF, 0x0128),	// 
	/*0x0007*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0008*/ MAKE_OPWORD(OC_WITHPF, 0x0130),	// 
	/*0x0009*/ MAKE_OPWORD(OC_WITHPF, 0x0138),	// 
	/*0x000A*/ MAKE_OPWORD(OC_WITHPF, 0x0140),	// 
	/*0x000B*/ MAKE_OPWORD(OC_WITHPF, 0x0148),	// 
	/*0x000C*/ MAKE_OPWORD(OC_WITHPF, 0x0150),	// 
	/*0x000D*/ MAKE_OPWORD(OC_WITHPF, 0x0158),	// 
	/*0x000E*/ MAKE_OPWORD(OC_WITHPF, 0x0160),	// 
	/*0x000F*/ MAKE_OPWORD(OC_WITHPF, 0x0168),	// 
	/*0x0010*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0011*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0012*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0013*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0014*/ MAKE_OPWORD(OC_WITHPF, 0x0170),	// 
	/*0x0015*/ MAKE_OPWORD(OC_WITHPF, 0x0178),	// 
	/*0x0016*/ MAKE_OPWORD(OC_WITHPF, 0x0180),	// 
	/*0x0017*/ MAKE_OPWORD(OC_WITHPF, 0x0188),	// 
	/*0x0018*/ MAKE_OPWORD(OC_WITHPF, 0x0190),	// 
	/*0x0019*/ MAKE_OPWORD(OC_WITHPF, 0x0198),	// 
	/*0x001A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001D*/ MAKE_OPWORD(OC_WITHPF, 0x01A0),	// 
	/*0x001E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0020*/ MAKE_OPWORD(OC_WITHPF, 0x01A8),	// 
	/*0x0021*/ MAKE_OPWORD(OC_WITHPF, 0x01B0),	// 
	/*0x0022*/ MAKE_OPWORD(OC_WITHPF, 0x01B8),	// 
	/*0x0023*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0024*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0025*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0026*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0027*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0028*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0029*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x002A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x002B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x002C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x002D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x002E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x002F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0030*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0031*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0032*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0033*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0034*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0035*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0036*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0037*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0038*/ MAKE_OPWORD(OC_WITHPF, 0x01C0),	// 
	/*0x0039*/ MAKE_OPWORD(OC_WITHPF, 0x01C8),	// 
	/*0x003A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0040*/ MAKE_OPWORD(OC_WITHPF, 0x01D0),	// 
	/*0x0041*/ MAKE_OPWORD(OC_WITHPF, 0x01D8),	// 
	/*0x0042*/ MAKE_OPWORD(OC_WITHPF, 0x01E0),	// 
	/*0x0043*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0044*/ MAKE_OPWORD(OC_WITHPF, 0x01E8),	// 
	/*0x0045*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0046*/ MAKE_OPWORD(OC_WITHPF, 0x01F0),	// 
	/*0x0047*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0048*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0049*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004A*/ MAKE_OPWORD(OC_WITHPF, 0x01F8),	// 
	/*0x004B*/ MAKE_OPWORD(OC_WITHPF, 0x0200),	// 
	/*0x004C*/ MAKE_OPWORD(OC_WITHPF, 0x0208),	// 
	/*0x004D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0050*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0051*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0052*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0053*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0054*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0055*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0056*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0057*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0058*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0059*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0060*/ MAKE_OPWORD(OC_WITHPF, 0x0210),	// 
	/*0x0061*/ MAKE_OPWORD(OC_WITHPF, 0x0218),	// 
	/*0x0062*/ MAKE_OPWORD(OC_WITHPF, 0x0220),	// 
	/*0x0063*/ MAKE_OPWORD(OC_WITHPF, 0x0228),	// 
	/*0x0064*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0065*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0066*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0067*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0068*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0069*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0070*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0071*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0072*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0073*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0074*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0075*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0076*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0077*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0078*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0079*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0080*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0081*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0082*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0083*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0084*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0085*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0086*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0087*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0088*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0089*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0090*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0091*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0092*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0093*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0094*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0095*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0096*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0097*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0098*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0099*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x009A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x009B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x009C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x009D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x009E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x009F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00AA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00AB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00AC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00AD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00AE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00AF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00BA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00BB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00BC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00BD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00BE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00BF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DF*/ MAKE_OPWORD(OC_WITHPF, 0x0230),	// 
	/*0x00E0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00ED*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F0*/ MAKE_OPWORD(OC_WITHPF, 0x0238),	// 
	/*0x00F1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0100*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0101*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0102*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0103*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0104*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0105*/ MAKE_OPWORD(OC_INFOEX, 0x017D),	// VPERMQ
	/*0x0106*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0107*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0108*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0109*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x010A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x010B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x010C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x010D*/ MAKE_OPWORD(OC_INFOEX, 0x017E),	// VPERMPD
	/*0x010E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x010F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0110*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0111*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0112*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0113*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0114*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0115*/ MAKE_OPWORD(OC_INFOEX, 0x017F),	// VPBLENDD
	/*0x0116*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0117*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0118*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0119*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011D*/ MAKE_OPWORD(OC_INFOEX, 0x0136),	// VPERMILPS
	/*0x011E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x011F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0120*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0121*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0122*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0123*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0124*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0125*/ MAKE_OPWORD(OC_INFOEX, 0x0137),	// VPERMILPD
	/*0x0126*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0127*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0128*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0129*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x012A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x012B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x012C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x012D*/ MAKE_OPWORD(OC_INFOEX, 0x0138),	// VPERM2F128
	/*0x012E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x012F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0130*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0131*/ MAKE_OPWORD(OC_INFOEX, 0x0139),	// ROUNDPS
	/*0x0132*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0133*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0134*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0135*/ MAKE_OPWORD(OC_INFOEX, 0x013A),	// VROUNDPS
	/*0x0136*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0137*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0138*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0139*/ MAKE_OPWORD(OC_INFOEX, 0x013B),	// ROUNDPD
	/*0x013A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013D*/ MAKE_OPWORD(OC_INFOEX, 0x013C),	// VROUNDPD
	/*0x013E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x013F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0140*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0141*/ MAKE_OPWORD(OC_INFOEX, 0x013D),	// ROUNDSS
	/*0x0142*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0143*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0144*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0145*/ MAKE_OPWORD(OC_INFOEX, 0x013E),	// VROUNDSS
	/*0x0146*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0147*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0148*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0149*/ MAKE_OPWORD(OC_INFOEX, 0x013F),	// ROUNDSD
	/*0x014A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x014B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x014C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x014D*/ MAKE_OPWORD(OC_INFOEX, 0x0140),	// VROUNDSD
	/*0x014E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x014F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0150*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0151*/ MAKE_OPWORD(OC_INFOEX, 0x0141),	// BLENDPS
	/*0x0152*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0153*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0154*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0155*/ MAKE_OPWORD(OC_INFOEX, 0x0142),	// VBLENDPS
	/*0x0156*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0157*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0158*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0159*/ MAKE_OPWORD(OC_INFOEX, 0x0143),	// BLENDPD
	/*0x015A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x015B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x015C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x015D*/ MAKE_OPWORD(OC_INFOEX, 0x0144),	// VBLENDPD
	/*0x015E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x015F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0160*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0161*/ MAKE_OPWORD(OC_INFOEX, 0x0145),	// PBLENDW
	/*0x0162*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0163*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0164*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0165*/ MAKE_OPWORD(OC_INFOEX, 0x0146),	// VPBLENDW
	/*0x0166*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0167*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0168*/ MAKE_OPWORD(OC_INFOEX, 0x0147),	// PALIGNR
	/*0x0169*/ MAKE_OPWORD(OC_INFOEX, 0x0148),	// PALIGNR
	/*0x016A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x016B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x016C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x016D*/ MAKE_OPWORD(OC_INFOEX, 0x0149),	// VPALIGNR
	/*0x016E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x016F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0170*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0171*/ MAKE_OPWORD(OC_INFOEX, 0x014A),	// PEXTRB
	/*0x0172*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0173*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0174*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0175*/ MAKE_OPWORD(OC_INFOEX, 0x014B),	// VPEXTRB
	/*0x0176*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0177*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0178*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0179*/ MAKE_OPWORD(OC_INFOEX, 0x014C),	// PEXTRW
	/*0x017A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x017B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x017C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x017D*/ MAKE_OPWORD(OC_INFOEX, 0x014D),	// VPEXTRW
	/*0x017E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x017F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0180*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0181*/ MAKE_OPWORD(OC_INFOEX, 0x014E),	// PEXTRD
	/*0x0182*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0183*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0184*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0185*/ MAKE_OPWORD(OC_INFOEX, 0x014F),	// VPEXTRD
	/*0x0186*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0187*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0188*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0189*/ MAKE_OPWORD(OC_INFOEX, 0x0150),	// EXTRACTPS
	/*0x018A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x018B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x018C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x018D*/ MAKE_OPWORD(OC_INFOEX, 0x0151),	// VEXTRACTPS
	/*0x018E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x018F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0190*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0191*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0192*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0193*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0194*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0195*/ MAKE_OPWORD(OC_INFOEX, 0x0152),	// VINSERTF128
	/*0x0196*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0197*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0198*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0199*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x019A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x019B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x019C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x019D*/ MAKE_OPWORD(OC_INFOEX, 0x0153),	// VEXTRACTF128
	/*0x019E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x019F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A5*/ MAKE_OPWORD(OC_INFOEX, 0x0181),	// VCVTPS2PH
	/*0x01A6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01A9*/ MAKE_OPWORD(OC_INFOEX, 0x0154),	// PINSRB
	/*0x01AA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01AB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01AC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01AD*/ MAKE_OPWORD(OC_INFOEX, 0x0155),	// VPINSRB
	/*0x01AE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01AF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B1*/ MAKE_OPWORD(OC_INFOEX, 0x0156),	// INSERTPS
	/*0x01B2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B5*/ MAKE_OPWORD(OC_INFOEX, 0x0157),	// VINSERTPS
	/*0x01B6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01B9*/ MAKE_OPWORD(OC_INFOEX, 0x0158),	// PINSRD
	/*0x01BA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01BB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01BC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01BD*/ MAKE_OPWORD(OC_INFOEX, 0x0159),	// VPINSRD
	/*0x01BE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01BF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C5*/ MAKE_OPWORD(OC_INFOEX, 0x0183),	// VINSERTI128
	/*0x01C6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01C9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CD*/ MAKE_OPWORD(OC_INFOEX, 0x0184),	// VEXTRACTI128
	/*0x01CE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01CF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D1*/ MAKE_OPWORD(OC_INFOEX, 0x015A),	// DPPS
	/*0x01D2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D5*/ MAKE_OPWORD(OC_INFOEX, 0x015B),	// VDPPS
	/*0x01D6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01D9*/ MAKE_OPWORD(OC_INFOEX, 0x015C),	// DPPD
	/*0x01DA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01DB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01DC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01DD*/ MAKE_OPWORD(OC_INFOEX, 0x015D),	// VDPPD
	/*0x01DE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01DF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E1*/ MAKE_OPWORD(OC_INFOEX, 0x015E),	// MPSADBW
	/*0x01E2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E5*/ MAKE_OPWORD(OC_INFOEX, 0x015F),	// VMPSADBW
	/*0x01E6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01E9*/ MAKE_OPWORD(OC_INFOEX, 0x0160),	// PCLMULQDQ
	/*0x01EA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01EB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01EC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01ED*/ MAKE_OPWORD(OC_INFOEX, 0x0161),	// VPCLMULQDQ
	/*0x01EE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01EF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F5*/ MAKE_OPWORD(OC_INFOEX, 0x0180),	// VPERM2I128
	/*0x01F6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01F9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FD*/ MAKE_OPWORD(OC_INFOEX, 0x0162),	// VBLENDVPS
	/*0x01FE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x01FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0200*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0201*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0202*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0203*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0204*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0205*/ MAKE_OPWORD(OC_INFOEX, 0x0163),	// VBLENDVPD
	/*0x0206*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0207*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0208*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0209*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x020A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x020B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x020C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x020D*/ MAKE_OPWORD(OC_INFOEX, 0x0164),	// VPBLENDVB
	/*0x020E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x020F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0210*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0211*/ MAKE_OPWORD(OC_INFOEX, 0x0165),	// PCMPESTRM
	/*0x0212*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0213*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0214*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0215*/ MAKE_OPWORD(OC_INFOEX, 0x0166),	// VPCMPESTRM
	/*0x0216*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0217*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0218*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0219*/ MAKE_OPWORD(OC_INFOEX, 0x0167),	// PCMPESTRI
	/*0x021A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x021B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x021C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x021D*/ MAKE_OPWORD(OC_INFOEX, 0x0168),	// VPCMPESTRI
	/*0x021E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x021F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0220*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0221*/ MAKE_OPWORD(OC_INFOEX, 0x0169),	// PCMPISTRM
	/*0x0222*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0223*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0224*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0225*/ MAKE_OPWORD(OC_INFOEX, 0x016A),	// VPCMPISTRM
	/*0x0226*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0227*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0228*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0229*/ MAKE_OPWORD(OC_INFOEX, 0x016B),	// PCMPISTRI
	/*0x022A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x022B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x022C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x022D*/ MAKE_OPWORD(OC_INFOEX, 0x016C),	// VPCMPISTRI
	/*0x022E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x022F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0230*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0231*/ MAKE_OPWORD(OC_INFOEX, 0x016D),	// AESKEYGENASSIST
	/*0x0232*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0233*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0234*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0235*/ MAKE_OPWORD(OC_INFOEX, 0x016E),	// VAESKEYGENASSIST
	/*0x0236*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0237*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0238*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0239*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x023A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x023B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x023C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x023D*/ MAKE_OPWORD(OC_NONE, 0x0100),	// 
	/*0x023E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x023F*/ MAKE_OPWORD(OC_INFOEX, 0x0195),	// RORX
};

OPBYTE_INFO PEDisAsm::G_3DNOW_TBL[CTBL_LEN_3DNOW] =
{
	/*0x0000*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0001*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0002*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0003*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0004*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0005*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0006*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0007*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0008*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0009*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x000A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x000B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x000C*/ MAKE_OPWORD(OC_INFO, 0x0357),	// PI2FW
	/*0x000D*/ MAKE_OPWORD(OC_INFO, 0x0358),	// PI2FD
	/*0x000E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x000F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0010*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0011*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0012*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0013*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0014*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0015*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0016*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0017*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0018*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0019*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001C*/ MAKE_OPWORD(OC_INFO, 0x0359),	// PF2IW
	/*0x001D*/ MAKE_OPWORD(OC_INFO, 0x035A),	// PF2ID
	/*0x001E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x001F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0020*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0021*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0022*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0023*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0024*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0025*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0026*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0027*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0028*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0029*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x002A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x002B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x002C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x002D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x002E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x002F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0030*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0031*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0032*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0033*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0034*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0035*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0036*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0037*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0038*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0039*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x003F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0040*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0041*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0042*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0043*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0044*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0045*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0046*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0047*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0048*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0049*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x004F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0050*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0051*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0052*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0053*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0054*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0055*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0056*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0057*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0058*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0059*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x005F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0060*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0061*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0062*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0063*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0064*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0065*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0066*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0067*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0068*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0069*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x006F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0070*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0071*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0072*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0073*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0074*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0075*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0076*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0077*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0078*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0079*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007A*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007E*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x007F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0080*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0081*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0082*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0083*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0084*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0085*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0086*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0087*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0088*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0089*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008A*/ MAKE_OPWORD(OC_INFO, 0x035B),	// PFNACC
	/*0x008B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x008E*/ MAKE_OPWORD(OC_INFO, 0x035C),	// PFPNACC
	/*0x008F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0090*/ MAKE_OPWORD(OC_INFO, 0x035D),	// PFCMPGE
	/*0x0091*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0092*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0093*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0094*/ MAKE_OPWORD(OC_INFO, 0x035E),	// PFMIN
	/*0x0095*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0096*/ MAKE_OPWORD(OC_INFO, 0x035F),	// PFRCP
	/*0x0097*/ MAKE_OPWORD(OC_INFO, 0x0360),	// PFRSQRT
	/*0x0098*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x0099*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x009A*/ MAKE_OPWORD(OC_INFO, 0x0361),	// PFSUB
	/*0x009B*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x009C*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x009D*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x009E*/ MAKE_OPWORD(OC_INFO, 0x0362),	// PFADD
	/*0x009F*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A0*/ MAKE_OPWORD(OC_INFO, 0x0363),	// PFCMPGT
	/*0x00A1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A4*/ MAKE_OPWORD(OC_INFO, 0x0364),	// PFMAX
	/*0x00A5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A6*/ MAKE_OPWORD(OC_INFO, 0x0365),	// PFRCPIT1
	/*0x00A7*/ MAKE_OPWORD(OC_INFO, 0x0366),	// PFRSQIT1
	/*0x00A8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00A9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00AA*/ MAKE_OPWORD(OC_INFO, 0x0367),	// PFSUBR
	/*0x00AB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00AC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00AD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00AE*/ MAKE_OPWORD(OC_INFO, 0x0368),	// PFACC
	/*0x00AF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B0*/ MAKE_OPWORD(OC_INFO, 0x0369),	// PFCMPEQ
	/*0x00B1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B4*/ MAKE_OPWORD(OC_INFO, 0x036A),	// PFMUL
	/*0x00B5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B6*/ MAKE_OPWORD(OC_INFO, 0x036B),	// PFRCPIT2
	/*0x00B7*/ MAKE_OPWORD(OC_INFO, 0x036C),	// PMULHRW
	/*0x00B8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00B9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00BA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00BB*/ MAKE_OPWORD(OC_INFO, 0x036D),	// PSWAPD
	/*0x00BC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00BD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00BE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00BF*/ MAKE_OPWORD(OC_INFO, 0x036E),	// PAVGUSB
	/*0x00C0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00C9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00CF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00D9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00DF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00E9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00ED*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00EF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F0*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F1*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F2*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F3*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F4*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F5*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F6*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F7*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F8*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00F9*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FA*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FB*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FC*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FD*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FE*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
	/*0x00FF*/ MAKE_OPWORD(OC_NONE, 0x0000),	// 
};
